#!/usr/bin/perl
#
# $Id: updateplugins.pl,v 1.16 2006/09/21 12:34:35 airwofl Exp $
#
################################################################################
#			      Last update: 09.10.2004			      #
#-----------------------------------------------------------------------------#
#				     Inprotect				      #
#-----------------------------------------------------------------------------#
# Copyright (C) 2002 - 2004 Inprotect.com				      #
#									      #
# This program is free software; you can redistribute it and/or modify it     #
# under the terms of version 2 of the GNU General Public License as published #
# by the Free Software Foundation.					      #
#									      #
# This program is distributed in the hope that it will be useful, but WITHOUT #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or       #
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for    #
# more details.								      #
#									      #
# You should have received a copy of the GNU General Public License along     #
# with this program; if not, write to the Free Software Foundation, Inc.,     #
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA			      #
#									      #
# Contact Information:							      #
# Alex Zimin (alex@inprotect.com)					      #
# http://www.inprotect.com						      #
###############################################################################
# See the README.txt and/or help files for more information on how to use &   #
# configuration.							      #
# See the LICENSE.txt file for more information on the License this software  #
# is distributed under.							      #
#									      #
# This program is intended for use in an authorized manner only, and the      #
# author can not be held liable for anything done with this program, code, or #
# items discovered with this program's use.				      #
###############################################################################

use DBI;

use vars qw/%CONFIG/;

&load_configs;

#Redirect output to the log file
my $updatepluginslog = "$CONFIG{'UPDATEPLUGINSLOG'}";
my $updateplugins="$CONFIG{'UPDATEPLUGINSTABLE'}";
open(LOG,">>$updatepluginslog") or die "Failed to create $updatepluginslog: $!\n";
*STDERR=*LOG;
*STDOUT=*LOG;

my($nessususer, $nessuspassw, $nessussvr, $nessusport, $nessusdb, $nessustable, $tempfile, $sid, $sautoenable, $status, $statusvalue, $serverid);

#Update these variables:
$serverid = "$CONFIG{'SERVERID'}";			#Nessus server id 
$nessustable = "nessus_plugins";			#Final table with Nessus plugins
$dbusername = "$CONFIG{'DATABASEUSER'}"; 		#Username to connect to database
$dbpass = "$CONFIG{'DATABASEPASSWORD'}";		#Password to connect to database
$dbdsn = "$CONFIG{'DATABASEDSN'}";			#Database DSN
$tempfile = "$CONFIG{'OUTDIR'}/plugins.sql";		#Temp Nessus plugins file

my ($risk, $dbh, $sth_ins, $sth_upd, $sth_sel2, $sth_sel3, $sth_selc, $sth_self, $sth_insc, $sth_insf, $catid, $setid, $plugincount, $pid, $pname, $pfamily, $pcategory, $pcopyright, $psummary, $pdescription, $pversion, $pcve_id,$pluginversion, $pbugtraq_id);

my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst);
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

$year+=1900;
my $now;
$mon++;
if ($mon<10){ $mon="0".$mon;};
if ($mday<10) { $mday="0".$mday;};
if ($hour<10){ $hour="0".$hour;};
if ($min<10){ $min="0".$min;};
if ($sec<10){ $sec="0".$sec;}; $now=$year.$mon.$mday.$hour.$min.$sec;

main();
print localtime(time)." updateplugins: Closing script\n";
close LOG;
exit(0);

sub main {

	#Establish db connection
	$dbh=conn_db();

	#Select server attributes
	$sth = $dbh->prepare(qq{
		SELECT hostname, port, user, password
		FROM nessus_servers
		WHERE id=$serverid
		} );
	$sth->execute;
	($nessussvr, $nessusport, $nessususer, $nessuspassw)=$sth->fetchrow_array;

	#Select Nessus plugins download location
	$sth = $dbh->prepare(qq{
		SELECT settingValue
		FROM inprotect_settings
      WHERE settingName = 'inprotect_url'
		} );
	$sth->execute;
	my($inprotect_url)=$sth->fetchrow_array;

	print localtime(time)." updateplugins: executing nessus-update-plugins\n";
	#execute nessus-update-plugins
	system ("/opt/nessus/sbin/nessus-update-plugins") == 0 or print localtime(time)." updateplugins: No new plugins installed\n";
	#If used patch for nessus-update-plugins, we may pass parameter on the command line.
	#system ("nessus-update-plugins.141 -u $inprotect_url/nessus") == 0 or die localtime(time)." updateplugins: No new plugins installed";

	print localtime(time)." updateplugins: sleeping for 120sec to allow nessus to restart\n";
	#Sleep 300 sec, allow nessusd to restart
	sleep 300;

	if ($updateplugins==1) {

		print localtime(time)." updateplugins: Getting plugin dump from nessusd\n";
		#Dump Nessus plugins info into a file
		system("$CONFIG{'NESSUSPATH'} -xpS -q $nessussvr $nessusport $nessususer $nessuspassw > $tempfile");

		print localtime(time)." updateplugins: Connecting to DB and updating plugins\n";
		#Insert Nessus plugins info into db
		system ("mysql --force --user=$CONFIG{'DATABASEUSER'} --password=$CONFIG{'DATABASEPASSWORD'} --host=$CONFIG{'DATABASEHOST'} $CONFIG{'DATABASENAME'} < $tempfile");

		#Delete temporary file
		unlink $tempfile if -e $tempfile;

		## Updating family and category tables
        #--------- NOTES ----------------
        # not sure why we do this without checking the autoenable settings
        # for the scan profile (sid) as this will just set up all new
        # families and categories to be auto-enabled for any sid
        # that has other families or categories auto-enabled.
        # - need to check with the code in sched.php to understand
        #   how the autoenable settings are managed and make sure that they
        #   are doing the right thing there
        #
        # so, I changed it.  We only add the new family or category
        # if the sid is set to autoenable by "F"amily or "C"ategory.
        # This still leaves the issue of setting it to "Enable All" when we
        # can't be certain that this is what the user really wants.
        # I'll look to adding a new flag (or flags) to the sid to allow the
        # user/admin to control what to do with new plugins/families/categories

        # prepare some queries for the while() loop
		$sth_ins=$dbh->prepare(qq{
			insert into nessus_category (name) values(?)
			} );
		$sth_selc=$dbh->prepare(qq{
			select id from nessus_category
			where name=?
			} );

        # get all new categories as a result of the latest plugin update
		$sth_sel = $dbh->prepare(q{
			select distinct plugins.category
			from plugins 
            left join nessus_category on plugins.category = nessus_category.name
			where nessus_category.id is null
			order by category
			} );
		$sth_sel->execute;

        # loop through them and add them to the DB
		while (my ($categoryname) = $sth_sel->fetchrow_array ) {
			$sth_ins->execute($categoryname);

            # get the id of the new entry
			$sth_selc->execute($categoryname);
			($catid)=$sth_selc->fetchrow_array;

            # prep the query to insert the new category id (cid)
		    $sth_insc=$dbh->prepare(qq{
			   insert into nessus_settings_category (sid, cid, status)
			   values (?, ?, ?)
			   } );
            # get the scan profile ids that are set to autoenable by category
			my $sth_selc2=$dbh->prepare(qq{
				select distinct id, auto_cat_status
                from nessus_settings
                where autoenable = 'C'
				} );
			$sth_selc2->execute;
            my $acs;
			while (($setid,$acs) =$sth_selc2->fetchrow_array ) {
                # create a new entry for this category and set it to 
                # auto_cat_status (defaults to Disable All, status=4)
				$sth_insc->execute($setid, $catid, $acs);
			}
		   $sth_insc->finish();
		   $sth_selc2->finish();
		}
		$sth_ins->finish();
		$sth_selc->finish();

        # prepare some queries for the while() loop
		$sth_ins=$dbh->prepare(qq{
			insert into nessus_family (name) values(?)
			} );
		$sth_self=$dbh->prepare(qq{
			select id 
            from nessus_family
			where name=?
			} );

        # get all sids that have a family associated with them
		$sth_sel = $dbh->prepare(q{
			select distinct plugins.family
			from plugins 
            left join nessus_family on plugins.family = nessus_family.name
			where nessus_family.id is null
			order by family
			} );
		$sth_sel->execute;

		while (my ($familyname) = $sth_sel->fetchrow_array ) {
			$sth_ins->execute($familyname);

            # get the id of the new entry
			$sth_self->execute($familyname);
			($famid)=$sth_self->fetchrow_array;

            # prep the query to create the new entry in the DB
			$sth_insf=$dbh->prepare(qq{
				insert into nessus_settings_family (sid, fid, status)
				values (?, ?, ?)
				} );
            # get the scan profile ids (sid) that have autoenable set to "F"
			my $sth_self2=$dbh->prepare(qq{
				select id, auto_fam_status
                from nessus_settings
                where autoenable = 'F'
				} );
			$sth_self2->execute;
            my $afs;
			while (($setid, $afs) =$sth_self2->fetchrow_array ) {
                # create a new entry for this family and set it to
                # Enable All (status = 1)
				$sth_insf->execute($setid,$famid, $afs);
			}
			$sth_insf->finish();
			$sth_self2->finish();
		}
		$sth_self->finish();
		$sth_ins->finish();


        # prepare a bunch of queries for use in the while() loop that
        # iterates over all the plugins in the DB to make execution
        # faster inside the loop
        # check to see if this plugin already exists in $nessustable
		$sth_psel2 = $dbh->prepare(qq{
				SELECT count(*)
				FROM $nessustable
				WHERE id=?
			} );
        # get the plugin details (incl family and category info)
		$sth_psel3 = $dbh->prepare(qq{
				SELECT t1.id, t1.name, t2.id, t3.id, t1.copyright, 
                       t1.summary, t1.description, t1.version, t1.cve_id, 
                       t1.bugtraq_id
				FROM plugins as t1, nessus_family as t2, nessus_category as t3
				WHERE t1.id=? 
                   and t1.family = t2.name 
                   and t1.category=t3.name
				});
        # insert the plugin into $nessustable
		$sth_pins = $dbh->prepare("
				INSERT into $nessustable
				VALUES (?, 'Y', ?, ?, null, null, ?,? ,?)
				");
        # check the version on the plugin in $nessustable
		$sth_psel6 = $dbh->prepare(qq{
				SELECT version
				FROM $nessustable
				WHERE id=?
				} );
        # update the info for a plugin that is already in $nessustable
		$sth_pins6 = $dbh->prepare("
				UPDATE $nessustable
				set version=?, modified=? where id=?
				");
        # get the category status
		$sth_isel3=$dbh->prepare(qq{
				select status 
                from nessus_settings_category
				where sid=? and cid=?
				} );
        # get the family status
		$sth_isel4=$dbh->prepare(qq{
				select status 
                from nessus_settings_family
				where sid=? and fid=?
				} );
        # populate the plugins settings table
		$sth_iins2=$dbh->prepare(qq{
				insert into nessus_settings_plugins
				values (?,?,?,?,?)
				} );

		#Select all plugin ids from the database
		$sth_sel = $dbh->prepare(q{
			SELECT id
			FROM plugins
			} );
		$sth_sel->execute;

        # loop through them and enable any in profiles that are configured
        # for autoenable (by family or category)
		while ( my ($id) = $sth_sel->fetchrow_array ) {

            # get the plugin information (details, family, category)
			$sth_psel3->execute($id);

			($pid, $pname, $pfamily, $pcategory, $pcopyright, 
             $psummary, $pdescription, $pversion, $pcve_id, 
             $pbugtraq_id) = $sth_psel3->fetchrow_array;

            # see if this plugin already exists in the DB and add it if
            # it doesn't
			$sth_psel2->execute($id);
			($plugincount)= $sth_psel2->fetchrow_array;
			if ($plugincount==0) {
				#INSERT new plugins into db

				$risk=7;
                $risk=1 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Serious/s);
                $risk=1 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Critical/s);
                $risk=2 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*High/s);
                $risk=3 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Medium/s);
                $risk=4 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Medium\/Low/s);
                $risk=5 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Low\/Medium/s);
                $risk=6 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Low/s);
                $risk=7 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Info/s);
                $risk=7 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*[nN]one/s);

                # insert it into the nessus_plugins table
				$sth_pins->execute($pid,$pversion,$now,$pcategory,$pfamily,$risk) or warn("Error inserting new plugin into $nessustable: $DBI::errstr\n");

                # get the list of scan profiles so we can update them
				$sth_isel = $dbh->prepare(qq{
					select id, autoenable 
                    from nessus_settings
					} );
				$sth_isel->execute;

                # loop through the scan profiles
				while (($sid, $sautoenable)=$sth_isel->fetchrow_array) {
					$statusvalue="Y";
                    # check to see if the profile is configured to
                    # autoenable by family or category
					if ($sautoenable eq "C") {
                        # check to see if the category is set to
                        # "Disable New"(3) or "Disable All" (4) 
						$sth_isel3->execute($sid,$pcategory);
						($status)=$sth_isel3->fetchrow_array;
						if ($status ==3 or $status==4) {
							$statusvalue="N";
						}
					} elsif ($sautoenable eq "F") {
                        # check to see if the family is set to
                        # "Disable New"(3) or "Disable All" (4) 
						$sth_isel4->execute($sid,$pfamily);
						($status)=$sth_isel4->fetchrow_array;
						if ($status ==3 or $status==4) {
							$statusvalue="N";
						}
					} else {
                        # nope, this profile isn't set to autoenable plugins,
                        # so set this plugin to be disabled
                        $statusvalue = "N";
                    }
					$sth_iins2->execute($pid,$sid,$statusvalue,$pcategory,$pfamily);
				}
            $sth_isel->finish();
			} else {
			   #Update changed plugins info in the db
				$sth_psel6->execute($id);
				($pluginversion) = $sth_psel6->fetchrow_array;
				if ($pluginversion ne $pversion) {
					$sth_pins6->execute($pversion,$now,$id);
				}
			}
		}
		$sth_psel2->finish();
		$sth_psel3->finish();
		$sth_psel6->finish();
		$sth_pins6->finish();
		$sth_pins->finish();
		$sth_isel3->finish();
		$sth_isel4->finish();
		$sth_iins2->finish();

        # prepare some queries for the while() loop to speed execution
		$sth_sel2 = $dbh->prepare(qq{
				SELECT count(*)
				FROM plugins
				WHERE id=?
			} );
		$sth_upd = $dbh->prepare("
				UPDATE $nessustable
				set enabled='N', deleted=? where id=?
				");
		$sth_del = $dbh->prepare(qq{
					DELETE
					FROM nessus_settings_plugins
					WHERE id=?
					});

		#Mark obsolete plugins deleted
		$sth_sel = $dbh->prepare(qq{
			SELECT id
			FROM $nessustable
			WHERE deleted is null
			} );
		$sth_sel->execute;
        # loop through all plugins that aren't already deleted
		while ( ($id) = $sth_sel->fetchrow_array ) {
			$sth_sel2->execute($id);
			($plugincount)= $sth_sel2->fetchrow_array;
            # if plugin still isn't in plugins table, set it to deleted
            # in nessus_plugins and remove it from the profiles.
			if ($plugincount==0) {
				$sth_upd->execute($now,$id);
				$sth_del->execute($id);
			}
		}
		$sth_sel2->finish();
		$sth_upd->finish();
		$sth_del->finish();

        # prepare some queries for execution in the while() loop
		$sth_sel2=$dbh->prepare(qq{
				select description
				from plugins
				where id=?
				});
		$sth_upd=$dbh->prepare(qq{
				update nessus_plugins set risk=?
				where id=?
				});

		#Updating risk level info
		$sth_sel = $dbh->prepare (q{
			select id
			from nessus_plugins
			where risk=0
			});
		$sth_sel->execute;
		while (my ($pluginid) = $sth_sel->fetchrow_array ) {
			$sth_sel2->execute($pluginid);
			$pdescription=$sth_sel2->fetchrow_array;

			$risk=7;
            $risk=1 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Serious/s);
            $risk=1 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Critical/s);
            $risk=2 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*High/s);
            $risk=3 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Medium/s);
            $risk=4 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Medium\/Low/s);
            $risk=5 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Low\/Medium/s);
            $risk=6 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Low/s);
            $risk=7 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*Info/s);
            $risk=7 if ($pdescription =~ m/Risk [fF]actor\s*:\s*(\\n)*[nN]one/s);
			$sth_upd->execute($risk,$pluginid);
		}

		$sth_sel2->finish();
		$sth_upd->finish();
		$sth_sel->finish();

		# Now need to run updateprefs.pl as prefs can change during an update
		system ("/usr/bin/updateprefs.pl");
	} #end of if - do not update database

	# Cleanup statement handles
	#$sth_sel2->finish();
	#$sth_sel3->finish();
	$sth->finish();

	disconn_db($dbh);

	#end of main
}

sub conn_db {
	my($dbh);
	$dbh = DBI->connect("$CONFIG{'DATABASEDSN'}:$CONFIG{'DATABASENAME'}:$CONFIG{'DATABASEHOST'}","$CONFIG{'DATABASEUSER'}","$CONFIG{'DATABASEPASSWORD'}", {
	PrintError => 0,
	RaiseError => 1,
	AutoCommit => 1 } ) or die("Failed to connect : $DBI::errstr\n");
	return $dbh;
}

sub disconn_db {
	my ($dbh) = @_;
	$dbh->disconnect or die "Failed to disconnect : $DBI::errstr\n";
}

sub load_configs
{
	my $configfile="/etc/inprotect/inprotect.cfg";
	my $noconfig=0;
	open(CONF,"<$configfile") || $noconfig++;
	my @CONFILE=<CONF>;
	close(CONF);

	if ($noconfig) { print localtime(time)." updateplugins: No inprotect.cfg file found.\n"; }

	foreach my $line (@CONFILE)
	{
		$line =~ s/\#.*$//;
		chomp($line);
		$line =~ s/\s+$//;
		$line =~ s/^\s+//;
		if ($line eq "") { next; }
		my @temp=split(/=/,$line,2);
		if ($temp[0] ne "") { $CONFIG{$temp[0]}=$temp[1]; }
	}
	return;
}
