-- MySQL dump 10.11
--
-- Host: localhost    Database: inprotect
-- ------------------------------------------------------
-- Server version	5.0.32-Debian_7etch1-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `inprotect_settings`
--

DROP TABLE IF EXISTS `inprotect_settings`;
CREATE TABLE `inprotect_settings` (
  `nessus_plugins_url` varchar(255) NOT NULL default '',
  `nessus_plugins_file` varchar(255) NOT NULL default '',
  `nessus_plugins_md5` varchar(255) NOT NULL default '',
  `nessus_plugins_sig` varchar(255) NOT NULL default '',
  `nessus_install_url` varchar(255) NOT NULL default '',
  `nessus_install_file` varchar(255) NOT NULL default '',
  `mailfrom` varchar(255) NOT NULL default '',
  `inprotect_url` varchar(255) NOT NULL default '',
  `inprotect_path` varchar(255) NOT NULL default '',
  `version` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `log`
--

DROP TABLE IF EXISTS `log`;
CREATE TABLE `log` (
  `id` int(11) NOT NULL auto_increment,
  `date_time` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `ip` varchar(15) NOT NULL default '',
  `username` varchar(255) character set latin1 collate latin1_bin default NULL,
  `action` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=71 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_category`
--

DROP TABLE IF EXISTS `nessus_category`;
CREATE TABLE `nessus_category` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `nname` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=12 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_family`
--

DROP TABLE IF EXISTS `nessus_family`;
CREATE TABLE `nessus_family` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `nname` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=47 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_hosts`
--

DROP TABLE IF EXISTS `nessus_hosts`;
CREATE TABLE `nessus_hosts` (
  `id` int(11) NOT NULL auto_increment,
  `sched_id` int(11) NOT NULL default '0',
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `hostip` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1578 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_live_stats`
--

DROP TABLE IF EXISTS `nessus_live_stats`;
CREATE TABLE `nessus_live_stats` (
  `sid` int(11) NOT NULL default '0',
  `host` varchar(255) NOT NULL default '',
  `action` varchar(255) NOT NULL default '',
  `percent` double NOT NULL default '0',
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_notes`
--

DROP TABLE IF EXISTS `nessus_notes`;
CREATE TABLE `nessus_notes` (
  `id` int(11) NOT NULL auto_increment,
  `pid` int(11) NOT NULL default '0',
  `resid` int(11) NOT NULL default '0',
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `note` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=12 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_plugins`
--

DROP TABLE IF EXISTS `nessus_plugins`;
CREATE TABLE `nessus_plugins` (
  `id` int(11) NOT NULL default '0',
  `enabled` char(1) NOT NULL default '',
  `version` varchar(255) default NULL,
  `created` varchar(14) default NULL,
  `modified` varchar(14) default NULL,
  `deleted` varchar(14) default NULL,
  `category` int(11) NOT NULL default '0',
  `family` int(11) NOT NULL default '0',
  `risk` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_preferences`
--

DROP TABLE IF EXISTS `nessus_preferences`;
CREATE TABLE `nessus_preferences` (
  `id` varchar(255) default NULL,
  `nessus_id` varchar(255) NOT NULL default '',
  `value` varchar(255) default NULL,
  `category` varchar(255) default NULL,
  `type` char(1) NOT NULL default '',
  PRIMARY KEY  (`nessus_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_preferences_defaults`
--

DROP TABLE IF EXISTS `nessus_preferences_defaults`;
CREATE TABLE `nessus_preferences_defaults` (
  `nessus_id` varchar(255) NOT NULL default '',
  `nessusgroup` varchar(255) default NULL,
  `type` varchar(255) default NULL,
  `field` varchar(255) default NULL,
  `value` varchar(255) default NULL,
  `category` varchar(255) default NULL,
  `flag` char(1) default NULL,
  PRIMARY KEY  (`nessus_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_results`
--

DROP TABLE IF EXISTS `nessus_results`;
CREATE TABLE `nessus_results` (
  `username` varchar(255) character set latin1 collate latin1_bin default NULL,
  `sched_id` int(11) default NULL,
  `sid` int(11) default NULL,
  `scantime` varchar(14) default NULL,
  `scantype` char(1) NOT NULL default 'M',
  `result_id` int(11) NOT NULL auto_increment,
  `domain` varchar(255) NOT NULL,
  `host` varchar(40) NOT NULL,
  `service` varchar(40) NOT NULL,
  `scriptid` varchar(40) NOT NULL,
  `risk` enum('1','2','3','4','5','6','7') NOT NULL,
  `msg` text,
  `falsepositive` enum('Y','N') default 'N',
  PRIMARY KEY  (`result_id`),
  KEY `host` (`host`),
  KEY `sched_id` (`sched_id`),
  KEY `service` (`service`),
  KEY `risk` (`risk`)
) ENGINE=MyISAM AUTO_INCREMENT=69863 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_scan`
--

DROP TABLE IF EXISTS `nessus_scan`;
CREATE TABLE `nessus_scan` (
  `sched_id` int(11) NOT NULL default '0',
  `host` varchar(255) NOT NULL default '',
  `status` char(1) NOT NULL default '',
  `server_id` int(11) NOT NULL default '0',
  `start_dttm` datetime default NULL,
  `end_dttm` datetime default NULL,
  `submit_dttm` datetime default NULL,
  `process_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`sched_id`,`host`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_schedule`
--

DROP TABLE IF EXISTS `nessus_schedule`;
CREATE TABLE `nessus_schedule` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `schedule_type` char(1) NOT NULL default 'H',
  `day_of_week` int(1) unsigned NOT NULL default '0',
  `day_of_month` int(2) unsigned NOT NULL default '1',
  `time` time NOT NULL default '00:00:00',
  `next_scan` varchar(14) default NULL,
  `status` char(1) default NULL,
  `email` varchar(100) NOT NULL default '',
  `sid` int(11) NOT NULL default '0',
  `timeout` int(11) default '172800',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=57 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_server_zones`
--

DROP TABLE IF EXISTS `nessus_server_zones`;
CREATE TABLE `nessus_server_zones` (
  `zoneid` int(11) NOT NULL default '0',
  `nessusid` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_servers`
--

DROP TABLE IF EXISTS `nessus_servers`;
CREATE TABLE `nessus_servers` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `hostname` varchar(255) NOT NULL default '',
  `port` int(11) NOT NULL default '1241',
  `user` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `PASSWORD` varchar(255) NOT NULL default '',
  `max_scans` int(11) NOT NULL default '10',
  `current_scans` int(11) NOT NULL default '0',
  `TYPE` char(1) NOT NULL default '',
  `owner` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `checkin_time` datetime default NULL,
  `status` char(1) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_settings`
--

DROP TABLE IF EXISTS `nessus_settings`;
CREATE TABLE `nessus_settings` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` varchar(255) default NULL,
  `autoenable` char(1) NOT NULL default 'N',
  `type` char(1) NOT NULL default 'G',
  `owner` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_settings_category`
--

DROP TABLE IF EXISTS `nessus_settings_category`;
CREATE TABLE `nessus_settings_category` (
  `sid` int(11) NOT NULL default '0',
  `cid` int(11) NOT NULL default '0',
  `status` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_settings_family`
--

DROP TABLE IF EXISTS `nessus_settings_family`;
CREATE TABLE `nessus_settings_family` (
  `sid` int(11) NOT NULL default '0',
  `fid` int(11) NOT NULL default '0',
  `status` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_settings_plugins`
--

DROP TABLE IF EXISTS `nessus_settings_plugins`;
CREATE TABLE `nessus_settings_plugins` (
  `id` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `enabled` char(1) NOT NULL default 'Y',
  `category` int(11) NOT NULL default '0',
  `family` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_settings_preferences`
--

DROP TABLE IF EXISTS `nessus_settings_preferences`;
CREATE TABLE `nessus_settings_preferences` (
  `sid` int(11) NOT NULL default '0',
  `id` varchar(255) default NULL,
  `nessus_id` varchar(255) NOT NULL default '',
  `value` varchar(255) default NULL,
  `category` varchar(255) default NULL,
  `type` char(1) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_settings_users`
--

DROP TABLE IF EXISTS `nessus_settings_users`;
CREATE TABLE `nessus_settings_users` (
  `id` int(11) NOT NULL auto_increment,
  `sid` int(11) NOT NULL default '0',
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=12 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_user_zones`
--

DROP TABLE IF EXISTS `nessus_user_zones`;
CREATE TABLE `nessus_user_zones` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `zid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=41 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_zone_ranges`
--

DROP TABLE IF EXISTS `nessus_zone_ranges`;
CREATE TABLE `nessus_zone_ranges` (
  `id` int(11) NOT NULL auto_increment,
  `zoneid` int(11) NOT NULL default '0',
  `range_start` int(11) unsigned NOT NULL default '0',
  `range_end` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=36 DEFAULT CHARSET=latin1;

--
-- Table structure for table `nessus_zones`
--

DROP TABLE IF EXISTS `nessus_zones`;
CREATE TABLE `nessus_zones` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `TYPE` char(1) NOT NULL default '',
  `owner` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=12 DEFAULT CHARSET=latin1;

--
-- Table structure for table `plugins`
--

DROP TABLE IF EXISTS `plugins`;
CREATE TABLE `plugins` (
  `id` int(11) NOT NULL default '0',
  `name` varchar(255) default NULL,
  `family` varchar(255) default NULL,
  `category` varchar(255) default NULL,
  `copyright` varchar(255) default NULL,
  `summary` varchar(255) default NULL,
  `description` blob,
  `version` varchar(255) default NULL,
  `cve_id` varchar(255) default NULL,
  `bugtraq_id` varchar(255) default NULL,
  `xref` blob,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `portscan`
--

DROP TABLE IF EXISTS `portscan`;
CREATE TABLE `portscan` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `userip` varchar(15) NOT NULL default '',
  `submittime` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `scanip` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `ports` char(1) NOT NULL default 'T',
  `portstart` smallint(5) unsigned default NULL,
  `portend` smallint(5) unsigned default NULL,
  `common` char(1) NOT NULL default 'Y',
  `scancomplete` char(1) NOT NULL default 'N',
  `options` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;

--
-- Table structure for table `portscan_os`
--

DROP TABLE IF EXISTS `portscan_os`;
CREATE TABLE `portscan_os` (
  `id` int(11) NOT NULL default '0',
  `host` varchar(15) default NULL,
  `os` varchar(255) default NULL,
  `details` varchar(255) default NULL,
  `devtype` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `portscan_results`
--

DROP TABLE IF EXISTS `portscan_results`;
CREATE TABLE `portscan_results` (
  `id` int(11) NOT NULL default '0',
  `host` varchar(15) default NULL,
  `port` int(11) NOT NULL default '0',
  `type` char(3) NOT NULL default '',
  `status` varchar(8) NOT NULL default '',
  `description` varchar(40) default NULL,
  `version` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `risk_level`
--

DROP TABLE IF EXISTS `risk_level`;
CREATE TABLE `risk_level` (
  `id` int(11) NOT NULL default '0',
  `description` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `pn_uname` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `pn_email` varchar(60) NOT NULL default '',
  `pn_pass` varchar(40) NOT NULL default '',
  `admin` char(1) NOT NULL default 'N',
  `profile` char(1) NOT NULL default 'N',
  `zones` char(1) NOT NULL default 'Y',
  `nmap` char(1) NOT NULL default 'Y',
  `nessus` char(1) NOT NULL default 'Y',
  `reports` char(1) NOT NULL default 'Y',
  `expire` varchar(8) default NULL,
  `locked` int(11) NOT NULL default '0',
  `created` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastaccessed` datetime NOT NULL default '0000-00-00 00:00:00',
  `owniponly` char(1) NOT NULL default 'N',
  `sc_now` char(1) NOT NULL default 'N',
  `sc_once` char(1) NOT NULL default 'N',
  `sc_daily` char(1) NOT NULL default 'N',
  `sc_weekly` char(1) NOT NULL default 'N',
  `sc_monthly` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`pn_uname`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2007-07-25 13:59:57
