use inprotect;

--
-- Up the default scan timeout limit to 48 hours for users scanning lots
-- of addresses.
--

alter table `nessus_schedule` alter column timeout set default 172800;

--
-- Change all instances of a username variable to become case sensitive
-- Resolves case sensitivity issues on reporting when using LIKE SQL
-- statements.
--

alter table log modify username varchar(255) binary;
alter table nessus_hosts modify username varchar(255) binary not null;
alter table nessus_live_stats modify username varchar(255) binary not null;
alter table nessus_notes modify username varchar(255) binary not null;
alter table nessus_results modify username varchar(255) binary;
alter table nessus_schedule modify username varchar(255) binary not null;
alter table nessus_servers modify owner varchar(255) binary not null;
alter table nessus_servers modify user varchar(255) binary not null;
alter table nessus_settings modify owner varchar(255) binary not null;
alter table nessus_settings_users modify username varchar(255) binary not null;
alter table nessus_user_zones modify username varchar(255) binary not null;
alter table nessus_zones modify owner varchar(255) binary not null;
alter table portscan modify username varchar(255) binary not null;
alter table users modify pn_uname varchar(255) binary not null;

--
-- Finally change the version information in the DB.
--

update `inprotect_settings`
set version = "0.22.3";
