DROP TABLE IF EXISTS `exceptions`;
CREATE TABLE `exceptions` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `eid` varchar(25) NOT NULL,
  `submitDate` datetime default NULL,
  `lastModified` datetime default NULL,
  `closeDate` datetime default NULL,
  `submitter` varchar(20) NOT NULL,
  `lastEditor` varchar(20) NOT NULL,
  `approver` varchar(20) default NULL,
  `status` varchar(25) NOT NULL,
  `plugin` int(10) unsigned NOT NULL default '0',
  `type` varchar(25) NOT NULL,
  `application` varchar(45) default NULL,
  `os` varchar(45) NOT NULL default '',
  `justification` text NOT NULL,
  `comments` text,
  `evidence` blob,
  `secRqmts` text,
  `ip` varchar(100) NOT NULL default '',
  `hostname` varchar(255) default NULL,
  `port` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `eid` (`eid`),
  KEY `ip` (`ip`),
  KEY `hostname` (`hostname`),
  KEY `plugin` (`plugin`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Vulnerability Exceptions';

--
-- Table structure for table `hosts`
--

DROP TABLE IF EXISTS `hosts`;
CREATE TABLE `hosts` (
  `id` int(11) NOT NULL auto_increment,
  `ip` varchar(45) NOT NULL default '',
  `hostname` varchar(45) NOT NULL default '',
  `description` varchar(200) NOT NULL default '',
  `status` varchar(45) NOT NULL default '',
  `os` varchar(45) NOT NULL default '',
  `contact` varchar(45) NOT NULL default '',
  `scanstate` varchar(25) default NULL,
  `lastscandate` datetime default NULL,
  `createdate` DATETIME NULL,
  `updatedate` DATETIME NULL,
  PRIMARY KEY  (`id`),
  KEY `ip` (`ip`),
  KEY `status` (`status`, `scanstate`)
) ENGINE=MyISAM;


-- 
-- Table structure for table `scan_requests`
-- 

DROP TABLE IF EXISTS `scan_requests`;
CREATE TABLE `scan_requests` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `serverHostname` varchar(50) NOT NULL,
  `serverIP` varchar(15) NOT NULL,
  `serverLocation` varchar(15) NOT NULL,
  `serverNetwork` varchar(25) NOT NULL,
  `serverState` varchar(25) NOT NULL,
  `desiredScanDate` datetime NOT NULL,
  `closeDate` datetime NOT NULL,
  `submitDate` datetime NOT NULL,
  `updateDate` datetime NOT NULL,
  `changeControl` int(10) unsigned NOT NULL,
  `schedID` int(10) unsigned NOT NULL,
  `requestStatus` varchar(15) NOT NULL,
  `requestorID` varchar(50) NOT NULL,
  `schedulerID` varchar(50) NOT NULL,
  `lastUpdateID` varchar(50) NOT NULL,
  `requestID` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `serverHostname` (`serverHostname`,`serverIP`,`requestStatus`(1),`requestID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


ALTER TABLE users add column groups varchar(50) NULL;

-- 
-- Table structure for table `groups`
-- 

CREATE TABLE `groups` (
  `gid` int(11) NOT NULL auto_increment,
  `groupName` varchar(50) NOT NULL,
  `groupDesc` varchar(255) NOT NULL,
  `groupRoles` varchar(255) NOT NULL,
  PRIMARY KEY  (`gid`),
  UNIQUE KEY `groupName` (`groupName`)
) ENGINE=MyISAM;


-- 
-- Table structure for table `group_roles`
-- 

CREATE TABLE `group_roles` (
  `gid` int(11) NOT NULL auto_increment,
  `roleID` int(11) NOT NULL,
  PRIMARY KEY  (`gid`)
) ENGINE=MyISAM;

-- 
-- Table structure for table `roles`
-- 

CREATE TABLE `roles` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `pn_uname` varchar(45) NOT NULL default '',
  `role` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `pn_uname` (`pn_uname`)
) ENGINE=MyISAM;
