-- 
-- Table structure for table `inprotect_features`
-- 

DROP TABLE IF EXISTS `inprotect_features`;
CREATE TABLE `inprotect_features` (
  `feature_id` int(10) unsigned NOT NULL auto_increment,
  `feature_name` varchar(55) NOT NULL default '',
  `feature_desc` varchar(255) NOT NULL default '',
  `feature_status` int(11) NOT NULL default '1',
  PRIMARY KEY  (`feature_id`)
) ENGINE=MyISAM;

-- 
-- Dumping data for table `inprotect_features`
-- 

INSERT INTO `inprotect_features` VALUES 
  (1, 'enableFP', 'Enables False Positive flagging in the reports and search results', 0),
  (2, 'enableExceptions', 'Enable tracking of exceptions to vulnerabilities', 1),
  (3, 'enableNotes', 'Enable ability to attach notes to individual vulnerabilities', 0),
  (4, 'enablePS', 'Enable the ability to perform NMAP scans through InProtect', 0),
  (5, 'enableIUpdates', 'Enable admin the ability to perform plugin updates from the console', 0),
  (6, 'enablePasswordQuality', 'Enable password quality checks (only valid for account in the internal InProtect SQL DB).', 0);

--
-- Add new rows to the inprotect_settings table for the config items moved
--  from the config file to the DB
--

--
-- Table structure for table `inprotect_settings`
--

DROP TABLE IF EXISTS `inprotect_settings`;

CREATE TABLE `inprotect_settings` (
  `settingID` int(11) NOT NULL auto_increment,
  `settingName` varchar(100) NOT NULL default '',
  `settingValue` varchar(255) NOT NULL default '',
  `settingDescription` varchar(255) default NULL,
  PRIMARY KEY  (`settingID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inprotect_settings`
--


/*!40000 ALTER TABLE `inprotect_settings` DISABLE KEYS */;
LOCK TABLES `inprotect_settings` WRITE;
INSERT INTO `inprotect_settings` VALUES 
  (1,'version','0.80.0','InProtect Version','Base'),
  (2,'inprotect_path','/var/www/inprotect','InProtect Web Root','Base'),
  (3,'inprotect_url','https://localhost/inprotect/','InProtect URL','Base'),
  (4,'nessus_install_url','http://install.nessus.org/releases','Nessus Download URL','Base'),
  (5,'nessus_install_file','nessus-2.0.x.tgz','Nessus Download Filename','Base'),
  (6,'nessus_plugins_sig','all-2.0.sig','Nessus Plugins Signature Filename','Base'),
  (7,'nessus_plugins_md5','all-2.0.tar.gz.md5','Nessus Plugins MD5 Filename','Base'),
  (8,'nessus_plugins_file','all-2.0.tar.gz','Nessus Plugins Download Filename','Base'),
  (9,'nessus_plugins_url','http://www.nessus.org/nasl','Nessus Plugins Download URL','Base'),
  (10,'mailfrom','InProtect@domain.com','InProtect From: Email Address','Mail'),
  (11,'replyto','InProtect@domain.com','InProtect Reply To: Email Address','Mail'),
  (12,'scanrequestemail','email@domain.com','Scan Request Submission Notification Email Address(es)','Mail'),
  (13,'scanapproveemail','email@domain','Scan Request Approval Notification Email Address(es)','Mail'),
  (14,'suggestionemail','email@domain.com','InProtect Suggestion Email Address','Mail'),
  (15, 'scanNotificationCC', 'email@domain.com', 'CC: address(es) for scan notification emails','Mail'),
  (16,'pq_minLength','8','Minimum Password Length','Auth'),
  (17,'pq_maxLength','64','Maximum Password Length','Auth'),
  (18,'pq_minAlpha','1','Minimum alphanumeric characters in the password','Auth'),
  (19,'pq_minLower','0','Minumum Lower Case letters in the password','Auth'),
  (20,'pq_minUpper','0','Minimum Upper Case letters in the password','Auth'),
  (21,'pq_minSpecial','0','Minimum number of special characters in the password','Auth'),
  (22,'pq_minNumber','1','Minimum number of numeric characters in the password','Auth'),
  (23,'allowscan','1','Enable users to scan any IP address','Base'),
  (24,'enableprivate','1','Enable scanning of private IP addresses (192.168.x.x, 10.x.x.x, 172.16.x.x)','Base'),
  (25,'emailverify','0','Verify users email address','Mail'),
  (26,'authLDAP','1','Authenticate users against an LDAP directory?','LDAP'),
  (27,'authFailLocal','1','Fail through to local SQL authentication if LDAP server is unavailable','LDAP'),
  (28,'authLDAP_host','ldaps://server.com:636','LDAP host (can be a hostname or a full LDAP URI)','LDAP'),
  (29,'authLDAP_port','','Port LDAP server is listening on','LDAP'),
  (30,'authLDAP_baseDN','o=domain.com','LDAP base DN','LDAP'),
  (31,'authLDAP_searchBase','ou=Users','LDAP search Base to use when searching for users (authLDAP_baseDN is automatically appended)','LDAP'),
  (32,'authLDAP_searchAttr','uid','LDAP attribute to use when searching for user','LDAP'),
  (33,'authLDAP_searchResults','dn','LDAP attributes to retun on successful authentication','LDAP'),
  (34,'maxScanAge','180','Maximum scan age (in days) before last scan of host is considered too old','Base'),
  (35,'nostatusArray','Decommissioned,Retired,Offline,Virtual,Alias','Host Status flag values to cause host entry to be ignored','Lists'),
  (36,'hostScanStateArray','Passed,Pending Scan,PendingFixes,Pending Exceptions,Scan Out of Date, Fixes Applied - Pending ReScan','Comma separated list of possible scan states for a host','Lists'),
  (37,'serverLocationArray','Home, Away, Other','Possible locations of scan hosts','Lists'),
  (38,'serverNetworkArray','DMZ,Internal,Test,Lab,Other','Comma separate list of possible server networks','Lists'),
  (39,'serverStateArray','Production,Pending Production,Test,Development,UAT','Comma separated list of possibe server states','Lists'),
  (40,'requestStatusArray','Pending,Scheduled,Rejected','Comma separated list of possible scan request statuses','Lists'),
  (41,'exceptionStatusArray','Pending,Rejected,Approved','Comma separated list of possible exception statuses','Lists'),
  (42,'exceptionTypeArray','False Positive,AmbiguousVulnerability,TruePositive','Comma separated list of possilble exception types','Lists'),
  (43,'enablessl','1','Require SSL for all InProtect sessions','Base'),
  (44,'enablePS','0','Enable the NMAP funcationality','Functions'),
  (45,'enableFP','0','Enable the False Positive flagging','Functions'),
  (46,'enableException','1','Enable tracking of vulnerability exceptions','Functions'),
  (47,'enableNotes','1','Enable per-vulnerability notes','Functions'),
  (48,'enableUpdates','0','Enable plugin updates from admin console (broken)','Functions');
UNLOCK TABLES;
/*!40000 ALTER TABLE `inprotect_settings` ENABLE KEYS */;


--
-- Table structure for table `roles`
--

DROP TABLE IF EXISTS `roles`;
CREATE TABLE `roles` (
  `roleID` int(10) unsigned NOT NULL auto_increment,
  `roleName` varchar(25) NOT NULL default '',
  `roleDesc` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`roleID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 PACK_KEYS=0;

--
-- Dumping data for table `roles`
--


/*!40000 ALTER TABLE `roles` DISABLE KEYS */;
LOCK TABLES `roles` WRITE;
INSERT INTO `roles` VALUES 
  (1,'admin','Administrator (incl. users)'),
  (2,'uadmin','User Administration'),
  (3,'nessus','Run Nessus scans'),
  (4,'nmap','Run Nmap scans'),
  (5,'scanRequest','Manage Scan Requests'),
  (6,'reports','View all scan reports'),
  (7,'zones','Edit Network Zones'),
  (8,'eapprove','Approve Exceptions'),
  (9,'esubmit','Submit Exception Requests'),
  (10,'eview','View Exceptions'),
  (11,'profile','Edit Nessus Scan Profiles');
UNLOCK TABLES;
/*!40000 ALTER TABLE `roles` ENABLE KEYS */;

--
-- Table structure for table `user_roles`
--

DROP TABLE IF EXISTS `user_roles`;
CREATE TABLE `user_roles` (
  `urID` int(10) unsigned NOT NULL auto_increment,
  `roleID` int(10) unsigned NOT NULL default '0',
  `pn_uname` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`urID`),
  KEY `role` (`roleID`,`pn_uname`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `user_roles`
--


/*!40000 ALTER TABLE `user_roles` DISABLE KEYS */;
LOCK TABLES `user_roles` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `user_roles` ENABLE KEYS */;

--
-- Table structure for table `groups`
--

DROP TABLE IF EXISTS `groups`;
CREATE TABLE `groups` (
  `gid` int(11) NOT NULL auto_increment,
  `groupName` varchar(255) NOT NULL default '',
  `groupDesc` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`gid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `groups`
--


/*!40000 ALTER TABLE `groups` DISABLE KEYS */;
LOCK TABLES `groups` WRITE;
INSERT INTO `groups` VALUES 
  (1,'Admin','Administrators'),
  (2,'Users','Power users - all non-admin roles');
UNLOCK TABLES;
/*!40000 ALTER TABLE `groups` ENABLE KEYS */;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `pn_uname` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `pn_email` varchar(60) NOT NULL default '',
  `pn_pass` varchar(40) NOT NULL default '',
  `expire` varchar(8) default NULL,
  `locked` int(11) NOT NULL default '0',
  `created` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastaccessed` datetime NOT NULL default '0000-00-00 00:00:00',
  `owniponly` char(1) NOT NULL default 'N',
  `sc_now` char(1) NOT NULL default 'N',
  `sc_once` char(1) NOT NULL default 'N',
  `sc_daily` char(1) NOT NULL default 'N',
  `sc_weekly` char(1) NOT NULL default 'N',
  `sc_monthly` char(1) NOT NULL default 'N',
  `dashboard` varchar(50) default NULL,
  PRIMARY KEY  (`pn_uname`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `users`
--


/*!40000 ALTER TABLE `users` DISABLE KEYS */;
LOCK TABLES `users` WRITE;
INSERT INTO `users` VALUES 
  ('admin','root@localhost', md5('admin'),'', 0,'2007-09-26 13:44:56','2007-09-26 13:44:56','N','N','N','N','N','N','dvt:1|dpe:1|dmt:1|dss:1|dnw:0');
UNLOCK TABLES;
/*!40000 ALTER TABLE `users` ENABLE KEYS */;

--
-- Table structure for table `group_roles`
--

DROP TABLE IF EXISTS `group_roles`;
CREATE TABLE `group_roles` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `gid` int(10) unsigned NOT NULL default '0',
  `roleID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gid` (`gid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `group_roles`
--


/*!40000 ALTER TABLE `group_roles` DISABLE KEYS */;
LOCK TABLES `group_roles` WRITE;
INSERT INTO `group_roles` VALUES 
  (1,1,1),
  (2,1,2),
  (3,1,3),
  (4,1,4),
  (5,1,5),
  (6,1,6),
  (7,1,7),
  (8,1,8),
  (9,1,9),
  (10,1,10),
  (11,1,11),
  (12,2,3),
  (13,2,4),
  (14,2,5),
  (15,2,6),
  (16,2,7),
  (17,2,8),
  (18,2,9),
  (19,2,10),
  (20,2,11);
UNLOCK TABLES;
/*!40000 ALTER TABLE `group_roles` ENABLE KEYS */;

--
-- Table structure for table `user_groups`
--

DROP TABLE IF EXISTS `user_groups`;
CREATE TABLE `user_groups` (
`ugID` int(10) unsigned NOT NULL auto_increment,
`pn_uname` varchar(55) NOT NULL default '',
`gid` int(10) unsigned NOT NULL default '0',
PRIMARY KEY  (`ugID`),
KEY `pn_uname` (`pn_uname`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `user_groups`
--


/*!40000 ALTER TABLE `user_groups` DISABLE KEYS */;
LOCK TABLES `user_groups` WRITE;
INSERT INTO `user_groups` VALUES 
  (1,'admin',1),
UNLOCK TABLES;
/*!40000 ALTER TABLE `user_groups` ENABLE KEYS */;

--
-- Table structure for table `dashboards`
--

DROP TABLE IF EXISTS `dashboards`;
CREATE TABLE `dashboards` (
  `dashID` int(10) unsigned NOT NULL auto_increment,
  `dashName` varchar(255) NOT NULL default '',
  `dashDesc` varchar(255) NOT NULL default '',
  `dashModule` varchar(50) NOT NULL default '',
  `dashStatus` int(11) NOT NULL default '1',
  PRIMARY KEY  (`dashID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `dashboards`
--

/*!40000 ALTER TABLE `dashboards` DISABLE KEYS */;
LOCK TABLES `dashboards` WRITE;
INSERT INTO `dashboards` VALUES 
  (1,'dvt','Vulnerability Totals','dashDVT.inc',1,'rcolumn','dashDVT.inc',2),
  (2,'dmt','My Totals','dashDMT.inc',1,'rcolumn','dashDMT.inc',1),
  (3,'dss','System Stats','dashDSS.inc',1,'rcolumn','dashDSS.inc',5),
  (4,'dpe','Pending Exceptions','dashDPE.inc',1,'rcolumn','dashDPE.inc',4),
  (5,'dnw','News Items','dashDNW.inc',1,'lcolumn','dashDNW.inc',6),
  (6,'dem','Executive Metrics','dashMetrics.inc',1,'lcolumn','dashMetrics.inc',3);
UNLOCK TABLES;
/*!40000 ALTER TABLE `dashboards` ENABLE KEYS */;


--
-- Table structure for table `user_dashboards`
--

DROP TABLE IF EXISTS `user_dashboards`;
CREATE TABLE `user_dashboards` (
`udID` int(10) unsigned NOT NULL auto_increment,
`dashID` int(10) NOT NULL default '0',
`dashStatus` int(10) NOT NULL default '1',
`dashLocation` varchar(25) NOT NULL default 'lcolumn',
`dashOrder` int(10) default NULL,
`pn_uname` varchar(55) NOT NULL default '',
PRIMARY KEY  (`udID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `user_dashboards`
--


/*!40000 ALTER TABLE `user_dashboards` DISABLE KEYS */;
LOCK TABLES `user_dashboards` WRITE;
INSERT INTO `user_dashboards` VALUES (1,1,1,'',NULL,'admin'),(2,2,1,'',NULL,'admin'),(3,3,1,'',NULL,'admin'),(4,4,1,'',NULL,'admin'),(5,5,0,'',NULL,'admin'),(35,6,1,'lcolumn',NULL,'admin');
UNLOCK TABLES;
/*!40000 ALTER TABLE `user_dashboards` ENABLE KEYS */;

-- add new columns to nessus_settings
alter table nessus_settings add column auto_cat_status int(10) default 4;
alter table nessus_settings add column auto_fam_status int(10) default 4;
