-- phpMyAdmin SQL Dump
-- version 2.9.0
-- http://www.phpmyadmin.net
-- 
-- Host: localhost
-- Generation Time: Oct 15, 2007 at 12:34 PM
-- Server version: 5.1.15
-- PHP Version: 5.2.0
-- 
-- Database: `inprotect`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `dashboards`
-- 

CREATE TABLE `dashboards` (
  `dashID` int(10) unsigned NOT NULL auto_increment,
  `dashName` varchar(255) NOT NULL default '',
  `dashDesc` varchar(255) NOT NULL default '',
  `dashModule` varchar(50) NOT NULL default '',
  `dashStatus` int(11) NOT NULL default '1',
  `dashLocation` varchar(25) NOT NULL default 'lcolumn',
  `dashURL` varchar(55) NOT NULL default '',
  `dashOrder` int(10) default NULL,
  PRIMARY KEY  (`dashID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Table structure for table `exceptions`
-- 
CREATE TABLE `exceptions` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `eid` varchar(25) NOT NULL default '',
  `submitDate` datetime default NULL,
  `lastModified` datetime default NULL,
  `closeDate` datetime default NULL,
  `submitter` varchar(20) NOT NULL default '',
  `lastEditor` varchar(20) NOT NULL default '',
  `approver` varchar(20) default NULL,
  `status` varchar(25) NOT NULL default '',
  `plugin` int(10) unsigned NOT NULL default '0',
  `type` varchar(25) NOT NULL default '',
  `application` varchar(45) default NULL,
  `os` varchar(45) NOT NULL default '',
  `justification` text NOT NULL,
  `comments` text,
  `evidence` blob,
  `secRqmts` text,
  `ip` varchar(100) NOT NULL default '',
  `hostname` varchar(255) default NULL,
  `port` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `eid` (`eid`),
  KEY `ip` (`ip`),
  KEY `hostname` (`hostname`),
  KEY `plugin` (`plugin`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Vulnerability Exceptions';


-- 
-- Table structure for table `group_roles`
-- 
CREATE TABLE `group_roles` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `gid` int(10) unsigned NOT NULL default '0',
  `roleID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gid` (`gid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


-- 
-- Table structure for table `groups`
-- 

CREATE TABLE `groups` (
  `gid` int(11) NOT NULL auto_increment,
  `groupName` varchar(255) NOT NULL default '',
  `groupDesc` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`gid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


-- 
-- Table structure for table `hosts`
-- 

CREATE TABLE `hosts` (
  `id` int(11) NOT NULL auto_increment,
  `ip` varchar(45) NOT NULL default '',
  `hostname` varchar(45) NOT NULL default '',
  `description` varchar(200) NOT NULL default '',
  `status` varchar(45) NOT NULL default '',
  `os` varchar(45) NOT NULL default '',
  `contact` varchar(45) NOT NULL default '',
  `scanstate` varchar(25) default NULL,
  `lastscandate` datetime default NULL,
  `createdate` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `ip` (`ip`),
  KEY `status` (`status`,`scanstate`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Table structure for table `inprotect_features`
-- 

CREATE TABLE `inprotect_features` (
  `feature_id` int(10) unsigned NOT NULL auto_increment,
  `feature_name` varchar(55) NOT NULL default '',
  `feature_desc` varchar(255) NOT NULL default '',
  `feature_status` int(11) NOT NULL default '1',
  PRIMARY KEY  (`feature_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


-- 
-- Table structure for table `roles`
-- 

CREATE TABLE `roles` (
  `roleID` int(10) unsigned NOT NULL auto_increment,
  `roleName` varchar(25) NOT NULL default '',
  `roleDesc` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`roleID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 PACK_KEYS=0;

-- 
-- Table structure for table `scan_requests`
-- 

CREATE TABLE `scan_requests` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `serverHostname` varchar(50) NOT NULL default '',
  `serverIP` varchar(15) NOT NULL default '',
  `serverLocation` varchar(15) NOT NULL default '',
  `serverNetwork` varchar(25) NOT NULL default '',
  `serverState` varchar(25) NOT NULL default '',
  `desiredScanDate` datetime NOT NULL default '0000-00-00 00:00:00',
  `closeDate` datetime NOT NULL default '0000-00-00 00:00:00',
  `submitDate` datetime NOT NULL default '0000-00-00 00:00:00',
  `updateDate` datetime NOT NULL default '0000-00-00 00:00:00',
  `changeControl` int(10) unsigned NOT NULL default '0',
  `schedID` int(10) unsigned NOT NULL default '0',
  `requestStatus` varchar(15) NOT NULL default '',
  `requestorID` varchar(50) NOT NULL default '',
  `schedulerID` varchar(50) NOT NULL default '',
  `lastUpdateID` varchar(50) NOT NULL default '',
  `requestID` varchar(50) NOT NULL default '',
  `serverOS` varchar(50) default NULL,
  PRIMARY KEY  (`id`),
  KEY `serverHostname` (`serverHostname`,`serverIP`,`requestStatus`(1),`requestID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


-- 
-- Table structure for table `user_dashboards`
-- 

CREATE TABLE `user_dashboards` (
  `udID` int(10) unsigned NOT NULL auto_increment,
  `dashID` int(10) NOT NULL default '0',
  `dashStatus` int(10) NOT NULL default '1',
  `dashLocation` varchar(25) NOT NULL default 'lcolumn',
  `dashOrder` int(10) default NULL,
  `pn_uname` varchar(55) NOT NULL default '',
  PRIMARY KEY  (`udID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Table structure for table `user_groups`
-- 

CREATE TABLE `user_groups` (
  `ugID` int(10) unsigned NOT NULL auto_increment,
  `pn_uname` varchar(55) NOT NULL default '',
  `gid` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ugID`),
  KEY `pn_uname` (`pn_uname`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


-- 
-- Table structure for table `user_roles`
-- 

CREATE TABLE `user_roles` (
  `urID` int(10) unsigned NOT NULL auto_increment,
  `roleID` int(10) unsigned NOT NULL default '0',
  `pn_uname` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`urID`),
  KEY `role` (`roleID`,`pn_uname`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- Table structure CHANGES
-- 

-- 
-- Table structure for table `inprotect_settings`
-- 

DROP TABLE IF EXISTS `inprotect_settings`;

CREATE TABLE `inprotect_settings` (
  `settingID` int(11) NOT NULL auto_increment,
  `settingName` varchar(100) NOT NULL default '',
  `settingValue` varchar(255) NOT NULL default '',
  `settingDescription` varchar(255) default NULL,
  `settingSection` varchar(50) default NULL,
  PRIMARY KEY  (`settingID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



-- 
-- Table structure CHANGES
-- 

ALTER TABLE nessus_settings ADD COLUMN auto_cat_status int( 10 ) default 4;
ALTER TABLE nessus_settings ADD COLUMN auto_fam_status int( 10 ) default 4;


ALTER TABLE `nessus_results` 
	CHANGE `risk` `risk` ENUM('1','2','3','4','5','6','7') NOT NULL, 
	CHANGE `falsepositive` `falsepositive` ENUM('Y','N') NULL DEFAULT 'N';
ALTER TABLE `nessus_results` ADD INDEX ( `host` ) ;
ALTER TABLE `nessus_results` ADD INDEX ( `sched_id` ) ;
ALTER TABLE `nessus_results` ADD INDEX ( `service` );
ALTER TABLE `nessus_results` ADD INDEX ( `risk` ); 
 -- 
-- Table structure for table `users`
-- 
ALTER TABLE `users`
DROP `admin`,
DROP `profile`,
DROP `zones`,
DROP `nmap`,
DROP `nessus`;


-- 
-- Dumping data for table `dashboards`
-- 

INSERT INTO `dashboards` (`dashID`, `dashName`, `dashDesc`, `dashModule`, `dashStatus`, `dashLocation`, `dashURL`, `dashOrder`) VALUES 
(1, 'dvt', 'Vulnerability Totals', 'dashDVT.inc', 1, 'rcolumn', 'dashDVT.inc', 2),
(2, 'dmt', 'My Totals', 'dashDMT.inc', 1, 'rcolumn', 'dashDMT.inc', 1),
(3, 'dss', 'System Stats', 'dashDSS.inc', 1, 'lcolumn', 'dashDSS.inc', 3),
(4, 'dpe', 'Pending Exceptions', 'dashDPE.inc', 1, 'lcolumn', 'dashDPE.inc', 4),
(5, 'dnw', 'News Items', 'dashDNW.inc', 1, 'lcolumn', 'dashDNW.inc', 5);

-- --------------------------------------------------------

-- 
-- Dumping data for table `groups`
-- 

INSERT INTO `groups` (`gid`, `groupName`, `groupDesc`) VALUES 
(1, 'Admin', 'Administrators'),
(2, 'Users', 'Power users - all non-admin roles');

-- --------------------------------------------------------

-- 
-- Dumping data for table `group_roles`
-- 

INSERT INTO `group_roles` (`id`, `gid`, `roleID`) VALUES 
(1, 1, 1),
(2, 1, 2),
(3, 1, 3),
(4, 1, 4),
(5, 1, 5),
(6, 1, 6),
(7, 1, 7),
(8, 1, 8),
(9, 1, 9),
(10, 1, 10),
(11, 1, 11),
(12, 2, 3),
(13, 2, 4),
(14, 2, 5),
(15, 2, 6),
(16, 2, 7),
(17, 2, 8),
(18, 2, 9),
(19, 2, 10),
(20, 2, 11);

-- --------------------------------------------------------

-- 
-- Dumping data for table `inprotect_features`
-- 

INSERT INTO `inprotect_features` (`feature_id`, `feature_name`, `feature_desc`, `feature_status`) VALUES 
(1, 'enableFP', 'Enables False Positive flagging in the reports and search results', 0),
(2, 'enableExceptions', 'Enable tracking of exceptions to vulnerabilities', 1),
(3, 'enableNotes', 'Enable ability to attach notes to individual vulnerabilities', 0),
(4, 'enablePS', 'Enable the ability to perform NMAP scans through InProtect', 0),
(5, 'enableIUpdates', 'Enable admin the ability to perform plugin updates from the console', 0),
(6, 'enablePasswordQuality', 'Enable password quality checks (only valid for account in the internal InProtect SQL DB).', 0);

-- --------------------------------------------------------

-- 
-- Dumping data for table `inprotect_settings`
-- 

INSERT INTO `inprotect_settings` (`settingID`, `settingName`, `settingValue`, `settingDescription`, `settingSection`) VALUES 
(1, 'version', '0.80.1 Beta', 'InProtect Version', 'Base'),
(2, 'inprotect_path', '/var/www/inprotect', 'InProtect Web Root', 'Base'),
(3, 'inprotect_url', 'https://localhost/inprotect/', 'InProtect URL', 'Base'),
(4, 'nessus_install_url', 'http://install.nessus.org/releases', 'Nessus Download URL', 'Base'),
(5, 'nessus_install_file', 'nessus-2.0.x.tgz', 'Nessus Download Filename', 'Base'),
(6, 'nessus_plugins_sig', 'all-2.0.sig', 'Nessus Plugins Signature Filename', 'Base'),
(7, 'nessus_plugins_md5', 'all-2.0.tar.gz.md5', 'Nessus Plugins MD5 Filename', 'Base'),
(8, 'nessus_plugins_file', 'all-2.0.tar.gz', 'Nessus Plugins Download Filename', 'Base'),
(9, 'nessus_plugins_url', 'http://www.nessus.org/nasl', 'Nessus Plugins Download URL', 'Base'),
(10, 'mailfrom', 'InProtect@domain.com', 'InProtect From: Email Address', 'Mail'),
(11, 'replyto', 'email@domain.com', 'InProtect Reply To: Email Address', 'Mail'),
(12, 'scanrequestemail', 'email@domain.com', 'Scan Request Submission Notification Email Address(es)', 'Mail'),
(13, 'scanapproveemail', 'email@domain.com', 'Scan Request Approval Notification Email Address(es)', 'Mail'),
(14, 'suggestionemail', 'email@domain.com', 'InProtect Suggestion Email Address', 'Mail'),
(15, 'pq_minLength', '8', 'Minimum Password Length', 'Auth'),
(16, 'pq_maxLength', '64', 'Maximum Password Length', 'Auth'),
(17, 'pq_minAlpha', '1', 'Minimum alphanumeric characters in the password', 'Auth'),
(18, 'pq_minLower', '0', 'Minumum Lower Case letters in the password', 'Auth'),
(19, 'pq_minUpper', '0', 'Minimum Upper Case letters in the password', 'Auth'),
(20, 'pq_minSpecial', '0', 'Minimum number of special characters in the password', 'Auth'),
(21, 'pq_minNumber', '1', 'Minimum number of numeric characters in the password', 'Auth'),
(22, 'allowscan', '1', 'Enable users to scan any IP address', 'Base'),
(23, 'enableprivate', '1', 'Enable scanning of private IP addresses (192.168.x.x, 10.x.x.x, 172.16.x.x)', 'Base'),
(24, 'emailverify', '0', 'Verify users email address', 'Mail'),
(25, 'authLDAP', '0', 'Authenticate users against an LDAP directory?', 'LDAP'),
(26, 'authFailLocal', '1', 'Fail through to local SQL authentication if LDAP server is unavailable', 'LDAP'),
(27, 'authLDAP_host', 'ldap://localhost:389', 'LDAP host (can be a hostname or a full LDAP URI)', 'LDAP'),
(28, 'authLDAP_port', '', 'Port LDAP server is listening on', 'LDAP'),
(29, 'authLDAP_baseDN', 'dc=mindache,dc=com', 'LDAP base DN', 'LDAP'),
(30, 'authLDAP_searchBase', 'ou=inprotect', 'LDAP search Base to use when searching for users (authLDAP_baseDN is automatically appended)', 'LDAP'),
(31, 'authLDAP_searchAttr', 'uid', 'LDAP attribute to use when searching for user', 'LDAP'),
(32, 'authLDAP_searchResults', 'dn', 'LDAP attributes to retun on successful authentication', 'LDAP'),
(33, 'maxScanAge', '180', 'Maximum scan age (in days) before last scan of host is considered too old', 'Base'),
(34, 'nostatus', 'Decommissioned,Retired,Offline,Virtual,Alias', 'Host Status flag values to cause host entry to be ignored', 'Lists'),
(35, 'hostScanStateArray', 'Passed,Pending Scan,PendingFixes,Pending Exceptions,Scan Out of Date, Fixes Applied - Pending ReScan', 'Comma separated list of possible scan states for a host', 'Lists'),
(36, 'serverLocationArray', 'Home, Away, Other', 'Possible locations of scan hosts', 'Lists'),
(37, 'serverNetworkArray', 'DMZ, Internal, Test, Lab, Other', 'Comma separate list of possible server networks', 'Lists'),
(38, 'serverStateArray', 'Production,Pending Production,Test,Development,UAT', 'Comma separated list of possibe server states', 'Lists'),
(39, 'requestStatusArray', 'Pending,Scheduled,Rejected', 'Comma separated list of possible scan request statuses', 'Lists'),
(40, 'exceptionStatusArray', 'Pending,Rejected,Approved', 'Comma separated list of possible exception statuses', 'Lists'),
(41, 'exceptionTypeArray', 'False Positive,AmbiguousVulnerability,TruePositive', 'Comma separated list of possilble exception types', 'Lists'),
(42, 'enablessl', '1', 'Require SSL for all InProtect sessions', 'Base'),
(43, 'enablePS', '0', 'Enable the NMAP funcationality', 'Functions'),
(44, 'enableFP', '0', 'Enable the False Positive flagging', 'Functions'),
(45, 'enableException', '1', 'Enable tracking of vulnerability exceptions', 'Functions'),
(46, 'enableNotes', '1', 'Enable per-vulnerability notes', 'Functions'),
(47, 'enableUpdates', '0', 'Enable plugin updates from admin console (broken)', 'Functions');

-- --------------------------------------------------------

-- 
-- Dumping data for table `roles`
-- 

INSERT INTO `roles` (`roleID`, `roleName`, `roleDesc`) VALUES 
(1, 'admin', 'Administrator incl. users'),
(2, 'uadmin', 'User Administration'),
(3, 'nessus', 'Run Nessus scans'),
(4, 'nmap', 'Run Nmap scans'),
(5, 'scanRequest', 'Submit Scan Requests'),
(6, 'reports', 'View all scan reports'),
(7, 'zones', 'Edit Network Zones'),
(8, 'eapprove', 'Approve Exceptions'),
(9, 'esubmit', 'Submit Exception Requests'),
(10, 'eview', 'View Exceptions'),
(11, 'profile', 'Edit Nessus Scan Profiles');

-- --------------------------------------------------------

-- 
-- Dumping data for table `user_dashboards`
-- 

INSERT INTO `user_dashboards` (`udID`, `dashID`, `dashStatus`, `dashLocation`, `dashOrder`, `pn_uname`) VALUES 
(1, 1, 1, 'rcolumn', 2, 'admin'),
(2, 2, 1, 'rcolumn', 1, 'admin'),
(3, 3, 1, 'lcolumn', 3, 'admin'),
(4, 4, 1, 'lcolumn', 4, 'admin'),
(5, 5, 1, 'lcolumn', 5, 'admin');

-- --------------------------------------------------------

-- 
-- Dumping data for table `user_groups`
-- 

INSERT INTO `user_groups` (`ugID`, `pn_uname`, `gid`) VALUES 
(1, 'Admin', 1);

-- --------------------------------------------------------
