<?php
//
// $Id: admin.php,v 1.9 2006/08/10 17:19:32 airwofl Exp $
//

$pageTitle = "User Management";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$getParams = array( "op", "auname" );
$postParams = array( "op", "auname", "aemail", "locked", "expire", 
                     "pass1", "pass2" );

// get all available roles and put in hash
$query = "SELECT roleID, roleName, roleDesc
          FROM roles
          ORDER BY roleName ASC";
$result = $dbconn->GetArray($query);
if($result === false) {
   echo "SQL Error: " . $dbconn->ErrorMsg();
} else {
   foreach($result as $role) {
      $allRoles[$role['roleID']] = array( 'roleName' => $role['roleName'],
                                          'roleDesc' => $role['roleDesc'] );
   }
}

// get all available groups and put in hash
$query = "SELECT gid, groupName, groupDesc
          FROM groups";
$result = $dbconn->GetArray($query);
if($result === false) {
   echo "SQL Error: " . $dbconn->ErrorMsg();
} else {
   foreach($result as $group) {
      $allGroups[$group['gid']] = array( 'groupName' => $group['groupName'],
                                         'groupDesc' => $group['groupDesc'] );
   }
}

// additional variable setup based on how we were called
switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   //print_r($allRoles);
   // process the roles info
   foreach($allRoles as $roleID=>$rdata) {
      if(isset($_POST[$roleID])) {
         $proles[$roleID] = "Y";
      } else {
         $proles[$roleID] = "N";
      }
   }
   if(isset($_POST['groups'])) {
      foreach($_POST['groups'] as $gid) {
         $gid = htmlspecialchars(mysql_real_escape_string(trim($gid)), ENT_QUOTES); 
         $pgroups[$gid] = 1;
      }
   }
   break;
}

// need admin rights, check if user has it
if (!$uroles['admin'] && !$uroles['uadmin']) {
    echo "Insufficient permissions - Access Denied.";
    $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
               " : Access denied", PEAR_LOG_WARNING);
} else {
    $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
               " : Accessed page", PEAR_LOG_DEBUG);
    echo "<B>User Management</b><BR>";

    switch ($op) {
    case "delete" :
        // don't delete the data for the user, just reassign it to
        // the admin account for scan related info.  Only remove
        // personalization or rights related data.

        /* original code

        $query="delete from users 
                where pn_uname='$auname'";
        $result=$dbconn->execute($query);

        $query="delete from nessus_hosts where username='$auname'";
        $result=$dbconn->execute($query);

        $query="delete from nessus_notes where username='$auname'";
        $result=$dbconn->execute($query);

        $query="delete from nessus_results where username='$auname'";
        $result=$dbconn->execute($query);

        $query="delete from nessus_scan where username='$auname'";
        $result=$dbconn->execute($query);

        $query="delete from nessus_schedule where username='$auname'";
        $result=$dbconn->execute($query);

        $query="delete from nessus_user_zones where username='$auname'";
        $result=$dbconn->execute($query);

        $query="delete from portscan where username='$auname'";
        $result=$dbconn->execute($query);

        $query="delete from nessus_settings_users where username='$auname'";
        $result=$dbconn->execute($query);

        $query="delete from nessus_zones where username='$auname' and type='P'";
        $result=$dbconn->execute($query);

        end original code */

        // new code
        $error = 0; // for capturing errors on the SQL commands
        $query="update nessus_hosts 
                set username = 'admin' 
                where username='$auname'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "nessus_hosts: " . $dbconn->ErrorMsg();
        }

        $query="update nessus_notes 
                set username='admin' 
                where username='$auname'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "nessus_notes: " . $dbconn->ErrorMsg();
        }

        $query="update nessus_results 
                set username='admin' 
                where username='$auname'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "nessus_results: " . $dbconn->ErrorMsg();
        }

// not necessary, this table isn't linked to users directly
//       $query="update nessus_scan 
//                set username='admin' 
//                where username='$auname'";
//        $result=$dbconn->execute($query);
//        if($result === false) {
//           $error++;
//           $errorMsg[] = "nessus_scan: " . $dbconn->ErrorMsg();
//        }
//
        $query="update nessus_schedule 
                set username='admin' 
                where username='$auname'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "nessus_schedule: " . $dbconn->ErrorMsg();
        }

        // remove this entry, it's rights data
        $query="delete from nessus_user_zones 
                where username='$auname'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "nessus_user_zones: " . $dbconn->ErrorMsg();
        }

        $query="update portscan 
                set username='admin' 
                where username='$auname'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "portscan: " . $dbconn->ErrorMsg();
        }

        // personalization info, so remove this
        $query="delete from nessus_settings_users 
                where username='$auname'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "nessus_settings_users: " . $dbconn->ErrorMsg();
        }

        // rights data, remove this
        $query="delete from nessus_zones 
                where owner='$auname' and type='P'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "nessus_zones: " . $dbconn->ErrorMsg();
        }
        // end new code

        // clean up the roles table
        $query="delete from user_roles 
                where pn_uname='$auname'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "user_roles: " . $dbconn->ErrorMsg();
        }

        // clean up the user_groups table
        $query="delete from user_groups 
                where pn_uname='$auname'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "user_groups: " . $dbconn->ErrorMsg();
        }

        // clean up the user_dashboard table
        $query="delete from user_dashboard 
                where pn_uname='$auname'";
        $result=$dbconn->execute($query);
        if($result === false) {
           $error++;
           $errorMsg[] = "user_dashboard: " . $dbconn->ErrorMsg();
        }

        // only remove the user account if no previous errors
        if ($error == 0) {
           $query="delete from users 
                   where pn_uname='$auname'";
           $result=$dbconn->execute($query);
           if($result === false) {
              $error++;
              $errorMsg .= $dbconn->ErrorMsg();
           }
        }
        
        // check for error in the sql queries and print message accordingly
        if($error != 0) { 
           echo "<table class='error'>";
           echo "<tr><th>Error</th></tr>";
           echo "<tr><td>There was an error in one or more of the SQL queries
                 when deleting the user information.</td></tr>";
           echo "<tr><td>The User account has not been deleted</td></tr>";
           echo "<tr><td><pre>" . implode("\n",$errorMsg) . "</pre></td></tr>";
           echo "</table>";
           $logh->log("$username : " . $_SERVER['PHP_SELF']  .
                   " : Errors encountered while deleting user " . 
                   $auname . ": " . implode(",",$errorMsg), PEAR_LOG_NOTICE);
        } else {
           echo "<B>User account <I>$auname</I> has been deleted.</B><BR><BR>";
           $logh->log("$username : " . $_SERVER['PHP_SELF']  .
                   " : Deleted user " . $auname, PEAR_LOG_NOTICE);
        }
        $auname="";
        $op="";
        break;
    case "add" :
       if ($pass1<>"" and $pass2<>"") {
          $error = 0;
          $checkPass = checkPass($pass1);
          $pass1=md5($pass1);
          $pass2=md5($pass2);
          if ($pass1==$pass2 && $checkPass=="pass") {
             if ($locked<>"Y") {
                $locked="0";
             } else {
                $locked=5;
             }
             // create record in users table
             $query="insert into users (pn_uname, pn_email, pn_pass, 
                                        expire, locked) 
                                 values ('$auname', '$aemail', '$pass1', 
                                         '$expire', $locked)";
             if ($dbconn->execute($query) === false) {
                echo "Error creating user: ". $dbconn->ErrorMsg();
                $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                           " : Error creating user " . $auname .
                           ":" . $dbconn->ErrorMsg(), PEAR_LOG_NOTICE);
                $error = 1;
             }

             // create records in roles table
             $query="insert into user_roles (pn_uname, roleID) values ";
             $vals = array ();
             foreach($allRoles as $roleID=>$roleData) {
                if ($proles[$roleID]=='Y') {
                   // only an "admin" can create another admin
                   // or assign the "zones" and "profiles" rights
                   if ($uroles['admin']) { 
                      $vals[] = "('$auname', '$roleID')";
                   } else if ($roleData['roleName'] != "admin" && 
                              $roleData['roleName'] != "zones" &&
                              $roleData['roleName'] != "profiles") {
                      $vals[] = "('$auname', '$roleID')";
                   }
                }
             }
             $query .= implode(",", $vals);
             //echo $query;
             if ($dbconn->execute($query) === false) {
                echo "Error creating user roles: " .$dbconn->ErrorMsg();
                $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                           " : Error creating user roles " . $auname .
                           ":" . $dbconn->ErrorMsg(), PEAR_LOG_NOTICE);
                $error = 1;
             }
             // print success message to screen
             if ($error == 0) {
                echo "<B>User <I>$auname</I> has been added.</B><br>";
                $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                           " : Created user " . $auname, PEAR_LOG_NOTICE);
             }
          } else {
             if($checkPass != "pass") {
                echo <<<EOT
<FONT COLOR="#FF0000"><B>
Cannot add user, provided password doesn't meet 
minimum standards ($checkPass).</B> <br>
<PRE>
(min Length = $minLength, 
 max Length = $maxLength, 
 min Alpha = $minAlpha,
 min Number = $minNumber, 
 min Upper = $minUpper,
 min Lower = $minLower, 
 min Special = $minSpecial)
</PRE>
</FONT><br>
EOT;
             } else {
                echo <<<EOT
<FONT COLOR="#FF0000"><B>Cannot add user, provided
passwords do not match.</B></FONT><br>
EOT;
             }
          }
       } else {
          echo "<FONT COLOR=\"#FF0000\"><B>Cannot add user, 
                password can not be blank.</B></FONT><br>";
          $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                     " : Create user failed - blank password for " . 
                     $auname, PEAR_LOG_DEBUG);
       }
       $op="";
       break;
    case "update" :
        // set up error flag
        $error = 0;
        $errMsg = "";
        // update users table
        if($locked == "") {
           $locked = "NULL";
        }
        $query="update users 
                set pn_email='$aemail', 
                    locked=$locked, 
                    expire='$expire' 
                where pn_uname='$auname'";
        $result=$dbconn->execute($query);
        if(!$result) { // oops, DB error
           $errMsg[] = "<p>DB Update Error (user update)- " . 
                       $dbconn->ErrorMsg() . "</p>";
           $error = 1;
        } 
        // update roles table
        // first remove all existing roles
        $query="delete from user_roles where pn_uname = '$auname'";
        $result=$dbconn->execute($query);
        if(!$result) { // oops, DB error
           $errMsg[] = "<p>DB Update Error (user_roles delete) - " .
                       $dbconn->ErrorMsg() . "</p>";
           $error = 1;
        } 
        // now add the new roles back
        /*
        print_r($allRoles);
        echo "<bR>";
        print_r($proles);
        echo "<br>";
        */
        foreach($allRoles as $roleID=>$data) {
           //echo "checking $role: ";
           if ($proles[$roleID]=="Y") {
              //echo "adding\n";
              $query="insert into user_roles (pn_uname,roleID) 
                         values ('$auname','$roleID')";
              $result=$dbconn->execute($query);
              if(!$result) { // oops, DB error
                 $errMsg[] = "<p>DB Update Error (user_roles add) - " .
                             $dbconn->ErrorMsg() . "</p>";
                 $error = 1;
              } 
           }
        }
        // finally, do any group mods
        $addgroups = $remgroups = array();
        foreach($allGroups as $gid=>$ag) {
           if(isset($pgroups[$gid])) {
              $addgroups[] = "('$auname', $gid)";
           } else {
              $remgroups[] = $gid;
           }
        }
        if(!empty($remgroups)) {
           $dquery = "DELETE FROM user_groups
                      WHERE pn_uname = '$auname' AND
                        gid IN (" . implode(",", $remgroups) . ")";
           $dres = $dbconn->execute($dquery);
           if($dres === false) { 
              $error = 1;
              $errMsg[] = "user_groups delete: " . $dquery . "<br>" .
                          $dbconn->ErrorMsg();
           }
        }
        if(!empty($addgroups)) {
           $iquery = "INSERT INTO user_groups
                       (pn_uname, gid) VALUES " .
                      implode(",",$addgroups);
           $ires = $dbconn->execute($iquery);
           if($ires === false) { 
              $error = 1;
              $errMsg[] = "user_groups add: " . $iquery . "<br>" .
                          $dbconn->ErrorMsg();
           }
        }

        if($error == 0) {
           echo "<B>Account has been updated.</B><br>";
           $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                      " : Updated user " . $auname, PEAR_LOG_NOTICE);
           $op="";
           // if user is updating own rights, reload them here.
           if ($auname == $username) {
              //$_SESSION['roles'] = getUserRoles($auname, $dbconn);
              $_SESSION['roles'] = getUserRoles($auname);
           }
        } else {
           echo "<table class='error'>
                 <tr><th>Error</th></tr>
                 <tr><td>";
           echo implode("<br>", $errMsg);
           echo "</td></tr>
                 </table>";
           $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                      " : Error updating user " . $auname . ": " .
                      implode("|", $errMsg) . PEAR_LOG_NOTICE);
           require_once('footer.php');
           die();
        }
        break;
    case "switch" :
        if($uroles[admin]) {
           $query="select pn_uname, pn_pass 
                   from users 
                   where md5(pn_uname)='$auname'";
           $result=$dbconn->execute($query);
   
           list($suuser, $supass) = $result->fields;
   
           // get the users roles and stick them in the session
           $_SESSION['roles'] = getUserRoles($suuser);


           $_SESSION['pass'] = $supass;
           $_SESSION['user'] = $suuser;

           $username=$suuser;

           echo "Successfully switched to user $suuser.<br>";
           $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                      " : Switched to user " . $suuser . ' - (' . 
                      implode(",",array_keys($_SESSION['roles'])) . 
                      ')', PEAR_LOG_NOTICE);
           require_once('footer.php');

           die();
        } else {
           echo "Error - Only users with Admin rights can switch users.<br>";
           $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                      " : Error - non-admin attempted to switch user to " .
                      $suuser, PEAR_LOG_NOTICE);
           require_once('footer.php');

           die();
           
        }
        break;
    default :
        break;
    }

    $query="select pn_uname, pn_email, created, lastaccessed 
            from users";
    $result=$dbconn->execute($query);
    echo <<<EOT
<table summary="User List" border=1>
<tr>
<th>Login Name</th>
<th>Email</th>
<th>Created</th>
<th>Last Login</th>
<th>&nbsp;</th>
<th>&nbsp;</th>
<th></th></tr>
EOT;
    while(!$result->EOF) {
        list($auser, $auemail, $created, $lastaccessed) = $result->fields;
        $md5auser=md5($auser);
        echo <<<EOT
<tr>
<td>$auser</td><td>$auemail</td>
<td>$created</td>
<td>$lastaccessed</td>
<td><a href="admin.php?op=edit&amp;auname=$auser" text="Edit User"><img src="images/pencil.png" alt="Edit User"></img></a></td>
<td><a href="admin.php?op=delete&amp;auname=$auser" text="Delete User"><img src="images/delete.png" alt="Delete User"></img></a></td>
<td><a href="admin.php?op=switch&amp;auname=$md5auser">Switch User</a></td>
</tr>
EOT;
        $result->MoveNext();
    }
    echo "</table>";

    if($op=="pass") {
        if ($pass1<>"" and $pass2<>"") {
           $goodPass = checkPass($pass1);
           $pass1=md5($pass1);
           $pass2=md5($pass2);
           if ($pass1==$pass2 && $goodPass == "pass") {
              $query="update users set pn_pass='$pass1' 
                      where pn_uname='$auname'";
              $result=$dbconn->execute($query);
              echo "<B>Password has been reset.</B><br>";
              $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                         " : Reset password for " . $auname, PEAR_LOG_NOTICE);

              if ($auname==$username) {
                 $_SESSION['pass'] = $pass1;
              }
           } else {
              if($goodPass != "pass") {
                 echo <<<EOT
<FONT COLOR="#FF0000"><B>
Cannot reset password, provided password doesn't meet 
minimum standards ($goodPass).</B> <br>
<PRE>
(min Length = $minLength, 
 max Length = $maxLength, 
 min Alpha = $minAlpha,
 min Number = $minNumber, 
 min Upper = $minUpper,
 min Lower = $minLower, 
 min Special = $minSpecial)
</PRE>
</FONT><br>
EOT;
                 $logh->log("$username : " . $_SERVER['PHP_SELF']  .
                            " : Reset password failed - " . $goodPass ."  - " .
                            $auname, PEAR_LOG_DEBUG);
              } else {
                  echo <<<EOT
<FONT COLOR="#FF0000"><B>Could not reset password 
for user <I>$auname</I>. Passwords entered do not 
match.</B></FONT><br>
EOT;
                  $logh->log("$username : " . $_SERVER['PHP_SELF']  .
                             " : Reset password failed - mismatch for " .
                             $auname, PEAR_LOG_DEBUG);
              }
           }
        } else {
           echo "<FONT COLOR=\"#FF0000\"><B>Cannot use a blank password.
                 </B></FONT><br>";
           $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                      " : Reset password fail - blank password for " . 
                      $auname, PEAR_LOG_DEBUG);

        }
        $op="";
    }

    switch ($op) {
    case "edit" :
        // get user info
        $query="select pn_email, expire, locked  
                from users 
                where pn_uname='$auname'";
        $result=$dbconn->execute($query);
        list($aemail, $expire, $locked)=$result->fields;
        // get user groups
        $query = "SELECT groups.gid, groupName
                  FROM groups
                  LEFT JOIN user_groups
                  ON groups.gid = user_groups.gid
                  WHERE user_groups.pn_uname = '$auname'";
        $result = $dbconn->GetArray($query);
        if($result === false) {
           echo "SQL Error: " . $dbconn->ErrorMsg();
        } else {
           $ugroups = array();
           foreach($result as $group) {
              $ugroups[$group['gid']] = $group['groupName'];
           }
        }

        // get user role info
        $proles = array();
        $query = "SELECT r.roleID, r.roleName 
                  FROM user_roles as ur
                  LEFT JOIN roles as r ON ur.roleID = r.roleID
                  WHERE ur.pn_uname = '$auname'";
        $results = $dbconn->GetArray($query);
        if($results === false) {
           echo "SQL Error: " . $dbconn->ErrorMsg();
        } else {
           foreach ($results as $role) {
              $proles[$role['roleID']] = "Y"; //$results->fields[0];
           }
        }

        $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                   " : Select user for editing - " . $auname, PEAR_LOG_INFO);

        // create the groups pull-down
        $gquery = "SELECT gid, groupName
                   FROM groups
                   ORDER BY groupName ASC";
        $gresult = $dbconn->GetArray($gquery);
        if($gresult === false) {
           echo "SQL Error:  " . $dbconn->ErrorMsg();
           require_once('footer.php');
           die();
        }
        $ghtml .= "<select name='groups[]' multiple size=5>";
        foreach($gresult as $group) {
           $sel = "";
           if(in_array($group['groupName'],$ugroups)) { $sel = "selected"; }
           $ghtml .= "<option value='$group[gid]' $sel>$group[groupName]</option>";
        }
        $ghtml .= "</select>";
        
        // create HTML for the roles checkboxes (may need to redo as a select)
        $rhtml = "";
        foreach($allRoles as $roleID=>$roleData) {
           $selected = ($proles[$roleID] == "Y") ? "value='Y' checked" : "value='N'";
           $rhtml .= "<input type='checkbox' name='$roleID' $selected>";
           $rhtml .= $roleData['roleName'] . " - " . $roleData['roleDesc'] .
                     "</input><br>\n";
        }
        echo <<<EOT
<form method="post" action="admin.php">
<input type="hidden" name="op" value="update">
<input type="hidden" name="auname" value="$auname">
<p></p>
Edit User: <b>$auname</b><br>
<table summary="Edit User Details">
<tr>
<td>Email</td>
<td><input type="text" name="aemail" value="$aemail"></td>
</tr>
<tr>
<td>Groups</td>
<td>$ghtml</td>
</tr>
<tr>
<td>Permissions</td>
<td>$rhtml
</td>
</tr>
<tr>
<td>Account Expiration<br>
YYYYMMDD</td>
<td><input type="text" name="expire" value="$expire">
<input type="checkbox" name="locked" value="Y" 
EOT;
        if ($locked>=5) {echo "checked";}
        echo <<<EOT
>Account Locked
</td></tr>
</table>

<input type="submit" name="submit" value="Update Account">
</form>
EOT;

        if ($auname<>"") {
            echo <<<EOT
<form method="post" action="admin.php">
<input type="hidden" name="op" value="pass"><input type="hidden" name="auname" value="$auname">
<b>Reset Password:</b><BR>
<table summary="Change password">
<tr><td>Password:</td>
<td><input type="password" name="pass1" value=""></td>
</tr>
<tr>
<td>Confirm Password</td>
<td><input type="password" name="pass2" value=""></td>
</tr>
</table>
<input type="submit" name="submit" value="Reset Password">
</form>
EOT;
        }
        break;
    case $op=="" :
    default : // new user
       // create roles checkbox HTML
       $rhtml = $ghtml =  "";
       foreach ($allRoles as $roleID => $roleData) {
          $rhtml .= "<input type='checkbox' name='$roleID' value='N'>" .
                    $roleData['roleName'] . " - " .  $roleData['roleDesc'] .
                    "</input><br>";
       }
       // create the groups pull-down
       $gquery = "SELECT groupName
                  FROM groups
                  ORDER BY groupName ASC";
       $gresult = $dbconn->GetArray($gquery);
       if($gresult === false) {
          echo "SQL Error:  " . $dbconn->ErrorMsg();
          require_once('footer.php');
          die();
       }
       $ghtml .= "<select name='groups[]' multiple size=5>";
       foreach($gresult as $group) {
          $ghtml .= "<option value='$group[groupName]'>$group[groupName]</option>";
       }
       $ghtml .= "</select>";
       echo <<<EOT
<p></p>
<form method="post" action="admin.php">
<input type="hidden" name="op" value="add">
<table summary="New user details">
<tr><td>Username</td>
<td><input type="text" name="auname" value=""></td>
</tr>
<tr>
<td>Email</td>
<td><input type="text" name="aemail" value=""></td>
</tr>
<tr>
<td>Password</td>
<td><input type="password" name="pass1" value=""></td>
</tr>
<tr>
<td>Confirm Password</td>
<td><input type="password" name="pass2" value=""></td>
</tr>
<tr>
<td>Groups</td>
<td>$ghtml</td>
</tr>
<tr>
<td>Permissions</td>
<td>$rhtml
</td>
</tr>
<tr>
<td>Account Expiration<br>
YYYYMMDD</td>
<td><input type="text" name="expire" value="">
<input type="checkbox" name="locked" value="Y">Account Locked
</td></tr>
</table>
<input type="submit" name="submit" value="Add New User">
</form>
EOT;
        break;
      #  default :
      #break;
      # NOTE: There is something weird happening here.
      # This is theoretically the same logic flow as the old
      # version, but it doesnt allow new users to be added.
      # need to recheck.
      # temp fix was to move the default branch of the switch
    }
}
require_once('footer.php');
?>
