<?php
/*
 * Page to allow user to View/Edit a scan result exception.
 * Exceptions are stored in the exceptions table in the DB.
 *
 */

$pageTitle = "View/Edit Exception";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('adodb/tohtml.inc.php');

$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
           ": Accessed Page", PEAR_LOG_DEBUG);

// validate rights to view this page
/*
$admin = (strpos($_SESSION['roles'],"admin") === false) ? FALSE : TRUE;
$eapprove = (strpos($_SESSION['roles'],"eapprove") === false) ? FALSE : TRUE;
$esubmit = (strpos($_SESSION['roles'],"esubmit") === false) ? FALSE : TRUE;
$eview = (strpos($_SESSION['roles'],"eview") === false) ? FALSE : TRUE;
*/

if (!$uroles[nessus] && !$uroles[admin] && !$uroles[eapprove] && 
    !$uroles[esubmit] && !$uroles[eview]) {
  // oops, shouldn't be here
  echo "Insufficient rights to view this page.";
  require_once('footer.php');
  // should do this better, but it'll work for now.
  die();
}

$getParams = array ( "op", "eid", "prevPage" );
$postParams = array( "op", "submit", "eid", "justification", "type",
                     "status", "os", "comments", "justification",
                     "secRqmts", "ip", "plugin", "save", "approve", "port",
                     "prevPage" );
switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      }
   }
	break;
case "POST" :
   foreach($postParams as $pp) {
      if(isset($_POST[$pp])) {
         $$pp = htmlspecialchars(mysql_escape_string(trim($_POST[$pp])),ENT_QUOTES);
      }
   }
	break;
}


/* not used at the moment
switch ($op) {
case "view":
   break;
case "edit":
   break;
case "del":
   break;
default:
   break;
}
*/

// create a new exception in the DB
if ($op == "create" && ($uroles[eapprove] || $uroles[esubmit])) {
   if(!isset($eid) || !isset($ip) || !isset($plugin) || !isset($type)) {
      echo "Invalid request: Missing required information."; 
      require_once("footer.php");
      die();
   }
   // same person can't submit and approve exception, force separation
   //if(!$eapprove) { // force new entry to Pending status if not approver
      $status = "Pending";
      $closeDate = "NULL";
   //} elseif ($status == "Approved") {
   //   $closeDate = "'" . date("Y-m-d H:i:s") . "'";
   //   $approver = $username;
   //}
   //if($closeDate == "") { $closeDate = "NULL"; }
   $lastModified = date("Y-m-d H:i:s");
   if($submitDate == "") { $submitDate = $lastModified; }
   //$lastEditor = $submitter = $username;
   if($port == "") { $port = "NULL"; }
   $create = "INSERT INTO exceptions (eid, ip, hostname, type, os, status,
                                      comments, justification, secRqmts,
                                      submitDate, closeDate, approver, 
                                      plugin, port, lastModified,
                                      submitter, lastEditor)
              VALUES ('$eid', '$ip', '$hostname', '$type',
                      '$os', '$status', '$comments',
                      '$justification', '$secRqmts',
                      '$submitDate', $closeDate, 
                      '$approver', '$plugin', $port,
                      '$lastModified', '$username', '$username')";
   if (! $dbconn->execute($create) === false ) {
      echo "Exception $eid saved.";
      echo "<p>Return to <a href='$prevPage'>Exceptions</a> list.</p>";
      echo "<p>Add another <a href='editException.php?op=new'>New Exception</a>.</p>";

      $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                 ": Created exception $eid", PEAR_LOG_DEBUG);
   } else {
      echo "There was a problem saving the exception: <br>";
      echo $dbconn->ErrorMsg();
   }
}

// delete exception
if ($op == "del") {
   if(!isset($eid)) {
      echo "Invalid request:  Exception ID missing from request.";
      require_once("footer.php");
      die();
   }
   $del="delete from exceptions
         where eid = '$eid'";
   if (! $dbconn->execute($del) === false ) {
      echo "<font color='#666666' size='2'>Exception $eid has been deleted.
            <BR></font>";
      echo "<p>Return to <a href='exceptions.php'>Exceptions</a> list.</p>";
      $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                 ": Deleted exception $eid", PEAR_LOG_DEBUG);
   } else {
      echo "There was a problem deleting the exception: <br>";
      echo $dbconn->ErrorMsg();
   }
}

// for view or edit, get the exception details and draw table
if ($op == "edit" || $op == "view") {
   // set a flag for use in painting tables
   if( $op == "edit" && ($uroles[eapprove] || $uroles[esubmit])) {
      $displayForm = TRUE;
   } elseif ($op == "view") {
      $displayForm = FALSE;
   } else {
      echo "Insuffient rights to edit an exception.";
      require_once('footer.php');
      die();
   }

   $query="SELECT e.submitDate, e.closeDate, e.approver, e.status, e.plugin,
                  e.type, e.application, e.os, e.justification, e.port,
                  e.comments, e.secRqmts, e.ip, e.hostname, e.eid,
                  e.submitter, e.lastModified, e.lastEditor
           FROM exceptions as e 
           WHERE e.eid = '$eid'";

   $result=$dbconn->execute($query);
   $data = $result->fields;

   // form with inputs only if user has edit/approval rights
   if ($displayForm) {
      echo "<H3>Edit Exception</H3>";
      // build a link to the plugin info
      $pluginLink = "<a class='legend' href='lookup.php?id=$data[plugin]'
                     onClick=\"return popup('lookup.php?id=$data[plugin]',
                     'PluginLookup');\">
                     <img src='images/info.png' alt='Info' border=0></a>";
      // build the status pulldown
      $statOptions = array( "Pending", "Rejected", "Approved" );
      foreach ($statOptions as $so) {
         if ($so == $data[status]) {
            $statPull .= "<option selected value=\"$so\">$so</option>";
         } else {
            $statPull .= "<option value=\"$so\">$so</option>";
         }
      }
      // build the type pulldown
      $typeOptions = array('False Positive', 
                           'Ambiguous Vulnerability', 
                           'True Positive');
      foreach ($typeOptions as $to) {
         if ($to == $data[type]) {
            $typePull .= "<option selected value=\"$to\">$to</option>";
         } else {
            $typePull .= "<option value=\"$to\">$to</option>";
         }
      }

      echo "<p><a href='$prevPage'>Back to Exception List</a></p>";
      // fields are editable only if the exception is pending
      if($data[status] == "Approved" || $data[status] == "Rejected") {
         echo "<p>This exception must be Unapproved to be edited.</p>";
         $fip = $data[ip];
         $fos = $data[os];
         $ft = $data[type];
         $fj = $data[justification];
         $fc = $data[comments];
         $fr = $data[secRqmts];
         $fp = $data[port];
      } else {
         $fip = "<input name='ip' value='$data[ip]'></input>";
         $fp = "<input name='port' value='$data[port]'></input>";
         $fos = "<input name='os' value='$data[os]' size='32'>";
         $ft = "<select name='type'>$typePull</select>";
         $fj = "<textarea name='justification' rows='4' cols='50'>$data[justification]</textarea>";
         $fc = "<textarea name='comments' rows='4' cols='50'>$data[comments]</textarea>";
         $fr = "<textarea name='secRqmts' rows='4' cols='50'>$data[secRqmts]</textarea>";
#         $fj = "<textarea name='justification' rows='4' cols='50' onkeyup='this.value = this.value.slice(0,65000)'>$data[justification]</textarea>";
#         $fc = "<textarea name='comments' rows='4' cols='50' onkeyup='this.value=this.value.slice(0,65000)'>$data[comments]</textarea>";
#         $fr = "<textarea name='secRqmts' rows='4' cols='50' onkeyup='this.value=this.value.slice(0,65000)'>$data[secRqmts]</textarea>";
      }

      echo <<<EOT
<form action="editException.php" method="post">
<table summary="Edit Exception" border=1 cellspacing="0" cellpadding="2">
<tr>
   <th>Exception ID</th>
   <td>$eid</td></tr>
<tr>
   <th>Hostname</th>
   <td>$data[hostname]</td></tr>
<tr>
   <th>IP</th>
   <td>$fip</td></tr>
<tr>
   <th>Port</th>
   <td>$fp (leave blank for any port)</td></tr>
<tr>
   <th>Plugin</th>
   <td>$data[plugin] $pluginLink</td></tr>
<tr>
   <th>O/S</th>
   <td>$fos</td></tr>
<tr>
   <th>Status</th>
<!--  <td><select name="status">$statPull</select></td></tr>-->
  <td>$data[status]</td></tr>
<tr>
   <th>Type</th>
   <td>$ft</td></tr>
<tr>
   <th>Justification</th>
   <td>$fj</td></tr>
<tr>
   <th>Comments</th>
   <td>$fc</td></tr>
<tr>
   <th>Security Requirements</th>
   <td>$fr</td></tr>
<tr>
   <th>Submitted By</th>
   <td>$data[submitter]</td></tr>
<tr>
   <th>Submit Date</th>
   <td>$data[submitDate]</td></tr>
<tr>
   <th>Last Modified By</th>
   <td>$data[lastEditor]</td></tr>
<tr>
   <th>Last Modified</th>
   <td>$data[lastModified]</td></tr>
<tr>
   <th>Closed By</th>
   <td>$data[approver]</td></tr>
<tr>
   <th>Close Date</th>
   <td>$data[closeDate]</td></tr>
</table>
<input type="hidden" name="op" value="save">
<input type="hidden" name="laspPage" value="$prevPage">
<input type="hidden" name="eid" value="$eid">
EOT;
      switch ($data[status]) {
      case "Approved":
      case "Rejected":
         echo "<input type='submit' name='save' value='Unapprove'>";
         break;
      case "Pending":
         echo "<input type='submit' name='save' value='Update'>";
         // can't approve an exception you submit
         if($username != $data[submitter]) {
            echo "<input type='submit' name='save' value='Approve'>";
         }
         echo "<input type='submit' name='save' value='Reject'>";
         break;
      default:
         break;
      }
      echo "</form>";
   } else {
      echo "<H3>View Exception</H3>";
      echo "<p><a href='$prevPage'>Back to Exception List</a>";
      if($uroles[esubmit] || $uroles[eapprove]) {
         echo " |  <a href='editException.php?op=edit&eid=$eid&prevPage=$prevPage'>Edit This Exception</a>";
      }
      echo "</p>";
      echo <<<EOT
<table summary="View Exception" border=1 cellspacing="0" cellpadding="2">
<tr>
   <th>Exception ID</th>
   <td>$eid</td></tr>
<tr>
   <th>Hostname</th>
   <td>$data[hostname]</td></tr>
<tr>
   <th>IP</th>
   <td>$data[ip]</td></tr>
<tr>
   <th>Port</th>
   <td>$data[port]</td></tr>
<tr>
   <th>Plugin</th>
   <td>$data[plugin]</td></tr>
<tr>
   <th>O/S</th>
   <td>$data[os]</td></tr>
<tr>
   <th>Status</th>
   <td>$data[status]</td></tr>
<tr>
   <th>Type</th>
   <td>$data[type]</td></tr>
<tr>
   <th>Justification</th>
   <td>$data[justification]</td></tr>
<tr>
   <th>Comments</th>
   <td>$data[comments]</td></tr>
<tr>
   <th>Security Requirements</th>
   <td>$data[secRqmts]</td></tr>
<tr>
   <th>Submitted By</th>
   <td>$data[submitter]</td></tr>
<tr>
   <th>Submit Date</th>
   <td>$data[submitDate]</td></tr>
<tr>
   <th>Last Modified By</th>
   <td>$data[lastEditor]</td></tr>
<tr>
   <th>Last Modifed</th>
   <td>$data[lastModified]</td></tr>
<tr>
   <th>Closed By</th>
   <td>$data[approver]</td></tr>
<tr>
   <th>Close Date</th>
   <td>$data[closeDate]</td></tr>
</table>
EOT;
   }
}

// save any changes
if($op == "save") {
   if($uroles[esubmit] || $uroles[eapprove]) {
      $now = date("Y-m-d H:i:s");
      $update = "UPDATE exceptions SET ";
      $notSubmitter = "";
      switch ($save) {
      case "Approve":
         if(!$uroles[eapprove]) {
            echo "Error - insufficient rights to approve exception request.";
            require_once('footer.php');
            die();
         } else {
            $sets[] = "status = 'Approved'"; 
            $sets[] = "closeDate = '$now'"; 
            $sets[] = "approver = '$username'"; 
            $logMsg = "Exception $eid Approved";
         }
         // add to the where clause to prevent the submitter from approving
         // an exception
         $notSubmitter = " AND submitter <> '$username'";
         break;
      case "Unapprove":
         $sets[] = "status = 'Pending'"; 
         $sets[] = "closeDate = NULL"; 
         $sets[] = "approver = NULL"; 
         $logMsg = "Exception $eid marked Pending";
         break;
      case "Rejected":
         $sets[] = "status = 'Rejected'"; 
         $sets[] = "closeDate = '$now'"; 
         $sets[] = "approver = '$username'"; 
         $logMsg = "Exception $eid Rejected";
         break;
      case "Update":
         if($port == "") { 
            $sets[] = "port = NULL"; 
         } else {
            $sets[] = "port = $port";
         }
         $sets[] = "os = '$os'";
         $sets[] = "ip = '$ip'";
         //$sets[] = "hostname = '$hostname'";
         $sets[] = "justification = '$justification'";
         $sets[] = "comments = '$comments'";
         $sets[] = "secRqmts = '$secRqmts'";
         $sets[] = "type = '$type'"; 
         $logMsg = "Exception $eid Updated";
         break;
      }
      $sets[] = "lastEditor = '$username'";
      $sets[] = "lastModified = '$now'";
      $update .= implode(",", $sets) . " WHERE eid = '$eid'";
      $update .= $notSubmitter;
      if (! $dbconn->execute($update) === false ) {
         echo $logMsg;
         echo "<p>Return to <a href='$prevPage'>Exceptions</a> list.</p>";
         $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                    ": $logMsg", PEAR_LOG_DEBUG);
      } else {
         echo "There was a problem updating the exception:<br>";
         echo $dbconn->ErrorMsg();
      }
   }
}

// create new exception
if ($op == "new") {
   if($uroles[esubmit] || $uroles[eapprove]) {
      echo "<H3>New Exception</H3>";
      // build the status pulldown
      // always created in Pending state
      // can't approve own exception request
      //if(!$eapprove) {
         $statPull = "Pending";
      //} else {
      //   $statPull = "<select name='status'>";
      //   $statOptions = array( "Pending", "Rejected", "Approved" );
      //   foreach ($statOptions as $so) {
      //      $statPull .= "<option value=\"$so\">$so</option>";
      //   }
      //   $statPull .= "</select>";
      //}

      // build the exception type pulldown
      $typePull = "<select name='type'>";
      $typeOptions = array('False Positive', 
                           'Ambiguous Vulnerability', 
                           'True Positive');
      foreach ($typeOptions as $to) {
         $typePull .= "<option value=\"$to\">$to</option>";
      }
      $typePull .= "</select>";

      // see if we were called from the a scan report/results page
      // and therefore have some of the info already
      $getParams = array("auto","hostname", "ip", "os", "plugin", "sid", 
                         "rid", "port");
      foreach ($getParams as $inData) {
         if(isset($_GET[$inData])) {
            $newData[$inData]=htmlspecialchars(mysql_real_escape_string(trim($_GET[$inData])), ENT_QUOTES); 
         }
      }

      // see if we have this host in the hosts table
      $hquery = "SELECT os
                 FROM hosts ";
      if(isset($ip)) {
         $hquery .= "WHERE ip='$ip'";
      } elseif(isset($hostname)) {
         $hquery .= "WHERE hostname='$hostname'";
      }
      $newData['os'] = $dbconn->GetOne($hquery);


      // create the pull-downs for the plugin and O/S fields if this wasn't
      // sent in the GET call and doesn't exist in the hosts table
      if(!isset($newData['os'])) {
         $query = "SELECT DISTINCT(os) 
                   FROM hosts
                   ORDER BY os ASC";
         $results = $dbconn->execute($query);
         $osVal = $results->GetMenu('os');
         //$osVal = "<select name='os'>";
         //foreach ($results->GetArray() as $osOpt) {
         //   $osVal .= "<option value=\"$osOpt\">$osOpt</option>\n";
         //}
         //$osVal .= "</select>";
      } else {
         $osVal = "<input name='os' value='$newData[os]'></input>";
      }
      if(!isset($newData['plugin'])) {
         $query = "SELECT id 
                   FROM plugins
                   ORDER BY id ASC";
         $results = $dbconn->execute($query);
         $plugVal = $results->GetMenu('plugin');
         //$plugVal = "<select name='plugin'>";
         //foreach ($results->GetArray() as $p=>$d) {
         //   $plugVal .= "<option value=\"$p\">$d</option>\n";
         //}
         //$plugVal .= "</select>";
      } else {
         $plugVal = "<input name='plugin' value='$newData[plugin]'></input>";
      }

      // create the exception ID
      $eid = substr($username,0,4) . "-" . time();
      // set the submitDate to the current time
      $submitDate = date("Y-m-d H:i:s");

      echo <<<EOT
<form action="editException.php" method="post">
<table summary="New Exception" border=1 cellspacing="0" cellpadding="2">
<tr>
   <th>Exception ID</th>
   <td>$eid</td></tr>
<tr>
   <th>Hostname</th>
   <td><input name="hostname" value="$newData[hostname]"></input> (use ANY for all hosts)</td></tr>
<tr>
   <th>IP</th>
   <td><input name="ip" value="$newData[ip]"></input> (use ALL for all hosts)</td></tr>
<tr>
   <th>Port</th>
   <td><input name="port" value="$newData[port]"></input> (leave blank for any port)</td></tr>
<tr>
   <th>Plugin</th>
   <td>$plugVal</td></tr>
<tr>
   <th>O/S</th>
   <td>$osVal</td></tr>
<tr>
   <th>Status</th>
   <td>$statPull</td></tr>
<tr>
   <th>Type</th>
   <td>$typePull</td></tr>
<tr>
   <th>Justification</th>
<!--   <td><textarea name='justification' rows='4' cols='50' onkeyup='this.value=this.value.slice(0,65000)'></textarea></td></tr> -->
   <td><textarea name='justification' rows='4' cols='50'></textarea></td></tr>
<tr>
   <th>Comments</th>
<!--   <td><textarea name='comments' rows='4' cols='50' onkeyup='this.value=this.value.slice(0,65000)'></textarea></td></tr> -->
   <td><textarea name='comments' rows='4' cols='50'></textarea></td></tr>
<tr>
   <th>Security Requirements</th>
<!--   <td><textarea name='secRqmts' rows='4' cols='50' onkeyup='this.value=this.value.slice(0,65000)'></textarea></td></tr> -->
   <td><textarea name='secRqmts' rows='4' cols='50'></textarea></td></tr>
<tr>
   <th>Submit Date</th>
   <td>$submitDate</td></tr>
</table>
<input type="hidden" name="op" value="create">
<!--<input type="hidden" name="submitDate" value="$submitDate">-->
<input type="hidden" name="prevPage" value="$prevPage">
<input type="hidden" name="eid" value="$eid">
<input type="submit" name="submit" value="Create">
EOT;
      //if(!$eapprove) { 
      //   echo "<input type='hidden' name='status' value='Pending'>";
      //}
      echo "</form>";
   } else {
      echo "Insufficient rights to create a new exception request.";
      require_once('footer.php');
      die();
   }
}

require_once('footer.php');
?>
