<?php

$pageTitle = "Exceptions";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');
$perPage = 25;

if(!$uroles['eview'] && !$uroles['admin'] && !$uroles['esubmit'] && 
   !$uroles['eapprove']) {
   echo "Insufficient rights to view this page.";
   require_once('footer.php');
   die();
}

$getParams = array ( "offset" , "view", 'sortby', 'sortdir' );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) {
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
	break;
}

if(isset($offset)) {
   if(!is_numeric($offset)) {
      $offset=0;
   }
} else {
   $offset=0;
}

$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
           " : Accessed Page", PEAR_LOG_DEBUG);
echo "<H3>Vulnerability Exceptions</H3>";
// for links back to whence you came
$prevPage = htmlentities($_SERVER['REQUEST_URI']);
//$prevPage = htmlspecialchars((trim($_SERVER['REQUEST_URI'])), ENT_QUOTES);

$query="SELECT count(*) from exceptions";
$result=$dbconn->execute($query);
$count=$result->fields[0];
if($count == 1)
   $text = "is $count exception";
else 
   $text = "are $count exceptions";
echo <<<EOT
There $text in the database.
<p>
<a href='editException.php?op=new&prevPage=$prevPage'>Add New Exception</a> | 
<a href="exportExceptions.php">Export Exceptions to Excel</a>
<p>
EOT;

// build the pager
$pager = "";
if ($count > $perPage) {
   $previous = $offset - $perPage;
   if ($previous < 0) {
      $previous = 0;
   }
   $last = $count - $perPage;
   $next = $offset + $perPage;
   if ($next > $last) {
      $next = $last;
   }

   $pager = "<p><a href='exceptions.php?offset=0' class='pager'>&lt&lt First </a> | ";
   if($previous > 0) {
      $pager .= "<a href='exceptions.php?offset=$previous' class='pager'>&lt Previous </a> | ";
   }
   $pageEnd = $offset + $perPage;
   $pager .= " [$offset - $pageEnd of $count] | ";
   if($next < $last) {
      $pager .= "<a href='exceptions.php?offset=$next' class='pager'>| Next &gt;</a> | ";
   }
   $pager .= "<a href='exceptions.php?offset=$last' class='pager'> Last &gt;&gt;</a></p>";
}

echo $pager;


// set the correct order, default is by status and submitDate
switch($sortby) {
case "submitDate":
   $obc = "ORDER BY submitDate $sortdir";
   break;
case "eid":
   $obc = "ORDER BY eid $sortdir";
   break;
case "port":
   $obc = "ORDER BY port $sortdir";
   break;
case "approver":
   $obc = "ORDER BY approver $sortdir";
   break;
case "closeDate":
   $obc = "ORDER BY closeDate $sortdir";
   break;
case "type":
   $obc = "ORDER BY type $sortdir";
   break;
case "status":
   $obc = "ORDER BY status $sortdir";
   break;
case "plink":
   $obc = "ORDER BY plugin $sortdir";
   break;
case "hlink":
   $obc = "ORDER BY hostname $sortdir";
   break;
case "ilink":
   $obc = "ORDER BY ip $sortdir";
   break;
default:
   $obc = "ORDER BY status ASC, submitDate DESC";
   break;
}

if($view == "pending") {
   $whereclause = "WHERE status = 'Pending' ";
} else {
   $whereclause = "";
}
 
$limit = "LIMIT $offset, $perPage";

$query = "SELECT eid, submitDate, status, plugin, type, ip, 
                 closeDate, approver, hostname, port
          FROM exceptions 
          $whereclause
          $obc
          $limit";

$result=$dbconn->GetArray($query);

$tdata = array();
foreach($result as $data) {
   if($data['hostname'] == "ANY" || $data['ip'] == "ALL") {
      $data['hlink'] = $data['hostname'];
      $data['ilink'] = $data['ip'];
   } else {
      $data['hlink'] = hostLink($data['hostname'],$data['ip'],"name",FALSE);
      $data['ilink'] = hostLink($data['hostname'],$data['ip'],"ip",FALSE);
   }
   $data['plink'] = "<a href='lookup.php?id=" . $data['plugin'] . 
                    "' target='_blank'>" .
                     $data['plugin'] . "</A>";
   $tdata[] = $data;
}

$elinks = array( "View" => array(
                      'url' => "editException.php?op=view&prevPage=" .
                               $prevPage . "&eid=%param%",
                      'param' => 'eid',
                      'icon' => 'images/zoom.png')) ;
if($uroles['eapprove'] || ($uroles['esubmit'] && 
   ($data['status'] == "Pending"))) {
   $elinks2 = array( "Edit" => array(
                         'url' => "editException.php?op=edit&prevPage=" .
                                  $prevPage . "&eid=%param%",
                         'param' => 'eid',
                         'icon' => 'images/pencil.png'),
                     "Delete" => array(
                         'url' => "editException.php?op=del&prevPage=".
                                   $prevPage . "&eid=%param%",
                         'param' => 'eid',
                         'icon' => "images/cross.png"));
}
$elinks = array_merge($elinks,$elinks2);

if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
$baseURL = $_SERVER['PHP_SELF'] . "?view=$view&sortby=%var%&sortdir=$sortdir";
$tableFieldMap = array( "Submit Date" => array( 'var' => "submitDate",
                                                'link' => $baseURL ),
                        "Exception ID" => array( 'var' => "eid",
                                                 'link' => $baseURL ),
                        "Hostname" => array( 'var' => "hlink",
                                             'link' => $baseURL ),
                        "IP" => array( 'var' => "ilink",
                                       'link' => $baseURL ),
                        "Port" => array( 'var' => "port",
                                         'link' => $baseURL ),
                        "Plugin ID" => array( 'var' => "plink",
                                              'link' => $baseURL ),
                        "Status" => array( 'var' => "status",
                                           'link' => $baseURL ),
                        "Type" => array( 'var' => "type",
                                         'link' => $baseURL ),
                        "Close Date" => array( 'var' => "closeDate",
                                               'link' => $baseURL ),
                        "Approver" => array( 'var' => "approver",
                                             'link' => $baseURL ),
                        "Links" => $elinks );

drawTable($tableFieldMap, $tdata, "Exceptions");

echo $pager;

echo <<<EOT
<p>
<a href='editException.php?op=new'>Add New Exception</a> | 
<a href="exportExceptions.php">Export Exceptions to Excel</a>
<p>
EOT;

require_once('footer.php');
?>
