<?php

require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once("jpgraph/jpgraph.php");
require_once("jpgraph/jpgraph_line.php");
require_once('permissions.inc.php');

$getParams = array( "uid", "allres", "schedule", "sid",
                    "days", "rrisk", "ip" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
	break;
}

// admin and reports roles have extra permissions, check if user has either
/*
$admin = (strpos($_SESSION['roles'],"admin") === false) ? FALSE : TRUE;
$reports = (strpos($_SESSION['roles'],"reports") === false) ? FALSE : TRUE;
*/

$allowedAccess = ($uroles['admin'] || $uroles['reports']) ? TRUE : FALSE;

$uid_filter=0;
if ($uid<>"") {
   $uid_filter=1; 
}

if (!$allowedAccess) { 
   $uid=$username; 
} else {
   if (!$uid_filter) { 
      $uid=$username; 
   }
}

if (!$allres) {
   $sql_onlybyuser="username='$uid'";
   $sql_byuser=$sql_onlybyuser." and ";
   $sql_nsubyuser="nessus_settings_users.".$sql_byuser;
} else {
   if (!$allowedAccess) { 
      JpGraphError::Raise(" Permission denied - you are not an admin. "); 
   }
   $sql_onlybyuser="";
   $sql_byuser="";
   $sql_nsubyuser="";
}

if ($schedule<>"") {
   if(!is_numeric($schedule)) { 
      JpGraphError::Raise(" Incorrect parameter - schedid not numeric. "); 
   }
   $query="select count(id) 
           from nessus_schedule 
           where ".$sql_byuser."id=$schedule";
   $result=$dbconn->execute($query);
   list($allowaccess)=$result->fields;
   if ($allowaccess<1) { 
      JpGraphError::Raise(" Incorrect parameter - schedule id or Permission denied. "); 
   }
# Commented out as not used anywhere else
#    $img.="&amp;schedule=$schedule";
#    $msg2="$schedule";
}
if ($sid<>"") {
   if(!is_numeric($sid)) { 
      JpGraphError::Raise(" Incorrect parameter - sid not numeric. "); 
   }
   $query="select count(nessus_settings.id) 
           from nessus_settings 
           inner join nessus_settings_users 
              on nessus_settings.id=nessus_settings_users.sid 
           where ".$sql_nsubyuser."nessus_settings.id=$sid";
   $result=$dbconn->execute($query);
   list($allowaccess)=$result->fields;
   if ($allowaccess<1) { 
      JpGraphError::Raise(" Incorrect parameter - Profile (sid) or 
                            Permission denied. "); 
   }
}
if ($days<>"") {
   if(!is_numeric($days) or $days<0) { 
      JpGraphError::Raise(" Incorrect parameter - days not numeric. "); 
   }
}
if ($rrisk<>"") {
/*
   if(!is_numeric($rrisk)) { 
      JpGraphError::Raise(" Incorrect parameter - risk not numeric. "); 
   }
   if($rrisk<1 or $rrisk>7) { 
      JpGraphError::Raise(" Incorrect parameter - risk out of bounds. "); 
   }
*/
}
if ($ip<>"") {
   require_once('validateip.inc.php');
   if (!inrange($ip, $dbconn)) { 
      JpGraphError::Raise("Incorrect parameter - IP address not found  
                           in a configured Network Zone. "); 
   }
}

$datax=array();
$risk1=array();
$risk2=array();
$risk3=array();
$risk4=array();
$risk5=array();
$risk6=array();
$risk7=array();

$query = "select distinct scantime as vdate 
          from nessus_results ";

$prevandquery=0;
$needwherequery=0;

if ($sql_onlybyuser<>"") {
   $query.="where ".$sql_onlybyuser;
   $prevandquery=1;
} else { 
   $needwherequery=1; 
}

if ($days<>"") {
   if ($needwherequery) { $query.="where "; }
   elseif ($prevandquery) { $query.=" and "; }
   $query.="TO_DAYS(now())-TO_DAYS(scantime)<=$days";
   $prevandquery=1;
   $needwherequery=0;
}

if ($schedule<>"") {
   if ($needwherequery) { $query.="where "; }
   elseif ($prevandquery) { $query.=" and "; }
   $query.="sched_id=$schedule";
   $prevandquery=1;
   $needwherequery=0;
}

if ($ip<>"") {
   if ($needwherequery) { $query.="where "; }
   elseif ($prevandquery) { $query.=" and "; }
   $query.="host='$ip'";
   $prevandquery=1;
   $needwherequery=0;
}

if ($sid<>"") {
   if ($needwherequery) { $query.="where "; }
   elseif ($prevandquery) { $query.=" and "; }
   $query.="sid=$sid";
   $prevandquery=1;
   $needwherequery=0;
}

if ($rrisk<>"") {
   if ($needwherequery) { $query.="where "; }
   elseif ($prevandquery) { $query.=" and "; }
   if(strpos($rrisk, "|")) { // need to explode it
      $i = 0;
      $query .= "( ";
      foreach(explode("|",$rrisk) as $rr) {
         if($i==0) {
            $query .= " risk=$rr ";
         } else {
            $query .= " or risk=$rr ";
         }
         $i=1;
      }
      $query .= " )";
   } else {
      $query.="risk=$rrisk";
   }
   $prevandquery=1;
   $needwherequery=0;
}

$query.=" order by vdate";
//JpGraphError::Raise("query = ".$query); 

$result=$dbconn->execute($query);

$totalrows=0;
while(!$result->EOF) {
   $totalrows = $totalrows + 1;
   list($date)=$result->fields;
   array_push($datax, $date);
   $prevrisk=0;

   $query1="select risk, count(scantime) as vcount 
            from nessus_results 
            where scantime='$date' and " . $sql_byuser .
               "falsepositive<>'Y' and scriptid <> 10180 and msg<>''";

   if ($schedule<>"") {
      $query1.=" and sched_id=$schedule";
   }

   if ($ip<>"") {
      $query1.=" and host='$ip'";
   }

   if ($sid<>"") {
      $query1.=" and sid=$sid";
   }

   if ($rrisk<>"") {
      if(strpos($rrisk, "|")) { // need to explode it
         $i = 0;
         $query1 .= " and ( ";
         foreach(explode("|",$rrisk) as $rr) {
            if($i==0) {
               $query1 .= " risk=$rr ";
            } else {
               $query1 .= " or risk=$rr ";
            }
            $i=1;
         }
         $query1 .= " )";
      } else {
         $query1.=" and risk=$rrisk";
      }
   }

   $query1.=" group by risk order by risk";

//JpGraphError::Raise("query1 = ".$query1); 
   $result1=$dbconn->execute($query1);

   while (list($risk, $riskcount)=$result1->fields) {
      for ($i=0;$i<$risk-$prevrisk-1;$i++) {
         switch ($i+$prevrisk+1) {
         case 1:
            array_push($risk1,0);
            break;
         case 2:
            array_push($risk2,0);
            break;
         case 3:
            array_push($risk3,0);
            break;
         case 4:
            array_push($risk4,0);
            break;
         case 5:
            array_push($risk5,0);
            break;
         case 6:
            array_push($risk6,0);
            break;
         case 7:
            array_push($risk7,0);
            break;
         } #end of switch
      } #end of for

      switch ($risk) {
         case 1:
            array_push($risk1,$riskcount);
            break;
         case 2:
            array_push($risk2,$riskcount);
            break;
         case 3:
            array_push($risk3,$riskcount);
            break;
         case 4:
            array_push($risk4,$riskcount);
            break;
         case 5:
            array_push($risk5,$riskcount);
            break;
         case 6:
            array_push($risk6,$riskcount);
            break;
         case 7:
            array_push($risk7,$riskcount);
            break;
      } #end of switch

      $prevrisk=$risk;
      $result1->MoveNext();
   }

   for ($i=$prevrisk+1; $i<=7; $i++) {
      switch ($i) {
      case 1:
         array_push($risk1,0);
         break;
      case 2:
         array_push($risk2,0);
         break;
      case 3:
         array_push($risk3,0);
         break;
      case 4:
         array_push($risk4,0);
         break;
      case 5:
         array_push($risk5,0);
         break;
      case 6:
         array_push($risk6,0);
         break;
      case 7:
         array_push($risk7,0);
         break;
      } #end of switch
   }
   $result->MoveNext();
} #End of while;

// Create the graph. These two calls are always required
// Setup the graph

$graph = new Graph(640,400,"auto");
$graph->SetScale("textlin");
$graph->SetShadow();
$graph->img->SetAntiAliasing();
$graph->img->SetMargin(70,150,20,100);
$graph->SetMarginColor('white');

$graph->title->Set("$days Day(s) Vulnerability Trend");
$graph->title->SetFont(FF_FONT1,FS_BOLD,12);

$graph->xaxis->SetTickLabels($datax);
$graph->xaxis->SetFont(FF_FONT1,FS_NORMAL,8);
$graph->xaxis->SetLabelAngle(90);
$graph->xaxis->SetTextTickInterval(1);
#$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD,10);
#$graph->xaxis->title->Set("Dates");

$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD,10);
$graph->yaxis->title->Set("Vulnerabilities");


$graph->ygrid->SetFill(true,'#EFEFEF@1','#BBCCFF@0.5');
$graph->xgrid->Show();

//Line thickness for all lines
$linethick = 3;

if($rrisk=="" || $rrisk==1 || strpos($rrisk,"1")) {
   // Create the line
   $p1 = new LinePlot($risk1);
   $p1->SetColor("red");
   $p1->SetLegend('Serious');
   $p1->SetWeight($linethick);
   $graph->Add($p1);
}

if($rrisk=="" || $rrisk==2 || strpos($rrisk,"2")) {
   // Create the line
   $p2 = new LinePlot($risk2);
   $p2->SetColor("yellow");
   $p2->SetLegend('High');
   $p2->SetWeight($linethick + 2);
   $graph->Add($p2);
}

if($rrisk=="" || $rrisk==3 || strpos($rrisk,"3")) {
   // Create the line
   $p3 = new LinePlot($risk3);
   $p3->SetColor("magenta");
   $p3->SetLegend('Medium');
   $p3->SetWeight($linethick);
   $graph->Add($p3);
}

if($rrisk=="" || $rrisk==4 || strpos($rrisk,"4")) {
   // Create the line
   $p4 = new LinePlot($risk4);
   $p4->SetColor("orange");
   $p4->SetLegend('Medium/Low');
   $p4->SetWeight($linethick);
   $graph->Add($p4);
}

if($rrisk=="" || $rrisk==5 || strpos($rrisk,"5")) {
   // Create the line
   $p5 = new LinePlot($risk5);
   $p5->SetColor("navy");
   $p5->SetLegend('Low/Medium');
   $p5->SetWeight($linethick);
   $graph->Add($p5);
}

if($rrisk=="" || $rrisk==6 || strpos($rrisk,"6")) {
   // Create the line
   $p6 = new LinePlot($risk6);
   $p6->SetColor("green");
   $p6->SetLegend('Low');
   $p6->SetWeight($linethick);
   $graph->Add($p6);
}

if($rrisk=="" || $rrisk==7 || strpos($rrisk,"7")) {
   // Create the line
   $p7 = new LinePlot($risk7);
   $p7->SetColor("blue");
   $p7->SetLegend('Info');
   $p7->SetWeight($linethick);
   $graph->Add($p7);
}

$graph->legend->SetShadow('gray@0.4',5);
$graph->legend->SetPos(0.04,0.06,'right','top');
$graph->legend->SetFont(FF_FONT1,FS_NORMAL,10);

// Display the graph
if ($totalrows > 1) {
   $graph->Stroke();
} else {
   JpGraphError::Raise("Only 1 set of results has been found. 2 or more scan results are required to produce a trend graph.");
}

?>
