<?php

$pageTitle = "Hosts";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');
//require_once('adodb/tohtml.inc.php');

// number of hosts to show per page with viewing all
$pageSize = 50;

// check role to make sure user can view this page
/*
$admin = (strpos($_SESSION['roles'],"admin") === false) ? FALSE : TRUE;
$reports = (strpos($_SESSION['roles'],"reports") === false) ? FALSE : TRUE;
$esubmit = (strpos($_SESSION['roles'],"esubmit") === false) ? FALSE : TRUE;
$eapprove = (strpos($_SESSION['roles'],"eapprove") === false) ? FALSE : TRUE;
$eview = (strpos($_SESSION['roles'],"eview") === false) ? FALSE : TRUE;
*/

if (!($uroles[admin] || $uroles[eview] || $uroles[esubmit] || $uroles[eapprove]
      || $uroles[reports])) {
  // oops, shouldn't be here
  echo "Insufficient rights to view this page.";
  require_once('footer.php');
  // should do this better, but it'll work for now.
  die();
}

$getParams = array( "host", "ip", "op", "offset", "type", "os", "status",
                    "value", "scanstate", "ref", "sortby", "sortdir" );
$postParams = array( "op", "ip", "hostname", "status", "contact", "os",
                     "description", "id", "scanstate");

$post = FALSE;

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else {
         $$gp = "";
      }
   }
	break;
case "POST" :
   $post = TRUE;
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) {
        $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else {
        $$pp = "";
      }
   }
	break;
}

if(isset($offset)) {
   if(!is_numeric($offset)) {
      $offset=0;
   }
} else {
   $offset=0;
}

$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
           ": Accessed Page", PEAR_LOG_DEBUG);

echo "<H3>Hosts</H3>";

//$result=$dbconn->execute($query);
//rs2html($result,'border=1 cellpadding=2',array('IP','Hostname','O/S',
//        'Status', 'Description','Contact'));


// add a new entry
if($post && $op=="new") { // means we should have gotten a POST with data
   $insert = "insert into hosts (ip, hostname, status, os, contact,
                 description, scanstate)
              values ('$ip', '$hostname', '$status', '$os', '$contact',
                 '$description', 'Pending Scan')";
   if (! $dbconn->execute($insert) === false ) {
     echo "New host added.<br>";
     $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                 ": Added new host record ($ip)", PEAR_LOG_DEBUG);
   } else { // need error handling here
     echo "There was an error creating the new record.<br>";
     echo $dbconn->ErrorMsg();
   }
   //echo "<p>Return to the <a href='" . $_SERVER['PHP_SELF'] . 
   //     "'>hosts table</a>.";
   if($ref <> "") {
      echo "Return to the <a href='$ref'>calling page</a>.";
   }
   //echo "</p>";
} 

// edit the data in the hosts table
if($post && $op=="edit") { // commit the changes
/*
echo "<PRE>";
print_r($_POST);
echo "</PRE>";
*/
   $update = "update hosts set ip = '$ip', hostname = '$hostname',
                status = '$status', os = '$os', description = '$description',
                contact = '$contact' ";
   if($scanstate == "Fixes Applied - Pending ReScan" && $uroles['esubmit']) {
      $update .= ", scanstate = '$scanstate' ";
   } elseif ($uroles['admin']) {
      $update .=", scanstate = '$scanstate' ";
   }
   $update .= "where id = '$id'";
//echo "<PRE>$update</PRE>";
   if($dbconn->execute($update) === false ) {
      $errMsg[] =  "There was an error updating the record: " . 
                   $dbconn->ErrorMsg();
      dispSQLError($errMsg,1);
   } else {
      echo "<p>Record updated successfully.</p>";
      $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                  ": Updated host record ($id)", PEAR_LOG_DEBUG);
   }
   echo "<p>Return to the <a href='" . $_SERVER['PHP_SELF'] . 
        "'>hosts table</a>.</p>";
}

if($op == "add"){
   $formFields = array ( "Hostname" => array( "name" => "hostname",
                                              "type" => "input",
                                              "size" => 32,
                                              "value" => $host),
                         "IP Address" => array( "name" => "ip",
                                                "type" => "input",
                                                "size" => 32,
                                                "value" => $ip),
                         "O/S" => array( "name" => "os",
                                                "type" => "input",
                                                "size" => 32,
                                                "value" => $os),
                         "Status" => array( "name" => "status",
                                                "type" => "select",
                                                "nameIndex" => 0,
                                                "value" => $serverStateArray,
                                                "selected" => $status),
                         "Description" => array( "name" => "description",
                                                "type" => "input",
                                                "size" => 60,
                                                "maxsize" => 255,
                                                "value" => ""),
                         "Contact" => array( "name" => "contact",
                                                "type" => "input",
                                                "size" => 50,
                                                "value" => ""),
                         "Scan State" => "Pending Scan");

      $formButtons = array( "Submit" => array( "name" => "submit",
                                               "type" => "submit",
                                               "value" => "Save"));
      $formHidden = array( "op" => "new",
                           "ref" => $ref );
      $formData = array( "summary" => "Create Host Entry",
                         "fields" => $formFields,
                         "hidden" => $formHidden,
                         "buttons" => $formButtons);
      drawForm($formData,$_SERVER['PHP_SELF']);
} elseif( $op == "edit" && ( isset($host) || isset($ip) ) &&
         ($uroles['admin'] || $uroles['esubmit'] || $uroles['eapprove']) ) {
   $query="SELECT ip, hostname, os, status, description, 
              contact, id, scanstate
           from hosts";
   if(isset($host) && isset($ip)) {
      $host = strtolower($host);
      $query .= " where hostname = '$host' AND ip = '$ip' order by hostname";
   } elseif (isset($ip)) {
      $query .= " where ip = '$ip' order by INET_ATON(ip) ASC ";
   } elseif (isset($host)) {
      $query .= " where hostname = '$host' order by hostname ";
   }
   $result=$dbconn->execute($query);
   $data = $result->fields;
   echo <<<EOT
<form action="hosts.php" method="post">
<table summary="Edit Host" width="75%" border=1 cellspacing="0" cellpadding="2">
<tr>
   <th>Hostname</th>
   <td><input name='hostname' value='$data[hostname]'></td></tr>
<tr>
   <th>IP</th>
   <td><input name='ip' value='$data[ip]'></td></tr>
<tr>
   <th>O/S</th>
   <td><input name='os' value='$data[os]' size='32'></td></tr>
<tr>
   <th>Status</th>
   <td><input name='status' value='$data[status]' size='32'></td></tr>
<tr>
   <th>Description</th>
   <td><input name='description' value='$data[description]' size='100' maxlength='255'></td></tr>
<tr>
   <th>Contact</th>
   <td><input name='contact' value='$data[contact]' size='32'></td></tr>
<tr>
   <th>Scan State</th>
EOT;
   if($uroles['admin'] || $uroles['esubmit'] || $uroles['eapprove']) {
      echo "<td><select name='scanstate'>";
      foreach ($hostScanStateArray as $ss) {
         if($data['scanstate'] == $ss) {
            echo "<option value='$ss' SELECTED>$ss</option>";
         } else {
            echo "<option value='$ss'>$ss</option>";
         }
      }
      echo "</td></tr>";
   } else {
      echo "<td>".$data['scanstate']."</td></tr>";
   }
   echo <<<EOT
</table>
<input type="hidden" name="op" value="edit">
<input type="hidden" name="id" value="$data[id]">
<input type="submit" name="submit" value="Save">
</form>
EOT;
} else { // view list
   $viewAll = FALSE;
   $querys="SELECT ip, hostname, os, status, description,
              contact, id, scanstate, lastscandate
           from hosts";
   // set up the SQL query based on the search form input (if any)
   switch($type) {
   case "ip":
      $q = $value;
      $queryw = " where ip LIKE '%$q%' order by INET_ATON(ip) ASC ";
      $stext =  "Search for ip = '*$q*'";
      break;
   case "name":
      $q = strtolower($value);
      $queryw = " where hostname LIKE '%$q%' order by hostname";
      $stext =  "Search for name = '*$q*'";
      break;
   case "contact":
      $q = strtolower($value);
      $queryw = " where contact LIKE '%$q%' order by hostname";
      $stext = "Search for contact = '*$q*'";
      break;
   case "desc":
      $q = strtolower($value);
      $queryw = " where description LIKE '%$q%' order by hostname";
      $stext = "Search for description = '*$q*'";
      break;
   case "status":
      $q = strtolower($value);
      $queryw = " where status LIKE '%$q%' order by hostname";
      $stext = "Search for status = '*$q*'";
      break;
   case "scanstate":
      $queryw = " where scanstate = '$scanstate' order by hostname";
      $stext = "Search for scanstate = '$scanstate'";
      break;
   default:
      $viewAll = TRUE;
      $queryw = " order by hostname";
      // add the limit for the paging
      $queryw .= " limit $offset,$pageSize"; 
      $stext = "Viewing all Hosts";
      break;
   }

   // put link to add new host
   echo "<p>";
   echo $stext;
   echo " | <a href='hosts.php?op=add' alt='Add New Host'>Add New Host</a>";
   echo "</p>";
   // echo the search criteria used

   // set up the pager and search fields if viewing all hosts
   $hostCount = 0;
   if($viewAll) {
      $hostCount = $dbconn->GetOne("SELECT count(ip) FROM hosts");
      $previous = $offset - $pageSize;
      if ($previous < 0) {
         $previous = 0;
      }
      $last = $hostCount - $pageSize;
      $next = $offset + $pageSize;
      if ($next > $last) {
         $next = $last;
      }
      $pageEnd = $offset + $pageSize;
      echo "<p>There are $hostCount hosts defined in the system.";
      // output the search form
      echo <<<EOT
<!--<form name="hostSearch" onSubmit="return OnSubmitForm();">-->
<form name="hostSearch" action="hosts.php" method="GET">
<input type="text" length="25" name="value">
<input type="radio" name="type" value="ip">IP
<input type="radio" name="type" value="name" checked>Name
<input type="radio" name="type" value="status">Status
<input type="radio" name="type" value="contact">Contact
<input type="radio" name="type" value="desc">Description
<input type="radio" name="type" value="scanstate">Scan State
<select name="scanstate">
EOT;
      foreach ($hostScanStateArray as $ss) {
         echo "<option value='$ss'>$ss</option>";
      }
      echo <<<EOT
</select>
<input type="hidden" name="op" value="search">
<input type="submit" name="submit" value="Find">
</form>
</p>
EOT;
      // output the pager
      echo "<p align=center><a href='hosts.php?offset=0' class='pager'>&lt&lt First</a> | ";
      if($offset != 0) {
         echo "<a href='hosts.php?offset=$previous' class='pager'>&lt Previous </a> | ";
      }
      if($pageEnd >= $hostCount) { $pageEnd = $hostCount; }
      echo "[ $offset - $pageEnd of $hostCount ] | ";
      if($next < $last) {
         echo "<a href='hosts.php?offset=$next' class='pager'>| Next &gt;</a> | ";
      }
      echo "<a href='hosts.php?offset=$last' class='pager'> Last &gt;&gt;</a></p>";
   } else {
      // get the search result count
      $queryc = "SELECT count(id)
                 FROM hosts ";
      $scount=$dbconn->GetOne($queryc.$queryw);
      echo "<p>$scount host";
      if($scount != 1) {
         echo "s";
      } else {
      }
      echo "found matching search criteria | "; 
      echo " <a href='hosts.php' alt='View All Hosts'>View All Hosts</a></p>";
   }

   // get the hosts to display
   $result=$dbconn->GetArray($querys.$queryw);
   if($result === false) {
      $errMsg[] = "Error getting hosts: " . $dbconn->ErrorMsg();
      $error++;
      dispSQLError($errMsg,$error);
   } else {
      $tdata = array();
      foreach($result as $data) {
         $data['hlink'] = hostLink($data['hostname'],$data['ip'],'name',true);
         $data['ilink'] = hostLink($data['hostname'],$data['ip'],'ip',true);
         $tdata[] = $data;
      }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "Hostname" => array( 'var' => 'hlink',
                                              'link' => $url ),
                         "IP" => array( 'var' => 'ilink',
                                        'link' => $url ),
                         "O/S" => array( 'var' => 'os',
                                         'link' => $url ),
                         "Status" => array( 'var' => 'status',
                                            'link' => $url ),
                         "Description" => array( 'var' => 'description',
                                                 'link' => $url ),
                         "Contact" => array( 'var' => 'contact',
                                             'link' => $url ),
                         "Scan State" => array( 'var' => 'scanstate',
                                                'link' => $url ),
                         "Last Scan Date" => array( 'var' => 'lastscandate',
                                                     'link' => $url ),
                         "Links" => array( "Search for Results" => array(
                                                'url' => 'search.php?submit=Search&hostname=%param%&search_by_name=1&showInfo=1&showLatestOnly=1',
                                                'param' => 'hostname',
                                                'icon' => 'images/zoom.png')));
      drawTable($fieldMap, $tdata, "Hosts");

   }

   // draw the pager again, if viewing all hosts
   if($viewAll) {
      echo <<<EOT
<p align=center>
<a href="hosts.php?offset=0" class="pager">&lt&lt First</a>
<a href="hosts.php?offset=$previous" class="pager">&lt Previous </a>
<a href="hosts.php?offset=$next" class="pager">| Next &gt;</a>
<a href="hosts.php?offset=$last" class="pager"> Last &gt;&gt;</a>
</p>
EOT;
   }
}

include ('footer.php');
?>
