<?php
//
// $Id: livestats.php,v 1.9 2006/08/10 17:19:32 airwofl Exp $
//

$pageTitle = "Live Stats";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

if (isset($_REQUEST['refresh'])) { 
   $req_refresh=htmlspecialchars(mysql_real_escape_string(trim($_REQUEST['refresh'])), ENT_QUOTES); 
} else { 
   $req_refresh=""; 
}
if (isset($_REQUEST['sortby'])) { 
   $sortby=htmlspecialchars(mysql_escape_string(trim($_REQUEST['sortby'])), ENT_QUOTES); 
} else { 
   $sortby=""; 
}

$getParams = array( "op", "host", "schedid" );
switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
}

if(is_numeric($req_refresh) && ($req_refresh >= 1) ) { 
   if( isset($meta_info) && is_array($meta_info) ) {
       $meta_info_count = count($meta_info);
   } else {
       $meta_info_count = 0;
   }
   $meta_info[$meta_info_count]["http-equiv"] = "refresh";
   $meta_url = "livestats.php?refresh=".$req_refresh;
   if (is_numeric($sortby)) {
      $meta_url.="&sortby=".$sortby;
   }
   $meta_info[$meta_info_count]["content"] = $req_refresh.";url=".$meta_url; 
}

$logh->log($username . " : " . $_SERVER['PHP_SELF']  .
           " : Accessed Page", PEAR_LOG_DEBUG);

if ($op=="stop") {
    $logh->log("$username : " . $_SERVER['PHP_SELF']  .
               " : Requested stop for schedid=" . $schedid . 
               " host=" . $host, PEAR_LOG_DEBUG);
    if (!is_numeric($schedid)) {
       $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                  " : Security violation - Requested to stop non numeric 
                    scheduleid " . $schedid, PEAR_LOG_CRIT);
       die("Can not access this page");
    }
    $query="select count(id) 
            from nessus_schedule 
            where username='$username' and id=$schedid";
    $result=$dbconn->execute($query);

    list($allowaccess)=$result->fields;
    if ($allowaccess<>1) {
       $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                  " : Security violation - Schedule not owned by this 
                    user: id " . $scheduleid, PEAR_LOG_CRIT);
       echo "Can not access this page";
       require_once('footer.php');
       die();
    }

    $query="select count(host) 
            from nessus_scan 
            where host='$host' and status='R' and sched_id=$schedid";
    $result=$dbconn->execute($query);
    list($allowaccess)=$result->fields;
    if ($allowaccess==1) {
       $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                  " : Sending stop message for schedid=" . 
                  $schedid . " host=" . $host, PEAR_LOG_NOTICE);
       $query="update nessus_scan 
               set status='P' 
               where sched_id=$schedid and host='$host' and status='R'";
       $result=$dbconn->execute($query);
       $stophost=$host;
       $stopschedid=$schedid;
    } else {
       $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                  " : Security violation - Attempt to stop invalid 
                    schedule or schedule owned by another user - 
                    scheduleid " . $schedid, PEAR_LOG_CRIT);
       echo "Can not access this page";
       require_once('footer.php');
       die();
    }
}

$sql_order="order by ";
$sql_order2="nessus_schedule.name, inet_aton(nessus_live_stats.host)";

if ($sortby=="" || !is_numeric($sortby)) { $sortby=0; }
if ($sortby==0) { // Do nothing as the required sql gets appended at the end of this IF block
} elseif ($sortby==1) {
   $sql_order2="nessus_schedule.name DESC, inet_aton(nessus_live_stats.host)"; 
} elseif ($sortby==2) { 
   // Can't sort by scanner id currently as this is not retrieved until
   //  the while loop when printing the results.
   // Would need to rewrite the whole PHP script to get this working - 
   //  sorry, don't have time.
   //
   // This is only here to maintain order on the sortby IDs used in the 
   //  links and also to make sure nothing breaks.
} elseif ($sortby==3) { 
   // Same comment as above.
} elseif ($sortby==4) { $sql_order2="inet_aton(nessus_live_stats.host), nessus_schedule.name"; }
elseif ($sortby==5) { $sql_order2="inet_aton(nessus_live_stats.host) DESC, nessus_schedule.name"; }
elseif ($sortby==6) { $sql_order.="nessus_live_stats.action, "; }
elseif ($sortby==7) { $sql_order.="nessus_live_stats.action DESC, "; }
elseif ($sortby==8) { $sql_order.="nessus_live_stats.percent, "; }
elseif ($sortby==9) { $sql_order.="nessus_live_stats.percent DESC, "; }
elseif ($sortby==10) { $sql_order.="nessus_live_stats.username, "; }
elseif ($sortby==11) { $sql_order.="nessus_live_stats.username DESC, "; }

$sql_order.=$sql_order2;

echo <<<EOT
<b>Live Scanning Status</b>
<br>
EOT;

$query="select nessus_live_stats.host, nessus_live_stats.action, 
               nessus_live_stats.percent, nessus_schedule.name, 
               nessus_live_stats.username, nessus_schedule.id 
        from nessus_live_stats
        left join nessus_schedule on nessus_live_stats.sid=nessus_schedule.id 
        where nessus_schedule.status='R' " . $sql_order;
$result=$dbconn->execute($query);

$refreshurl = "livestats.php";
$uriparam_refresh = "refresh=".$req_refresh;
$uriparam_sortby = "sortby=".$sortby;

if( $req_refresh<>"" || $sortby<>"" ) {
   $refreshurl .= "?";
}
if( $req_refresh<>"" ) {
   $refreshurl .= $uriparam_refresh;

   if( $sortby<>"" ) {
      $refreshurl .= "&";
   }
}
if( $sortby<>"" ) {
   $refreshurl .= $uriparam_sortby;
}

$query3="select count(*) 
         from nessus_scan 
         where server_id='0'";
$result3=$dbconn->execute($query3);
list($numstill2btested)=$result3->fields;

$query4="select count(*) 
         from nessus_scan 
         where server_id>0 and status='R'";
$result4=$dbconn->execute($query4);
list($numtesting)=$result4->fields;
?>
<p></p>
<a href="<?php echo $refreshurl;?>">Refresh Stats</a>&nbsp;|&nbsp;<A HREF="schedstats.php?refresh=<?php echo $req_refresh;?>">Hosts still to be Scanned</A></font>
<font size="1"><br><br></font>
<table border="0" cellspacing="0" cellpadding="2" style="border-collapse: collapse">
<tr>
<td rowspan='2'><form method="get">
Auto Refresh:
<select name="refresh">
<option value="0">None</option>
<option value="15" <?php if($req_refresh==15) echo "SELECTED"; ?>>15 Seconds</option>
<option value="60" <?php if($req_refresh==60) echo "SELECTED"; ?>>1 Minute</option>
<option value="300" <?php if($req_refresh==300) echo "SELECTED"; ?>>5 Minutes</option>
</select>
<?php if ($sortby<>"") { echo "<input type=\"hidden\" name=\"sortby\" value=\"$sortby\">"; } ?>
<input type="submit" value="Set">
</form></td><td rowspan='2'>&nbsp;&nbsp;&nbsp;</td>
<td>Number of hosts currently being tested:</td>
<td>&nbsp;&nbsp;&nbsp;<?php echo $numtesting;?></td>
</tr>
<tr>
<td>Number of hosts still to be tested:</td>
<td>&nbsp;&nbsp;&nbsp;<A HREF="schedstats.php?refresh=<?php echo $req_refresh;?>"><?php echo $numstill2btested;?></A></td>
</tr></table>
<p></p>
<?php

$url_sortby="<a href=\"livestats.php?";
if( $req_refresh<>"" ) {
   $url_sortby.="refresh=".$req_refresh;
}
$url_sortby.="&amp;sortby=";

$stats_table_head = " 
<table summary='Scans'>
<tr>
<th><font face='Verdana' color='#666666' size='2'><b>$url_sortby
";

if ($sortby==0) { $stats_table_head .= "1"; } else { $stats_table_head .= "0"; }
$stats_table_head .= "\">Schedule</a></b></font></th><th><font face=\"Verdana\" color=\"#666666\" size=\"2\"><b>$url_sortby";
if ($sortby==2) { $stats_table_head .= "3"; } else { $stats_table_head .= "2"; }
$stats_table_head .= "\">Scanner</a></b></font></th><th><font face=\"Verdana\" color=\"#666666\" size=\"2\"><b>$url_sortby";
if ($sortby==4) { $stats_table_head .= "5"; } else { $stats_table_head .= "4"; }
$stats_table_head .= "\">Host</a></b></font></th><th><font face=\"Verdana\" color=\"#666666\" size=\"2\"><b>$url_sortby";
if ($sortby==6) { $stats_table_head .= "7"; } else { $stats_table_head .= "6"; }
$stats_table_head .= "\">Task running</a></b></font></th><th><font face=\"Verdana\" color=\"#666666\" size=\"2\"><b>$url_sortby";
if ($sortby==8) { $stats_table_head .= "9"; } else { $stats_table_head .= "8"; }
$stats_table_head .= "\">Completed %</a></b></font></th><th><font face=\"Verdana\" color=\"#666666\" size=\"2\"><b>$url_sortby";
if ($sortby==10) { $stats_table_head .= "11"; } else { $stats_table_head .= "10"; }
$stats_table_head .= "\">Owner</a></b></font></th><th><font face=\"Verdana\" color=\"#666666\" size=\"2\"><b>Action</b></font></th></tr>";

$lc = 0; # loop counter, controls printing of the table header
while (!$result->EOF)
{
   if($lc == 0) {
      echo $stats_table_head;
   }
   $lc++;
   list($host, $action, $percent, $name, $db_username, $schedid)=$result->fields;

   $query1="select t1.name 
            from nessus_servers as t1, nessus_scan as t2, 
            nessus_live_stats as t3 
            where t1.id=t2.server_id and t2.host=t3.host 
               and t2.host='$host' and t2.status='R';";
   $result1=$dbconn->execute($query1);
   list($scannerhost_name)=$result1->fields;

   $complete = round($percent,0);
   echo <<<EOF
<tr>
<td><font face="Verdana" color="#666666" size="2">$name</font></td>
<td><font face="Verdana" color="#666666" size="2">$scannerhost_name</font></td>
<td><font face="Verdana" color="#666666" size="2">$host</font></td>
<td><font face="Verdana" color="#666666" size="2">$action</font></td>
<td><font face="Verdana" color="#666666" size="2">$complete%</font></td>
<td>$db_username</td>
<td>
EOF;
   $query2="select count(id) 
            from nessus_schedule 
            where username='$username' and id=$schedid";
   $result2=$dbconn->execute($query2);

   list($allowaccess2)=$result2->fields;
   if (($op=="stop") && ($host==$stophost) && ($schedid==$stopschedid)) {
      echo "Stopping";
   } elseif ($allowaccess2==1) {
      echo "<a href=\"livestats.php?op=stop&amp;schedid=$schedid&amp;host=$host&amp;sortby=$sortby";
      if( $req_refresh<>"" ) {
         echo "&amp;refresh=".$req_refresh;
      }
      echo "\">Stop</a>";
   }
   echo "</td></tr>";
   $result->MoveNext();
}

echo "</table>";

include ('footer.php');

?>
