<?php
//
// $Id: restext.php,v 1.10 2006/09/20 13:03:48 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

// don't want header for text output
//include ('header.php');
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
//require_once('permissions.inc.php');


$getParams = array( "scantime", "scantype", "schedid", "reporttype",
                    "sortby", "uid" );

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 

      } else { 
         $$gp=""; 
      }
   }
	break;
}

// admin and reports roles have extra permissions, check if user has either
//$admin = (strpos($_SESSION['roles'],"admin") === false) ? FALSE : TRUE;
//$reports = (strpos($_SESSION['roles'],"reports") === false) ? FALSE : TRUE;

if ($scantime<>"" and $scantype=="A" and $schedid<>"") {

   if (!is_numeric($schedid)) {
      die("Cannot access this page - error detected in URL."); 
   }

   $uid_filter=0;
   if ($uid<>"") { 
      $uid_filter=1; 
   }

   $query="select count(id),username 
           from nessus_schedule 
           where id=$schedid 
           group by username";
   $result=$dbconn->execute($query);

   list($allowaccess, $sql_uid)=$result->fields;

   if ($allowaccess<>1) { 
      die("Cannot access this page - Schedule details not in the database."); 
   }

   $query="select count(sched_id),username 
           from nessus_results 
           where sched_id=$schedid 
                 and scantime='$scantime' 
           group by username";
   $result=$dbconn->execute($query);

   list($allowaccess, $sql_uid)=$result->fields;

	if (!($uroles[admin] || $uroles[reports])) { 
      die("Cannot access this page - You are not the report owner or an admin."); 
   } else {
	   if (!$uid_filter) {
		   $uid_filter=1;
		   $uid=$sql_uid;
	   } elseif (!$uroles[reports]) {
		   if ($sql_uid!=$uid) { 
            die("Cannot access this page - error detected in URL (uid's don't match)."); 
         }
	   } else {
         $uid = $sql_uid;
      }
	}
} else {
	$uid=$username;
}

// get the scan job data
$query="select distinct t1.username, t2.name, t3.name, t3.description 
        from nessus_results as t1, nessus_schedule as t2, 
             nessus_settings as t3 
        where t1.username='$uid' 
              and t1.scantype='A' 
              and t1.sched_id = t2.id 
              and t1.sid=t3.id 
              and scantime='$scantime'
        order by scantime DESC";
$result=$dbconn->execute($query);
list ($sql_uid, $sched_name, $profile_name, $profile_desc)=$result->fields;

$tmpdate = dateformat($scantime);
//Generated date
$gendate = date("m/d/Y H:i:s");

// send the right content headers
header("Content-Type: application/vnd.ms-excel; name='excel'");
header("Content-disposition:  attachment; filename=scanresults-$uid-$scantime.xls");

// Set up the output table
//$dataHead = <<<EOT
echo <<<EOT
<table border=1>
<tr>
   <th colspan=9>Nessus scan results:</th>
</tr>
<tr>
   <th>Scan time:</th>
   <td colspan=8 align=left>$tmpdate</td>
</tr>
<tr>
   <th>Generated:</th>
   <td colspan=8 align=left>$gendate</td>
</tr>
<tr>
   <th>Profile:</th>
   <td colspan=8 align=left>$profile_name - $profile_desc</td>
</tr>
<tr>
   <th>Schedule:</th>
   <td colspan=8 align=left>$sched_name</td>
</tr>
<tr>
   <th>Owner:</th>
   <td colspan=8 align=left>$sql_uid</td>
</tr>
<tr>
   <th>IP</th>
   <th>Host</th>
   <th>Port</th>
   <th>Protocol</th>
   <th>Service</th>
   <th>Severity</th>
   <th>ScriptID</th>
   <th>Description</th>
EOT;

if($enableException) {
   echo "<th>Exception</th>";
}
echo "</tr>";

// get the "open ports", defined as a risk=7 with no message
$query="select nr.host as ip, h.hostname as host, nr.service as service,
               nr.risk as risk
        from nessus_results as nr
        left join hosts as h
        on nr.host=h.ip
        where nr.scantime='$scantime' 
              and nr.username='$uid' 
              and nr.sched_id=$schedid 
              and nr.msg='' 
              and nr.risk='7' ";
// add in host status exclusions
$query .= " and h.status NOT IN ('" . implode("','",$nostatusArray) . "') ";

/*
$nscount=0;
foreach ($nostatus as $ns) {
   if($nscount >= 1) { $query .= " and " };
   $query .= " h.status<>'$ns' ";
   $nscount++;
}
*/

$query .= " order by nr.result_id ASC";

$result1=$dbconn->execute($query); 

$portResults="";

while(list($ip, $host, $service, $risk)=$result1->fields) {
   $tmpport1=preg_split("/\(|\)/",$service);
   $tmpport2=preg_split("/\//",$tmpport1[1]);
   $service_num=$tmpport2[0];
   $service_proto=$tmpport2[1];

   $portResults[$ip][]=array( 'host' => $host, 
                              'service_num' => $service_num, 
                              'service_proto' => $service_proto, 
                              'service' => $service, 
                              'risk' => getrisk($risk) );
//   $data.= "<tr valign=top><td>$host</td><td>$service_num</td><td>$service_proto</td><td>$service</td><td>$risk></td><td></td><td>Open Port</td></tr>";
   $result1->MoveNext();
}

// get the scan results, sorted by host(IP) then risk
$query="select nr.host as ip,
               h.hostname as host, 
               nr.service as service, 
               nr.risk as risk, 
               nr.msg as msg, 
               nr.scriptid as scriptid
        from nessus_results as nr 
        left join hosts as h 
        on nr.host=h.ip
        where nr.scantime='$scantime' 
              and nr.sched_id=$schedid 
              and nr.msg<>''";
// exclude certain status flags
$query .= " and h.status NOT IN ('" . implode("','",$nostatusArray) . "') ";

/*
$nscount=0;
foreach ($nostatus as $ns) {
   if($nscount >= 1) { $query .= " and " };
   $query .= " h.status<>'$ns' ";
   $nscount++;
}
*/

$query .= " order by INET_ATON(nr.host) ASC, nr.risk ASC";
//              and nr.username='$uid' 
//$result1=$dbconn->execute($query);
//$arrResult1=$result1->GetArray();
$arrResult1=$dbconn->GetArray($query);
$arrResults = "";

//while(list($ip, $host, $service, $risk, $msg, $scriptid)=$result1->fields) {
foreach($arrResult1 as $data) {

   // get the port from the service field
   $tmpport1=preg_split("/\(|\)/",$data[service]);
   if (sizeof($tmpport1)==1) { $tmpport1[1]=$tmpport1[0]; }
   $tmpport2=preg_split("/\//",$tmpport1[1]);
   $service_num=$tmpport2[0];
   $service_proto=$tmpport2[1];

   if($enableException) {
      // get all exceptions for this IP and put it into a hash
      $exc = printException($data[ip], $data[scriptid], $dbconn, TRUE,
                             $data[host], $service_num);
      /*
      $equery="select eid, status, submitDate, plugin, port, hostname
               from exceptions
               where ( ip LIKE '%$data[ip]%' OR ip = 'ALL' ) 
                  AND plugin = '$data[scriptid]'";
      if(is_numeric($service_num)) { // we have a valid port
         $equery .= " AND ( port LIKE '%$service_num%' OR port IS NULL ) ";
      } else {
         $equery .= " AND port IS NULL";
      }
      //print $service_num . " - " . $equery . "<br>";
      $eresult=$dbconn->execute($equery);
      if($result === false) { // error
         echo "Error retrieveing data from DB:  " . 
              $dbconn->ErrorMsg() . "<br>";
      }
      $eresArray = $eresult->GetArray();
      $exc = "";
      foreach($eresArray as $edata) {
         if ($exc != "") { $exc .= "\n"; }
         $exc .= "$edata[eid] - $edata[submitDate] - $edata[status]";
      }
      //echo $exc;
      */
   }

   // now loop through all the results for this IP

   if($enableException) {
      // modified to not differentiate Info level findings for exceptions
      //if ($exc == "" && $data[risk] < 7) { $exc = "No Exceptions Found"; }
      if ($exc == "") { $exc = "No Exceptions Found"; }
   }

   $arrResults[$data[ip]][]=array( 'host' => $data[host], 
                                'service_num' => $service_num, 
                                'service_proto' => $service_proto, 
                                'service' => $data[service], 
                                'risk' => getrisk($data[risk]), 
                                'scriptid' => $data[scriptid], 
                                'msg' => $data[msg],
                                'exc' => $exc );
}
// now put together the results
if(empty($arrResults)) {
   $nst = implode(" or ", $nostatusArray);
   echo <<<EOT
<tr valign=top>
   <td colspan=8>There was a problem retrieving the results of the scan,
                 please check to be sure that a Host record exists that is
                 not listed as $nst.</td>
</tr>
EOT;

} else {
   foreach ($arrResults as $ip=>$scanData) {
      
      // scan results
      foreach($scanData as $values) {
         //$data .= <<<EOT
         echo <<<EOT
<tr valign=top>
   <td>$ip</td>
   <td>$values[host]</td>
   <td>$values[service_num]</td>
   <td>$values[service_proto]</td>
   <td>$values[service]</td>
   <td>$values[risk]</td>
   <td>$values[scriptid]</td>
   <td>$values[msg]</td>
EOT;
         if($enableException) {
            echo "<td>$values[exc]</td>";
         }
         echo "</tr>";
      }
      // then open ports
      if(!empty($portResults[$ip])) {  // check to make sure there is data
         foreach ($portResults[$ip] as $portData) {
            //$data .= <<<EOT
            echo <<<EOT
<tr valign=top>
   <td>$ip</td>
   <td>$portData[host]</td>
   <td>$portData[service_num]</td>
   <td>$portData[service_proto]</td>
   <td>$portData[service]</td>
   <td>$portData[risk]</td>
   <td></td>
   <td>Open Port</td>
EOT;
            if($enableException) {
               echo "<td></td>";
            }
            echo "</tr>";
         }
      }
   } // end foreach()
} //end if/else()
//$data .= "</table>";
echo "</table>";

// start the output
//header('Content-Type: text/tab-separated-values');
//header('Content-Disposition: attachment; filename="scanresults.txt"');
//echo $data;

?>
