<?php
//
// $Id: sched.php,v 1.14 2006/09/21 12:34:35 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Nessus Scan Schedule";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$myhostname="";

$getParams = array( 'page', 'op', 'schedid', 'sid',
                    'schedule_type', 'confirm', 'timeout',
                    'sortby', 'submit', 'hosts', 'hostname', 'viewall'
                   );

$postParams = array( 'page', 'op', 'schedid', 'sid', 'schedulename',
                     'schedule_type', 'ROYEAR', 'ROMONTH', 'ROday',
                     'week_days', 'dayofmonth', 'time_hour', 'time_min',
                     'confirm', 'timeout', 'submit', 'hosts', 'hostname'
                   );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         if(is_array($_GET[$gp])) {
            foreach ($_GET[$gp] as $i=>$tmp) {
               ${$gp}[$i] = sanitize($tmp);
            }
         } else {
            $$gp = sanitize($_GET[$gp]);
         }
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach ($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         if(is_array($_POST[$pp])) {
            foreach($_POST[$pp] as $i=>$tmp) {
               ${$pp}[$i] = sanitize($tmp);
//echo $pp . "[" . $i . "] = " . $$pp[$i] . "<br>";
            }
         } else {
            $$pp = sanitize($_POST[$pp]);
//echo $pp . " = " . $$pp . "<br>";
         }
      } else { 
         $$pp=""; 
      }
//echo $pp . " = " . $$pp . "<Br>";
   }
   break;
}

//echo "<pre>";
//print_r($hosts);
//echo $hosts;
//print_r($postParams);
//echo "</pre>";


if (!($uroles['nessus'] || $uroles['admin'])) {
   echo "Access Denied - you are not permitted to run Nessus Scans.<br>";
   $logh->log("$username : " . $_SERVER['PHP_SELF']  .
              " : Access denied", PEAR_LOG_WARNING);
} else {
   $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
              " : Accessed page", PEAR_LOG_DEBUG);
   $query = "select count(*) 
             from nessus_plugins";
   $result=$dbconn->execute($query);
   list($pluginscount)=$result->fields;

   if ($pluginscount==0) {
      $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                 " : You need to run updateplugins.pl", PEAR_LOG_CRIT);
      die ("<h2>Please run updateplugins.pl script first before using 
            web interface.</h2>");
   }
   echo "<font size=\"4\">Nessus Scans</font><br><br>";
   if ($page==1 or $page=="") {
      if ($op=="delete" or $op=="stop") {
         if (!is_numeric($schedid)) {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                       " : Non numeric schedid " . $schedid, PEAR_LOG_WARNING);
            die("Cannot access this page - schedid is non numeric");
         }
         $query="select count(id) 
                 from nessus_schedule 
                 where username='$username' and id=$schedid";
         $result=$dbconn->execute($query);

         list($allowaccess)=$result->fields;
         if ($allowaccess<>1) {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                       " : Attempt to access invalid schedid " . 
                       $schedid, PEAR_LOG_WARNING);
            die("Cannot access this page - permission denied.");
         }
     }
     if ($op=="new") {
        echo <<<EOF
New schedule<BR>
<form method="post" action="sched.php">
<input type="hidden" name="page" value="1">
<input type="hidden" name="op" value="save">
Schedule Name: <input type="text" name="schedulename" value="" size="60"><BR>
<input type="submit" name="submit" value="Save">
</form>
EOF;
     } else if ($op=="save") {
        //verify if the same schedule exists
        $query="SELECT count(name)
                FROM nessus_schedule
                WHERE name='$schedulename'";
        $result=$dbconn->execute($query);
        list($scheduleexists)=$result->fields;

        if($scheduleexists==0) {
           $query="insert into nessus_schedule
                     (username, name, schedule_type, status)
                     values ('$username', '$schedulename','H','C')";
           $result=$dbconn->execute($query);
           if($result === false) {
              echo "SQL Error creating schedule: " . $dbconn->ErrorMsg();
           }
           $schedid = $dbconn->Insert_Id();
           /*
           $query="select id
                   from nessus_schedule
                   where name='$schedulename'
                         and username='$username'";
           $result=$dbconn->execute($query);
           list($schedid)=$result->fields;
           */

           echo <<<EOF
Schedule '<B>$schedulename</B>' has been created.<BR>
<A HREF="sched.php?page=2&amp;schedid=$schedid">Manage Hosts</A><BR>
<A HREF="sched.php?page=3&amp;schedid=$schedid">Manage Schedule</A>
EOF;
           $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                      " : Added new schedule", PEAR_LOG_NOTICE);
        } else {
           echo <<<EOT
<FONT COLOR="#FF0000"><B>Cannot create new schedule. 
Schedule '$schedulename' already exists.</B></FONT>
EOT;
        }
     } else if ($op=="delete") {
        if ($confirm=="yes") {
           $query="delete from nessus_schedule 
                   where id=$schedid";
           $result=$dbconn->execute($query);
           $query="delete from nessus_hosts 
                   where sched_id=$schedid";
           $result=$dbconn->execute($query);
           echo <<<EOT
Schedule has been deleted.
Click <a href="sched.php">here</a> to go to the main page.<BR>
EOT;
           $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                      " : Deleted schedid " . $schedid, PEAR_LOG_NOTICE);
         } else {
           echo <<<EOT
Do you really want to delete this schedule?<BR>
<a href="sched.php?page=1&amp;op=delete&amp;schedid=$schedid&amp;confirm=yes">Yes</a> 
<a href="sched.php">No</A>
EOT;
         }
      } else if ($op=="stop") {
         // set the schedule entry from Running to Pending
         $query="update nessus_schedule set status='P' 
                 where id = $schedid and status='R'";
         $result=$dbconn->execute($query);
         // set the scan entry from Running to Pending
         $query="update nessus_scan set status='P' 
                 where sched_id=$schedid and status='R'";
         $result=$dbconn->execute($query);
         // mark Scheduled scan for scanner 0 as Complete
         $query="update nessus_scan set status='C' 
                 where sched_id=$schedid and status='S' and server_id=0";
         $result=$dbconn->execute($query);
         echo "Scan will be stopped shortly<br>";
         $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                    " : Requested scan stop for schedid " . 
                    $schedid, PEAR_LOG_WARNING);
      } else {
         if($viewall == 1) {
            echo "<a href='sched.php'>View My Schedules</a> |";
         } else {
            echo "<a href='sched.php?viewall=1'>View All Schedules</a> |";
         }
         echo "<a href='sched.php?page=1&amp;op=new'>New Schedule</a> |"; 
         echo "<a href='livestats.php?refresh=15'>View details of runnings
               scans</a><br><br>";

         $sql_order="order by ";
         // IF you need to use a default order variable, place it in $sql_order2.
         // BUT you will need to append a , and a space after each 
         //  sql_order statement in the IF block below otherwise SQL 
         //  errors will occur.
         $sql_order2="";

         if (!isset($sortby) || !is_numeric($sortby)) { $sortby=0; }
         if ($sortby==0) { $sql_order.="name"; }
         elseif ($sortby==1) { $sql_order.="name DESC"; }
         elseif ($sortby==2) { $sql_order.="schedule_type, date_format(next_scan, \"%Y%m%d%W%T\") DESC"; }
         elseif ($sortby==3) { $sql_order.="schedule_type DESC, date_format(next_scan, \"%Y%m%d%W%T\") DESC"; }
         elseif ($sortby==4) { $sql_order.="status DESC, date_format(next_scan, \"%Y%m%d%W%T\") DESC"; }
         elseif ($sortby==5) { $sql_order.="status, date_format(next_scan, \"%Y%m%d%W%T\") DESC"; }
         elseif ($sortby==6) { $sql_order.="date_format(next_scan, \"%Y%m%d%W%T\") DESC"; }
         elseif ($sortby==7) { $sql_order.="date_format(next_scan, \"%Y%m%d%W%T\")"; }
         elseif ($sortby==8) { $sql_order.="username DESC, name DESC"; }
         elseif ($sortby==9) { $sql_order.="username, name"; }

         $sql_order.=$sql_order2;

         if($viewall == 1) {
            $url_sortby="<a href=\"sched.php?viewall=1&sortby=";
         } else {
            $url_sortby="<a href=\"sched.php?sortby=";
         }

         echo <<<EOT
<table summary="Nessus Scans">
<tr><td><b>$url_sortby
EOT;
         if ($sortby==0) { echo "1"; } else { echo "0"; }
         echo "\">Schedule Name</a></b></td><td><b>$url_sortby";
         if ($sortby==2) { echo "3"; } else { echo "2"; }
         echo "\">Type</b></a></td><td><b>$url_sortby";
         if ($sortby==4) { echo "5"; } else { echo "4"; }
         echo "\">Status</b></a></td><td><b>$url_sortby";
         if ($sortby==6) { echo "7"; } else { echo "6"; }
         echo "\">Run Time</b></a></td><td><b>$url_sortby";
         if ($sortby==8) { echo "9"; } else { echo "8"; }
         echo <<<EOT
">Owner</b></a></td>
<td colspan=3><b>Action</b></td>
</tr>
EOT;
// modified by hsh to return all scan schedules
         $query = "select id, name, schedule_type, sid, timeout, username,
                      status, date_format(next_scan, \"%W %M %e, %Y - %r\") 
                 from nessus_schedule ";
         if($viewall == 1) { // list all schedules
         } else { // view only logged in users schedules
            $query .= "where username='$username' ";
         }
         $query .= $sql_order;
         $result=$dbconn->execute($query);

         while (!$result->EOF) {
            list ($schedid, $schedname, $schedtype, $sid, $timeout, $username,
                  $schedstatus, $nextscan)=$result->fields;
            echo <<<EOT
<tr><td><a href="sched.php?page=2&amp;schedid=$schedid">$schedname</A></td>
<td>
EOT;

            switch ($schedtype) {
            case "N":
               $stt="Once (Now)";
               break;
            case "O":
               $stt="Once";
               break;
            case "D":
               $stt="Daily";
               break;
            case "W":
               $stt="Weekly";
               break;
            case "M":
               $stt="Monthly";
               break;
            case "H":
               $stt="On Hold";
               break;
            default:
               $stt="&nbsp;";
               break;
            }
            echo "$stt</td><td>";
 
            switch ($schedstatus) {
            case "R":
               $itext="Running";
               $isrc="images/running.png";
               break;
            case "S":
               $itext="Scheduled";
               $isrc="images/sched.png";
               break;
            case "P":
               $itext="Pending";
               $isrc="images/hourglass.png";
               break;
            case "H":
               $itext="On Hold";
               $isrc="images/hourglass.png";
               break;
            case "C":
               $itext="Completed";
               $isrc="images/true.png";
               break;
            default:
               $itext="Scheduling";
               $isrc="images/question.png";
               $schedstatus="I";
            }
            echo "<img alt=$itext src=$isrc border=0 title=$itext>";
            echo "</td><td>$nextscan</td><td>";
            echo "$username</td><td>";
            if(($schedstatus=="R") || ($schedstatus=="P") 
               || ($schedstatus=="I")){
               echo <<<EOT
</td><td><a href="sched.php?page=1&amp;op=stop&amp;schedid=$schedid">
<img alt="Stop Scan" src="images/stop.png" border=0 title="Stop Scan"></a>
EOT;
            } else {
              echo<<<EOT
<A HREF="sched.php?page=3&schedid=$schedid&sid=$sid&schedule_type=N&timeout=$timeout&submit=runnow">
<img alt="Run scan now" src="images/go.png" border=0 title="Run scan now"></A></td><td>
EOT;
            }
            echo <<<EOT
</td><td><a href="sched.php?page=1&amp;op=delete&amp;schedid=$schedid">
<img alt="Delete Schedule" src="images/delete.png" border=0 title="Delete Schedule"></a></td></tr>
EOT;

            $result->MoveNext();
         }
         echo <<<EOT
</table>
<br><a href="sched.php?page=1&amp;op=new">New Schedule</a> | 
<a href="livestats.php?refresh=15">View runnings scans details</a><br><br>
EOT;
      }
   }
   if ($page==2) {
      if (!is_numeric($schedid)) {
         $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                    " : Non numeric schedid " . $schedid, PEAR_LOG_WARNING);
         die("Cannot access this page - schedid is not numeric");
      }
      $query="select count(id)
              from nessus_schedule
              where username='$username'
                    and id=$schedid";
      $result=$dbconn->execute($query);

      list($allowaccess)=$result->fields;
      if ($allowaccess<>1 && !$uroles['admin']) {
         $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                    " : Attempt to access invalid schedid " . 
                    $schedid, PEAR_LOG_WARNING);
         die("Cannot access this page - permission denied.");
      }
// moved to functions.inc
//      require_once('validateip.inc.php');

      if ($schedid=="") {
         $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                    " : Missing schedule ID parameter", PEAR_LOG_WARNING);
         die("Missing schedule ID parameter");
      }

      if ($allowscan==1) {
         if($myhostname==""){
            $myhostname=$_SERVER['REMOTE_ADDR'];
         }
      } else {
         $myhostname=$_SERVER['REMOTE_ADDR'];
      }

      echo <<<EOT
<A href="sched.php">My Schedules</A> | 
<B>Manage Hosts</B> | 
<A href="sched.php?page=3&amp;schedid=$schedid">Manage Schedule</A><HR>
EOT;

      // process the "Remove" request, loop through any values in the 
      // hosts[] array and remove them from the schedule
      if (!empty($hosts)) {
         // 'admin' can modify any schedule, set where clause accordingly
         $wherec = ($uroles['admin']) ? "" : "and username = '$username'";
         $stmt = $dbconn->prepare("delete from nessus_hosts 
                                   where hostip=?
                                      $wherec
                                      and sched_id=$schedid");
         foreach($hosts as $host) {
         //for ($i = 0; $i < count($hosts); $i++) {
              // already sanitized on the way in
//            $hosts[$i] = sanitize($hosts[$i]);
            $result=$dbconn->execute($stmt, array($host));
            //echo "$username : $hosts[$i] : $schedid <br>";
         }
         //echo "<p>Removed hosts from schedule</p>";
      }

      if (($allowscan==1 and strlen($hostname)>0) or 
          ($allowscan<>1 and $hostname==$_SERVER['REMOTE_ADDR'])) {
         // check for a range of IPs, only 1 range allowed for now
         $isRange = (strpos($hostname,"-") === false) ? FALSE : TRUE;
         if($isRange) {
            list($sip,$eip) = explode("-",$hostname);
            if (strlen($sip)>0 and inrange($sip, $dbconn) and
                strlen($eip)>0 and inrange($eip, $dbconn)) {
               $result=$dbconn->Execute("SELECT count(*) as ipcount
                                         FROM nessus_hosts 
                                         WHERE hostip='$hostname' 
                                               AND username='$username' 
                                               AND sched_id=$schedid");
               list($countip)=$result->fields;
               if ($countip==0) {
                  $result=$dbconn->Execute("INSERT INTO nessus_hosts 
                                              (username, hostip, sched_id) 
                                            VALUES ('$username','$hostname', 
                                                     $schedid)");
               } else {
                  echo "<b>This range is already in the database</b>";
               }
            } else {
               echo "<FONT COLOR=\"#FF0000\"><b>IP address $v not 
                     in an applicable <A HREF=\"zones.php\">
                     Network Zone</A></b></FONT>";
               $logh->log("$user : " . $_SERVER['PHP_SELF']  . 
                          " : Address not in a valid zone", PEAR_LOG_DEBUG);
            }
         } else {
            // split on the following
            //  - space separated (\s+)
            //  - unix newline (\s*\\n) - mysql escaping converts the input
            //  - windows newline (\s*\\r\\n) - mysql escaping converts the input
            //  - comma separated (,\s*)
            //  - semicolon separated (;\s*)
            $vals=preg_split("/\s+|\s*\\n|\s*\\r\\n|,\s*|;\s*/",$hostname,501);
            $inputhostcount=1;
            foreach($vals as $v) {
               $v=trim($v);
               if (strlen($v)>0 and inrange($v, $dbconn) and $inputhostcount < 501) {
                  $result=$dbconn->Execute("SELECT count(*) as ipcount
                                            FROM nessus_hosts 
                                            WHERE hostip='$v' 
                                                  AND username='$username' 
                                                  AND sched_id=$schedid");
                  list($countip)=$result->fields;
                  if ($countip==0) {
                     //removed 1/27/07 - hsh - not necessary for Putnam
                     //$acl=checkacl("owniponly", $dbconn);
                     //if ($acl=="Y") {
                     //    if ($v == $myhostname) {
                     //        $result=$dbconn->Execute("insert into nessus_hosts (username, hostip, sched_id) values ('$username','$v', $schedid)");
                     //    }
                     //} else {
                        $result=$dbconn->Execute("insert into nessus_hosts 
                                                    (username, hostip, sched_id) 
                                                    values ('$username','$v', 
                                                            $schedid)");
                     //}
                  } else {
                     echo "<b>This ip is already in the database</b>";
                  }
               } else {
                  if ( $inputhostcount > 500 ) {
                     echo <<<EOT
<b>There were more than 500 hosts / ranges input.<br>
The following details have not been added: $v</b><br><br>
EOT;
                     $logh->log("$user : " . $_SERVER['PHP_SELF']  . 
                                " : More than 500 hosts / ranges input", 
                                PEAR_LOG_DEBUG);
                  } elseif ( ! inrange ($v, $dbconn)) {
                     echo "<FONT COLOR=\"#FF0000\"><b>IP address $v not in an applicable <A HREF=\"zones.php\">Network Zone</A></b></FONT>";
                     $logh->log("$user : " . $_SERVER['PHP_SELF']  . 
                                " : Address not in a valid zone", PEAR_LOG_DEBUG);
                  }
               }
               $inputhostcount++;
            } //end of loop
         }
      }
      // modified where clause to allow admin to see/edit any schedule
      if(!$uroles['admin']) {
         $hwc = "where username='$username' and";
      } else {
         $hwc = "where";
      }
      $result=$dbconn->Execute("SELECT hostip 
                                FROM nessus_hosts 
                                $hwc sched_id=$schedid 
                                ORDER BY hostip");

      //$myhostname=htmlspecialchars($myhostname);

      // set up data for select box with assigned targets
      $tmpSelectedTarget = "";
      $counter=1;
      while (list($hostip)=$result->fields) {
         $tmpSelectedTarget .= "<OPTION VALUE=\"$hostip\">$hostip</option>";
         $counter++;
         $result->MoveNext();
      }

      // now get the list of all available targets from the hosts table
      $result=$dbconn->Execute("SELECT ip, hostname 
                                FROM hosts 
                                ORDER BY hostname");
      $tmpAllHosts = "";
      $aHcounter=1;
      while (list($ahip,$ahname)=$result->fields) {
         $tmpAllHosts .= "<OPTION VALUE=\"$ahip\">$ahname - $ahip</option>";
         $aHcounter++;
         $result->MoveNext();
      }

      // generate the table with the form fields
      echo <<<EOF
<table summary="Target Hosts">
   <tr><th colspan=2>List of target hosts</th></tr>
   <tr><td valign="top">
   <form method="post" action="sched.php">
   <input type="hidden" name="page" value="2">
   <input type="hidden" name="schedid" value="$schedid">
   <b>IP Addresses</b><br>comma separated OR a range (10.0.0.1-10.0.0.10)<BR>
   <textarea name="hostname" cols="25" rows="3">$hostname</textarea>
   <input type="submit" value="Add >>">
   <p></p>
   <input type="button" value="Copy ^" onclick="move(this.form.allhosts,this.form.hostname)">
   <br>
   <SELECT NAME="allhosts" SIZE="10" multiple>
   $tmpAllHosts
   </SELECT>
   </form>
   </td>
   <td valign="top">
   <form method="post" action="sched.php">
   <input type="hidden" name="page" value="2">
   <input type="hidden" name="schedid" value="$schedid">
   <b>Selected IPs</b><br>
   <SELECT NAME="hosts[]" SIZE="18" multiple>
   $tmpSelectedTarget
   </SELECT><BR>
   <input type="submit" name="remove" value="<< Remove">
   </form>
   </td></tr>
   <!--<tr><td colspan="2"><input type="submit" value="apply"></input></td></tr>-->
</table>
EOF;
      $result->Close();
   }

   if ($page==3) {
      if (!is_numeric($schedid)) {
         $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                    " : Non numeric schedid " . $schedid, PEAR_LOG_WARNING);
         echo "Cannot access this page - schedid is not numeric.";
         require_once('footer.php');
         die();
      }
      $query="SELECT count(id) 
              FROM nessus_schedule 
              WHERE username='$username' AND id=$schedid";
      $result=$dbconn->execute($query);

      list($allowaccess)=$result->fields;
      if ($allowaccess<>1 && !$uroles['admin']) {
         $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                    " : Attempt to access invalid schedid " .
                    $schedid, PEAR_LOG_WARNING);
         echo "Cannot access this page - permission denied.";
         require_once('footer.php');
         die();
      }
      if ($schedid=="") {
         $logh->log("$user : " . $_SERVER['PHP_SELF']  . 
                    " : Missing schedule ID parameter", PEAR_LOG_WARNING);
         echo "Missing schedule ID parameter";
         require_once('footer.php');
         die();
      }

      echo <<<EOT
<A href="sched.php">My Schedules</A> | 
<A href="sched.php?page=2&amp;schedid=$schedid">Manage Hosts</A> | 
<B>Manage Schedule</B><HR>
EOT;

      // modified where clause to allow admin to edit any schedule
      if(!$uroles['admin']) {
         $swc = " and username='$username'";
      } else {
         $swc = "";
      }
      $query="SELECT status 
              FROM nessus_schedule 
              WHERE id=$schedid $swc";
      $result=$dbconn->execute($query);
      list($running)=$result->fields;

      if ($running=="R" or $running=="P") {
         $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                    " : Attempted to change settings of running scan", 
                    PEAR_LOG_INFO);
         echo "Cannot change settings while scan is running.";
         require_once('footer.php');
         die();
      }

// not sure what this is for
//      $result=$dbconn->Execute("select username 
//                                from nessus_schedule 
//                                where username='$username' and id=$schedid");
//      list($userschedname)= $result->fields;

      if ($submit=="submit" || $submit=="runnow") {
         //Check all variables
         $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                    " : Requested submit for schedid=" . 
                    $schedid, PEAR_LOG_DEBUG);

         $submitscan=1;

         switch ($schedule_type) {
         case "N":
            break;
         case "O":
            if (!is_numeric($ROYEAR)) {$submitscan=0;}
            if (!is_numeric($ROMONTH)) {$submitscan=0;}
            if (!is_numeric($ROday)) {$submitscan=0;}
            if ($ROYEAR<date("Y") or $ROYEAR>date("Y")+1) {$submitscan=0;} //Must be changed to check for current and next year
            if ($ROMONTH<1 or $ROMONTH>12) {$submitscan=0;}
            if ($ROday<1 or $ROday>31) {$submitscan=0;}
            break;
         case "D":
            break;
         case "M":
            break;
         case "W":
            break;
         case "H":
            break;
         default:
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                       " : Invalid schedule type " . 
                       $schedule_type, PEAR_LOG_DEBUG);
            $submitscan=0;
         }

         if (!is_numeric($timeout)) {$submitscan=0;}
         if (!is_numeric($sid)) {$submitscan=0;}
         if ($timeout<0 or $timeout>604800) {$submitscan=0;}

         if ($submit!="runnow") {
            if (!is_numeric($time_hour)) {$submitscan=0;}
            if (!is_numeric($time_min)) {$submitscan=0;}
            if (!is_numeric($week_days)) {$submitscan=0;}
            if (!is_numeric($dayofmonth)) {$submitscan=0;}
 
            if ($time_hour<0 or $time_hour>23) {$submitscan=0;}
            if ($time_min<0 or $time_min>59) {$submitscan=0;}
            if ($week_days<0 or $week_days>6) {$submitscan=0;}
            if ($dayofmonth<1 or $dayofmonth>31) {$submitscan=0;}
         } else {
           $week_days=0;
           $dayofmonth=0;
           $scantime="00:00:00";
         }

         if ($submitscan<>1) {
           $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                      " : Error in one of the submitted fields", 
                      PEAR_LOG_WARNING);
           die("Cannot access this page -
                error in one of the submitted fields.");
         }

         $query="SELECT count(nessus_settings.id) 
                 FROM nessus_settings 
                 INNER JOIN nessus_settings_users 
                       ON nessus_settings.id=nessus_settings_users.sid 
                 WHERE nessus_settings_users.username='$username' 
                       AND nessus_settings.id=$sid";
         $result=$dbconn->execute($query);
         list($allowaccess)=$result->fields;

         if ($allowaccess<>1) {
            $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                       " : Submit scan failed - Denied", PEAR_LOG_WARNING);
            die("Cannot access this page");
         }

         if ($schedule_type <> "H") {
         // Check to see if an active Nessus Server is configured
         //  in the Network Zone for the hosts configured on this schedule
            $query="SELECT hostip 
                    FROM nessus_hosts 
                    WHERE sched_id=$schedid";
            $result=$dbconn->execute($query);

            $tmpNetworkZones=array();

            while (list($hostip)=$result->fields) {
               $query2="SELECT zoneid, range_start, range_end 
                        FROM nessus_zone_ranges 
                        INNER JOIN nessus_user_zones 
                            ON nessus_user_zones.zid=nessus_zone_ranges.zoneid 
                        WHERE nessus_user_zones.username='$username'";

               $result2=$dbconn->execute($query2);

               ereg('^([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])$',$hostip,$r);
               $ip2=intval($r[1])*16777216+intval($r[2])*65536+intval($r[3])*256+intval($r[4]);

               while(!$result2->EOF) {
                  list($tmpZoneID, $range_start, $range_end)=$result2->fields;

                  $rip1=0;
                  $rip2=0;

                  if ($range_start==$range_end) {
                     $rip1=$range_start;

                     if ($rip1==$ip2) {
                        if (!inArray($tmpZoneID,$tmpNetworkZones)) {
                           $tmpNetworkZones[]=$tmpZoneID;
                        }
                        break;
                     }
                  }

                  if ($range_start<$range_end) {
                     $rip1=$range_start;
                     $rip2=$range_end;

                     if ($ip2>=$rip1 and $ip2<=$rip2) {
                        if (!inArray($tmpZoneID,$tmpNetworkZones)) {
                           $tmpNetworkZones[]=$tmpZoneID;
                        }
                        break;
                     }
                  }

                  $result2->MoveNext();
               } //end of while network zone loop

               $result->MoveNext();
            } // end of while host list loop 

           // Now iterate through the array $tmpNetworkZones and check 
           // each server id to see if it's activity.

            for ($i=0; $i<count($tmpNetworkZones); $i++) {
               $query = "SELECT nessusid,count(nessusid) 
                         FROM nessus_server_zones 
                         WHERE zoneid=$tmpNetworkZones[$i] 
                         GROUP BY nessusid";
               $result=$dbconn->execute($query);
               list($tmpServerID,$allowaccess) = $result->fields;

               if ($tmpServerID<>"") {
                  $query = "SELECT name, description, status 
                            FROM nessus_servers 
                            WHERE id=$tmpServerID";
                  $result=$dbconn->execute($query);
                  list($tmpServName,$tmpServDesc,$tmpServStatus) = $result->fields;

                  if ($tmpServStatus != "A") {
                     $allowaccess=0;
                     $noserver=1;
                  }
               }

               if ($allowaccess<1) {
                  $query = "SELECT name, description 
                            FROM nessus_zones 
                            WHERE id=$tmpNetworkZones[$i]";
                  $result=$dbconn->execute($query);
                  list($tmpZoneName, $tmpZoneDesc) = $result->fields;
   
                  echo <<<EOT
<FONT COLOR=\"#FF0000\"><B>You have attempted to schedule a scan where
the Network Zone <I>'$tmpZoneName - $tmpZoneDesc'</I> is not configured 
with an online Nessus Server.<BR><BR>
EOT;

                  if ($noserver) {
                     echo "The Nessus Server <I>'$tmpServName - $tmpServDesc'</I> is currently not available.<BR><BR>";
                  }

                  echo "Please review the <A HREF=\"zones.php?item=editzone&zid=$tmpNetworkZones[$i]\">Network Zone</A> ";

                  if ($noserver) {
                     echo "or <A HREF=\"servers.php\">Nessus Server</A> ";
                  }

                  echo "settings.</B></FONT>";
                  die();
               }
            }
         }
         //Should be safe

         $scheduletime=$ROYEAR;
  
         if ($ROMONTH<10) $scheduletime.="0";
         $scheduletime.=$ROMONTH;
         if ($ROday<10) $scheduletime.="0";
         $scheduletime.=$ROday;

         $scantime="";

         if ($time_hour<10) {
            $scantime="0"; $scheduletime.="0";
         }
         $scantime .=$time_hour;
         $scheduletime.=$time_hour;
         if ($time_min<10) {$scantime .= "0"; $scheduletime .= "0";}
         $scantime .= $time_min;
         $scheduletime.=$time_min;
         $scantime .="00";
         $scheduletime.="00";
  
         if ($schedule_type=="O"){
            $query="UPDATE nessus_schedule 
                    SET schedule_type='$schedule_type', 
                        day_of_week='$week_days', 
                        day_of_month=$dayofmonth, 
                        time=$scantime, 
                        next_scan='$scheduletime', 
                        status='S', 
                        sid=$sid, 
                        timeout=$timeout 
                    WHERE username='$username' 
                        AND id=$schedid";

            $result=$dbconn->execute($query);
         } elseif ($schedule_type=="H"){
            $query="UPDATE nessus_schedule 
                    SET schedule_type='$schedule_type', 
                        day_of_week='$week_days', 
                        day_of_month=$dayofmonth, 
                        time=$scantime, 
                        next_scan=NULL, 
                        status='C', 
                        sid=$sid, 
                        timeout=$timeout 
                    WHERE username='$username' AND id=$schedid";
            $result=$dbconn->execute($query);
         } else {
            $result=$dbconn->Execute("UPDATE nessus_schedule 
                                      SET schedule_type='$schedule_type', 
                                          day_of_week='$week_days', 
                                          day_of_month=$dayofmonth, 
                                          time=$scantime, 
                                          next_scan=NULL, 
                                          status=NULL, 
                                          sid=$sid, 
                                          timeout=$timeout 
                                      WHERE username='$username' 
                                            AND id=$schedid");
         }
         echo "<BR><h3>Your Nessus scan has been successfully scheduled.</h3>";
      } else {
         // modified to allow admin to edit any schedule
         if (!$uroles['admin']) {
            $nawc = "username='$username' and ";
         }
         $result=$dbconn->Execute("SELECT schedule_type, day_of_week, 
                                          day_of_month, time, status, 
                                          name, sid, timeout 
                                   FROM nessus_schedule 
                                   WHERE $nawc id=$schedid");
         list($schedule_type, $week_days, $dayofmonth, $scantime,
              $sstatus, $sname, $profileid, $timeout )= $result->fields;
         $time_hour=substr($scantime,0,2);
         $time_min=substr($scantime,3,2);

         $today=date("Ymd");
         $tyear=substr($today,0,4);
         $tmonth = substr($today,4,2);
         $tday = substr($today,6,2);

         echo <<<EOT
<form method="post" action="sched.php">
<input type="hidden" name="page" value="3">
<input type="hidden" name="schedid" value="$schedid">
<p>Schedule - <B>$sname</B><BR></p>
<table summary="Schedule Details">
<tr><td>Profile</td>
EOT;
         // modified to allow admin to access any scan profile,
         // otherwise the user is restricted based on what profiles they
         // have assigned to them
         if(!$uroles['admin']) {
            $sidwc = "INNER JOIN nessus_settings_users 
                         ON nessus_settings.id=nessus_settings_users.sid 
                      WHERE nessus_settings_users.username='$username'";
         } else {
            $sidwc = "";
         }
         $query="SELECT nessus_settings.id, nessus_settings.name, 
                        nessus_settings.description 
                 FROM nessus_settings 
                 $sidwc
                 ORDER BY nessus_settings.name";
         $result=$dbconn->execute($query);
         if($result === false) { //oops error in the sql call
            $logh->log("$username : " . $_SERVER['PHP_SELF']  .
                       " : Error getting scan profiles: " .
                       $dbconn->ErrorMsg(), PEAR_LOG_WARNING);
            echo "Error: unable to retrieve the Scan Profiles from the
                  database:  " . $dbconn->ErrorMsg() . "</font><br/>";
         }
         echo "<td colspan=\"7\"><select name=\"sid\">";
         while (!$result->EOF) {
            list ($sid, $sname, $sdescription)=$result->fields;
            echo "<option value=\"$sid\" ";
            if ($profileid==$sid) {echo "selected";}
            echo ">$sname-$sdescription";

            $result->MoveNext();
         }
         echo "</select></td></tr>
               <tr><td colspan=8><hr></td></tr>
               <tr><td colspan=8>
               <input type=\"radio\" name=\"schedule_type\" value=\"H\"";
         if ($schedule_type=="H") echo " checked";
         echo ">On Hold</td></tr>
               <tr><td colspan=8>
               <input type=\"radio\" name=\"schedule_type\" value=\"N\"";
         if ($schedule_type=="N") echo " checked";
         echo ">Run Now</td></tr>
               <tr><td><input type=\"radio\" name=\"schedule_type\" value=\"O\"";
         if ($schedule_type=="O") echo " checked";
         echo ">Run Once</td><td colspan=\"7\"> Year ";
         echo "<select name='ROYEAR'>";
         for($i=$tyear;$i<=2010;$i++) {
            $selected = "";
            if($i == $tyear) { $selected = "selected";}
            echo "<option value='$i' $selected>$i</option>";
         }
         echo "</select> Month <select name='ROMONTH'>";
         for ($i=1;$i<=12;$i++) {
            echo "<option value=\"$i\" ";
            if ($i==$tmonth) echo "selected";
            echo ">$i</option>";
         };
         echo "</select> Day <select name=\"ROday\">";
         for ($i=1;$i<=31;$i++) {
            echo "<option value=\"$i\" ";
            if ($i==$tday) echo "selected";
            echo ">$i</option>";
         };
         echo <<<EOF
</select>
</td></tr>
<tr>
<td colspan=8><input type="radio" name="schedule_type" value="D"
EOF;
         if ($schedule_type=="D") echo " checked";
         echo <<<EOF
>Daily</td>
</tr><tr><td rowspan="2">
<input type="radio" name="schedule_type" value="W"
EOF;
         if ($schedule_type=="W") echo " checked";
         echo <<<EOF
>Weekly</td>
<td>Sunday</td>
<td>Monday</td>
<td>Tuesday</td>
<td>Wednesday</td>
<td>Thursday</td>
<td>Friday</td>
<td>Saturday</td></tr>
<tr>
<td><input type="radio" name="week_days" value="0"
EOF;
         if ($week_days=="0") echo " checked";
         echo "></td>";
         echo "<td><input type=\"radio\" name=\"week_days\" value=\"1\"";
         if ($week_days=="1") echo " checked";
         echo "></td>";
         echo "<td><input type=\"radio\" name=\"week_days\" value=\"2\"";
         if ($week_days=="2") echo " checked";
         echo "></td>";
         echo "<td><input type=\"radio\" name=\"week_days\" value=\"3\"";
         if ($week_days=="3") echo " checked";
         echo "></td>";
         echo "<td><input type=\"radio\" name=\"week_days\" value=\"4\"";
         if ($week_days=="4") echo " checked";
         echo "></td>";
         echo "<td><input type=\"radio\" name=\"week_days\" value=\"5\"";
         if ($week_days=="5") echo " checked";
         echo "></td>";
         echo "<td><input type=\"radio\" name=\"week_days\" value=\"6\"";
         if ($week_days=="6") echo " checked";
         echo "></td>";

         echo "<tr><td><input type=\"radio\" name=\"schedule_type\" value=\"M\""; 
         if ($schedule_type=="M") echo " checked"; 
         echo ">Monthly</td>"; 
         echo "<td colspan=\"7\">Day of Month<select name=\"dayofmonth\">"; 
         for ($i=1;$i<=31;$i++) {
            echo "<option value=\"$i\"";
            if ($dayofmonth==$i) echo " selected";
            echo ">$i</option>";
         }
         echo <<<EOT
</select>
</td></tr>
<tr><td colspan=8><hr></td></tr>
<tr><td rowspan="2">Time</td>
<td>Hour</td><td>Minutes</td><td colspan="5">
<font color="red">This time will be used for all schedule 
types</font></td>
</tr><tr><td><select name="time_hour">
EOT;
         for ($i=0;$i<=23;$i++){
            echo "<option  value=\"$i\"";
            if ($time_hour==$i) echo " selected";
            echo ">$i</option>";
         }
         echo "</select>";
         echo "</td><td><select name=\"time_min\">";
         for ($i=0;$i<59;$i=$i+5){
            if($i<10) { $i = "0$i"; }
            echo "<option value=\"$i\"";
            if ($time_min == $i) echo " selected";
            echo ">$i</option>";
         }
         echo <<<EOT
</select>
</td><td colspan=5>
</td></tr>
<tr><td>Timeout</td>
<td colspan=7><input type="text" name="timeout" value="$timeout">
<font color="red">Max scan run time in seconds</font></td></tr>
</table></td></tr><tr><td>
<input type="submit" name="submit" value="submit"></td></table></form>
EOT;
      }
   }
}
require_once("footer.php");

?>
