<?php
//
// $Id: search.php,v 1.9 2006/09/20 13:40:54 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Search";

// moved down below to support exporting results to excel
//require_once('header.php');
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('permissions.inc.php');

$varMap = array ( "severity" => "Risk Severity", 
                  "hostname" => "Hostname/IP", 
                  "service" => "Service", 
                  "plugin" => "Plugin ID",
                  "description" => "Description", 
                  "start_date" => "Start Date", 
                  "end_date" => "End Date", 
                  "showInfo" => "Include Infos",
                  "showFP" => "Include False Positives", 
                  "showPScan" => "Show Port Scans", 
                  "userfilter" => "Username" );

$postVars = array( "severity", "hostname", "byuser", "service", "plugin",
                   "description", "start_date", "end_date", "showInfo",
                   "showFP", "wildcard", "showPScan", "countres",
                   "fp", "nfp", "submit", "userfilter", "showLatestOnly",
                   "search_by_name" );
                   //"search_by_name", "host_is_wild" );

foreach($postVars as $pv) {
   if(isset($_REQUEST[$pv])) {
      $$pv = htmlspecialchars(mysql_escape_string(trim($_REQUEST[$pv])), ENT_QUOTES); 
   } else {
      $$pv = "";
   }
}

// check for wildcard search in the hostname
$host_is_wild = FALSE;
//if($host_is_wild) {
if(isset($hostname) && strpos($hostname,"*") !== FALSE) {
   $wild_host = str_replace("*","%",$hostname);
   $host_is_wild = TRUE;
}

// up the PHP memory limit if we were asked for all info results
if(($severity == "Info" || $severity == "All") && $showInfo) {
   ini_set("max_execution_time","360");
   ini_set("memory_limit","64M");
}


// for Export to Excel, we need to change the content type of the response,
//  so we use an alternate page to validate authentication
if($submit=="Export to Excel") {
   // send the right headers for the Excel version
   header("Content-Type: application/vnd.ms-excel; name='excel'");
   header("Content-disposition:  attachment; filename=searchresults.xls");
} else {
   require_once('header2.php');
}

$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
           " : Page accessed", PEAR_LOG_DEBUG);

if ($enableFP) {
   if ($fp<>"") {
      $query="update nessus_results set falsepositive='Y' where result_id=$fp";
      $result=$dbconn->execute($query);
   }

   if ($nfp<>"") {
      $query="update nessus_results set falsepositive='N' where result_id=$nfp";
      $result=$dbconn->execute($query);
   }
}

/*
if ($submit=="Reset search")
{
   $byuser="";
   $severity="";
   $hostname="";
   $service="";
   $plugin="";
   $description="";
   $start_date="";
   $end_date="";
   $showInfo="";
   $showPScan="";
   $showFP="";
   $countres="";
}
*/

if ($submit!="Export to Excel") {
   echo <<<EOF
   <form action="search.php" method="post">
   <table summary="Search criteria" >
EOF;

   if ($uroles['admin'] || $uroles['reports']) {
      echo <<<EOF
<tr><td VALIGN="center"><font color="#808080">
<b>User:&nbsp;&nbsp;&nbsp;&nbsp;</b></font></td>
<td VALIGN="center">
<form action="search.php" method="post">
<select NAME="byuser"><option value="All"
EOF;
      //if (($byuser=="") && (($userfilter=="Change user scope") || 
      //    ($submit=="Search"))) { 
      if ($byuser=="") { 
         echo " selected"; 
         $byuser = "All";
      }
      echo "> All</option>";

      // get usernames from DB
      $query2="SELECT pn_uname FROM users ORDER BY pn_uname";
      $result2=$dbconn->execute($query2);
   
      while(!$result2->EOF)
      {
         list($sql_uname)=$result2->fields;
         echo "<option value=\"$sql_uname\"";
         if ($sql_uname==$byuser) { echo " selected"; }
         elseif (($sql_uname==$username) && ($byuser=="") && 
                 ($userfilter!="Change user scope") && 
            ($submit!="Search")) { echo " selected"; }
         echo ">$sql_uname";
         $result2->MoveNext();
      }
      echo <<<EOF
</select>&nbsp;&nbsp;
<input type="submit" name="userfilter" value="Change user scope">
</td></tr></table></form>
<form action="search.php" method="post">
<table summary="Search criteria 2">
EOF;
   }

   $sql_byuser="";
   $sql_byuser2="";

   if (($userfilter=="Change user scope") || ($byuser<>"")) {
       if (!($uroles['admin']||$uroles['reports']) && ($byuser!=$username)) { 
          echo "Only permitted to search your own results -
               you don't have admin or reports rights."; 
          require_once("footer.php");
          die();
       }

       if ($byuser<>"" && $byuser!="All") {
          $sql_byuser="where username='$byuser' ";
          $sql_byuser2="username='$byuser' and ";
       }
   
       echo "<input name=\"byuser\" type=\"hidden\" value=\"$byuser\">";
   } elseif (($userfilter!="Change user scope") && ($byuser=="")) {
       // if user doesn't have admin or reports rights, they are restricted to
       // their own results
       if (!($uroles['admin']||$uroles['reports'])) {
          $sql_byuser="where username='$username' ";
          $sql_byuser2="username='$username' and ";
       }
   }

   echo <<<EOF
<tr>
<th>Severity:</th>
<td>
   <select NAME="severity"><option VALUE=""> All
EOF;

   // severity level search criteria
   echo "   <option VALUE=\"1\" "; 
   if($severity=="1"){ echo "selected"; }; echo "> Serious";
   echo "   <option VALUE=\"2\" "; 
   if($severity=="2"){ echo "selected"; }; echo "> High";
   echo "   <option VALUE=\"3\" "; 
   if($severity=="3"){ echo "selected"; }; echo "> Medium";
   echo "  <option VALUE=\"4\" "; 
   if($severity=="4"){ echo "selected"; }; echo "> Medium-Low";
   echo "   <option VALUE=\"5\" ";
   if($severity=="5"){ echo "selected"; }; echo "> Low-Medium";
   echo "   <option VALUE=\"6\" "; 
   if($severity=="6"){ echo "selected"; }; echo "> Low";
   echo "   <option VALUE=\"7\" "; 
   if($severity=="7"){ echo "selected"; }; echo "> Info";
   
   $sbnc = "";
   if($search_by_name){ $sbnc = " checked"; }
   $hiwc = "";
   if($host_is_wild){ $hiwc = " checked"; }
   echo <<<EOF
   </select>
</td>
</tr>
<tr>
<th>Host Name/IP Address:</th>
<td>
   <input type="checkbox" value="1" name="search_by_name" $sbnc>Search by Name</input>
<!-- 
   &nbsp;&nbsp;
   <input type="checkbox" value="1" name="host_is_wild" $hiwc>Wildcard Search (use *)</input>
-->
   <br>
   <input type="text" name="hostname" size=32 maxlength=64 value="$hostname">
   </input>
   &nbsp;&nbsp;<img src="images/help.png" title="[Leave blank for all Hosts/IPs, use * for wildcard]"></img>
</td>
</tr>
EOF;

// speed up the search page by not displaying all hosts that have results
//  the user will have to enter a hostname or an IP address
//echo <<<EOF
//  <select name="hostname">
//  <option value="" label="default"> All</option>
//EOF;
//
//$result=$dbconn->Execute("select distinct nr.host as ip, h.hostname as host 
//                          from nessus_results as nr
//           left join hosts as h
//           on nr.host=h.ip " . $sql_byuser . 
//          " order by nr.host ASC");
//while (list($hostRes, $hostName)=$result->fields) {
//    echo "<option value=\"$hostRes\" label=\"$hostRes\""; 
//    if($hostname==$hostRes){ echo"selected"; }; 
//    echo ">$hostRes - $hostName</option>";
//    $result->MoveNext();
//}
//
//echo <<<EOF
//</select>
//EOF;

   echo <<<EOF
<tr>
<th>Service(s):</th>
<td>
   <select name="service">
   <option value="" label="default"> All</option>
EOF;

   $result=$dbconn->Execute("select distinct service 
                             from nessus_results " . $sql_byuser .
                            " order by service ASC");
   while (list($serviceRes)=$result->fields) {
       echo "<option value=\"$serviceRes\" label=\"$serviceRes\""; 
       if($service==$serviceRes){ echo"selected"; }; 
       echo ">$serviceRes</option>";
       $result->MoveNext();
   }

   echo <<<EOF
   </select>
</td>
</tr>
<tr>
<th>Nessus Plugin:</th>
<td><select name="plugin">
   <option value="" label="default"> All</option>
EOF;

   $query = "select distinct scriptid 
             from nessus_results 
             where " . $sql_byuser2 . 
            "scriptid <> '' order by scriptid ASC";
   $result=$dbconn->Execute($query);
   while (list($pluginRes)=$result->fields) {
       echo "<option value=\"$pluginRes\" label=\"$pluginRes\""; 
       if($plugin==$pluginRes){ echo "selected"; }; 
       echo">$pluginRes</option>";
       $result->MoveNext();
   }

   // text search of description
   echo <<<EOF
   </select>
</td>
</tr>
<tr>
<th>Description (substring search):</th>
<td>
   <input type="text" name="description" size="64" maxlength="128" 
     value="$description" ></td>
</tr>

EOF;
 
   $query = "select distinct scantime 
             from nessus_results " . $sql_byuser .
            "order by scantime ASC";
   $dates=$dbconn->GetArray($query);
   $sdo = $edo = "";
   if($dates === false) {
      $errMsg[] = "Error getting scantimes: " . $dbconn->ErrorMsg();
      $error++;
   } else {
      foreach ($dates as $data) {
          $ssel = $esel = "";
          $tdate = $data['scantime'];
          $label = dateformat($data['scantime']);
          if($tdate==$start_date){ $ssel = "selected"; } 
          if($tdate==$end_date){ $esel = "selected"; } 
          $sdo .= "<option value='$tdate' label='$tdate' $ssel>$label</option>\n"; 
          $edo .= "<option value='$tdate' label='$tdate' $esel>$label</option>\n"; 
      }
   }
   //start and end date
   echo <<<EOF
<tr>
<th>Start Date:</th>
<td>
   <select name="start_date">
   <option value="" label="default"> No start date</option>
   $sdo
   </select>
</td>
</tr>
<tr>
<th>End Date:</th>
<td>
   <select name="end_date">
   <option value="" label="default"> No end date</option>
   $edo
   </select>
</td>
</tr>
EOF;

   // only show the latest scan results
   $sloc = "";
   if($showLatestOnly){ $sloc = " checked"; }
   echo <<<EOT
<tr>
<th>Show Only Latest Scan Results:</th>
<td>
<input type="checkbox" name="showLatestOnly" value="true" $sloc>
</td>
</tr>
EOT;

   // show Info (risk=7) results
   $sic = "";
   if($showInfo){ $sic = " checked"; }
   echo <<<EOF
<tr>
<th>Show Info Level Results:</th>
<td>
<input type="checkbox" name="showInfo" value="true" $sic>
</td>
</tr>
EOF;
   
   // show portscans
   if($enablePS) {
      if($showPScan){ $spsc = " checked"; }
      echo <<<EOF
<tr>
<th>Show Portscans:</th>
<td>
<input type="checkbox" name="showPScan" value="true" $spsc>
</td>
</tr>
EOF;
   }

   // show false positive results
   if ($enableFP) {
      if($showFP){ $sfpc = " checked"; }
      echo <<<EOF
<th>Show False Positives:</th>
<td>
<input type="checkbox" name="showFP" value="true" $sfpc>
</td>
</tr>
EOF;
   }

   $crc = "";
   if($countres){ $crc = " checked"; }
   echo <<<EOF
<th>Count Results Only:</th>
<td>
<input type="checkbox" name="countres" value="true" $crc>
</td>
</tr>
</table>
<P></P>
<input name="submit" value="Search" type="submit">&nbsp;&nbsp;&nbsp;&nbsp;
<input name="submit" value="Export to Excel" type="submit">&nbsp;&nbsp;&nbsp;
<!--<input name="submit" value="Reset search" type="submit">-->
</form>
EOF;
} // end $submit!="Export to Excel"

// search form was submitted, do the search and return the results
if($submit=="Search" || $submit=="Export to Excel"){
   if($submit=="Export to Excel") {
      $tborder = "border=1";
   }
   // get the current scan state from the hosts table for hostname/ip
   //  searches
   $lt = date("r");
   $hss = "";
   if($hostname != "" && !$host_is_wild) {
      $qss = "SELECT scanstate
              FROM hosts ";
//      if(substr_count($hostname,'.') == 3) { //  4 octets for an IP
      if(!$search_by_name) {
         $qss .= "WHERE ip = '$hostname'";
      } else {
         $qss .= "WHERE hostname = '$hostname'";
      }
      $hss = $dbconn->GetOne($qss);
   }

   if($submit=="Export to Excel") {

      // output search params for Excel version
      $now = date('r');
      echo <<<EOT
<table $tborder>
<tr><th>Search Parameters</th></tr>
<tr><td>Generated</td><td>$now</td></tr>
EOT;
      foreach($varMap as $var=>$text) {
         echo "<tr><td>$text</td><td>";
         // human readable date formats
         if($var == "end_date" || $var == "start_date") {
            echo dateformat($$var);
         } else {
            echo $$var;
         }
         echo "</td></tr>\n";
      }
      echo "<tr><td>Search by Name</td><td>$search_by_name</td></tr>\n";
      echo "<tr><td>Wildcard Host</td><td>$host_is_wild</td></tr>\n";
      if($hss != "") {
         echo "<tr><td>Current Scan State as of $lt</td><td>$hss</td></tr>\n";
      }
      echo "</table>\n";
   } else {
      if($hss != "") {
         echo "Current Scan State as of $lt: <b>$hss</b><p></p>";
      }
   }

   //$query=" ";
   $query = array();
   // start of query to get number of results
   $cquerys="Select count(nr.risk) as count, nr.risk 
             from nessus_results as nr ";

   $sql_join = "left join hosts as h on nr.host = h.ip";
   $query[] = "h.status NOT IN ('" . implode("','",$nostatusArray) . "') ";
   // see if only the last scan results were requested
//   if($showLatestOnly) {
//      $lsq = "(SELECT max(scantime)
//               FROM nessus_results
//               WHERE host = ";
//      if($hostname <> '') {
//         if($search_by_name) {
//         } else {
//         }
//      if($boolAnd) { $query .= " and "; }
//      elseif ($sql_byuser == "") { $query .= "where "; }
//      $query[] = "$lsq";
//   }

   // common query setup
//   if ($sql_byuser<>"") {
//       $boolAnd=TRUE; 
//   } else { 
//       $boolAnd=FALSE; 
//   }

   $slq  = "nr.scantime = (SELECT max(scantime)
                           FROM nessus_results
                           WHERE host ";
   if($hostname <> ""){
      $getScanState=1;
//      if($boolAnd){$query .= " and ";}
//      elseif ($sql_byuser=="") { $query .= "where "; }
      $operator = "=";
      $addwild = "";
      if($host_is_wild) {
         $operator = "LIKE";
         $hostname = $wild_host;
      }
      if($search_by_name) {
         $query[] = "h.hostname $operator '$hostname'";
         if($showLatestOnly) {
            $query[] = $slq . "= h.ip)";
         }
      } else {
         $query[] = "nr.host $operator '$hostname'";
         if($showLatestOnly) {
            $query[] = $slq . "= nr.host)";
         }
      }
   } else {
      if($showLatestOnly) {
         $query[] = $slq . "= nr.host)";
      }
   }
/*
      if(substr_count($hostname,'.') == 3) { //  4 octets for an IP
      } else { // must be a DNS name, have to get the IP first
         $iq = "SELECT ip
                FROM hosts
                WHERE hostname = '$hostname'";
         $ip = $dbconn->GetOne($iq);
         $hostname = $ip;
      }
      $query .= "host='$hostname'";
      $boolAnd=TRUE;
   }
*/

   if($severity<>""){
//      if($boolAnd){ $query=$query." and "; }
//      elseif ($sql_byuser=="") { $query=$query."where "; }
      $query[] = "nr.risk='$severity'";
//      $boolAnd=TRUE;
   }
   if($service<>""){
//      if($boolAnd){$query .= " and ";}
//      elseif ($sql_byuser=="") { $query .= "where "; }
      $query[] = "nr.service='$service'";
//      $boolAnd=TRUE;
   }
   if($plugin<>""){
//      if($boolAnd){$query .= " and ";}
//      elseif ($sql_byuser=="") { $query .= "where "; }
      $query[] = "nr.scriptid='$plugin'";
//      $boolAnd=TRUE;
   }
   if($start_date<>""){
//      if($boolAnd){$query .= " and ";}
//      elseif ($sql_byuser=="") { $query .= "where "; }
      $query[] = "nr.scantime >='$start_date'";
//      $boolAnd=TRUE;
   }
   if($end_date<>""){
//      if($boolAnd){$query .= " and ";}
//      elseif ($sql_byuser=="") { $query .= "where "; }
      $query[] = "nr.scantime <='$end_date'";
//      $boolAnd=TRUE;
   }
   if($description<>""){
//      if($boolAnd){$query .= " and ";}
//      elseif ($sql_byuser=="") { $query .= "where "; }
      $query[] = "nr.msg LIKE '%$description%'";
//      $boolAnd=TRUE;
   }
   if($enableFP && !$showFP){
//      if($boolAnd){$query .= " and ";}
//      elseif ($sql_byuser=="") { $query .= "where "; }
      $query[] = "nr.falsepositive='N'";
//      $boolAnd=TRUE;
   }
   if(!$showInfo){
//      if($boolAnd){$query .= " and ";}
//      elseif ($sql_byuser=="") { $query .= "where "; }
      $query[] = "nr.risk!='7'";
   }
   if($enablePS && (!$showPScan) && ($description=="")){
//      if($boolAnd){$query .= " and ";}
//      elseif ($sql_byuser=="") { $query .= "where "; }
      $query[] = "nr.msg!=''";
   }

   if($sqlbyuser2 <> "") {
      $query[] = $sqlbyuser2;
   }
   $cquerye = " group by nr.risk";
   $where_clause = " where " . implode(" AND ", $query);
   $final_query = $cquerys . $sql_join . $where_clause . $cquerye;

//echo "<pre>final_query = $final_query</pre>";
   // get the data from the DB
   $cresult=$dbconn->GetArray($final_query);
   if($cresult === false) {
      $errMsg[] = "SQL error getting vuln summary counts: " . $dbconn->ErrorMsg();
      $errMsg[] = "  query was: " . $final_query;
      $error++;
      dispSQLError($errMsg, $error);
      require_once('footer.php');
      die();
   }
    
   // get the counts for the different risk levels
   $counter=0;
   foreach($cresult as $data) {
      $counter += $data['count'];
      $cdata[$data['risk']]=$data['count'];
   }
   // output the risk counts to the table
   echo <<<EOF
<table $tborder summary="Vulnerability Summary">
<tr>
<th colspan=8>Vulnerability Summary:</th>
</tr>
<TR>
EOF;
   for($i=1;$i<=7;$i++) {
      echo "<td><B>".getrisk($i) . "</b>: "; 
      if(!isset($cdata[$i])) {
         echo "0";
      } else {
         echo "$cdata[$i]";
      }
      echo "</td>";
   }
   echo "<td><b>Total: </b> ".$counter."</td>";
   echo "</tr></table>";
   // no results, display friendly error
   if ($counter<1) { 
      echo "<FONT COLOR=\"#FF0000\">
            <B>No results were found. 
            Please refine your search criteria.</B></FONT>"; 
   }
   // output the results if there are any and this wasn't just a result count
   if((!$countres) && ($counter>0)) {
      // start of query to get full data
      $fquerys="select distinct nr.result_id, nr.host, nr.service, 
                 nr.risk, nr.msg, nr.scriptid, nr.falsepositive, nr.scantime, 
                 nr.scantype, nr.sched_id, h.hostname
              from nessus_results as nr
              left join hosts as h
                 on nr.host=h.ip ";
      // exclude the hosts with certain status flags
      /*
      $nscount=0;
      foreach ($nostatus as $ns) {
         if($nscount >= 1) { $query .= " and ";
         $fquerye .= " h.status<>'$ns' ";
         $nscount++;
      }
      */
//      $fquery[] = $sql_byuser2;
//      $fquery[] = " and h.status NOT IN ('" . implode("','",$nostatus) . "') ";

      // not the open ports
      //$fquerye .= " and (nr.risk <> '7' and nr.msg <> '') ";

      // sort order - by scantime for host lookup, else by host
      if($hostname != "") {
         $fquerye .= " order by nr.scantime DESC, nr.risk ASC, nr.scriptid DESC";
      } else {
         $fquerye .= " order by nr.host ASC, nr.risk ASC, nr.scriptid DESC";
      }

      // set up the SQL query
      $final_query = $fquerys . $where_clause . $fquerye;
      // get the vuln data from the DB
      $fresult=$dbconn->GetArray($final_query);
      echo <<<EOT
<p></p>
<table $tborder summary='Vulnerability Details'>
<tr>
<th>Hostname</th>
<th>IP Address </th>
<th>ScanTime</th>
<th>Service</th>
<th>Severity</th>
<th>Plugin ID</th>
<th>Description</th>
EOT;
      // for the Excel export option, we put the exception data in it's own
      //  column
      if($submit=="Export to Excel") {
         echo "<th>Exception</th>";
         echo "</tr>";
      } else {
         echo "</tr>";
      }

      $bgcolor="#f6f7eb";
      // set oldscantime to the first one in the results
      $oldscantime = $fresult[0]['scantime'];
      foreach($fresult as $data) {
         $openPort = 0; // open port flag
         $tmpport1=preg_split("/\(|\)/",$data['service']);
         if (sizeof($tmpport1)==1) { $tmpport1[1]=$tmpport1[0]; }
   #echo "$tmpport1[0] $tmpport1[1]<BR>";
         $tmpport2=preg_split("/\//",$tmpport1[1]);
   #echo "$tmpport2[0] $tmpport2[1]<BR>";
         $service_num=$tmpport2[0];
         $service_proto=$tmpport2[1];

// No need to do this anymore as the HTML entities are converted when importing the results
//            $msg=htmlspecialchars($msg, ENT_QUOTES);
//
// No more word-wrapping at small widths! Rely on the NASLs to do this, plus uses the screen more effectively.
//
// However for the already wrapped text (defined in each NASL), we have no control and I am not
// going to write a specialised parser to handle all of the bespoke formats
//
         if($submit!="Export to Excel") {
            $data[msg]=wordwrap(preg_replace("/\n/","<br>",$data['msg']),100,"<br>",1);
         }

         // for searches by hostname, put in a separator for the scantimes
         if($hostname != "" && ($data['scantime'] != $oldscantime)) {
            echo "<tr bgcolor='454567'><td colspan='7'><hr></td></tr>";
         }

         if($submit!="Export to Excel") {
            if ($bgcolor=="bgcolor=#dededf") {
                $bgcolor="bgcolor=#ffffff";
            } else {
                $bgcolor="bgcolor=#dededf";
            }
            if ($data['hostname'] == "") { $data['hostname'] = "unknown:$data[host]"; }
            $hlink = hostLink($data['hostname'],$data['host'],'name', FALSE);
            $ilink = hostLink($data['hostname'],$data['host'],'ip', FALSE);
         } else {
            $hlink = $data['hostname'];
            $ilink = $data['host'];
         }
         // so Excel will treat it as a string and not a large number
         $tmpdate = dateformat($data['scantime']);
         echo "<tr $bgcolor>
               <td>$hlink</td>
               <td>$ilink</td>
               <td>$tmpdate</td>
               <td>$data[service]</td>
               <td>" . getrisk($data['risk']) . "</td>
               <td>" . $data['scriptid'] . "</td>";
         if (trim($data['msg']) == "") {
             $data['msg']="Open Port<BR>";
             $openPort = 1;
         } 
         //if($enableException && $data[risk] <= 6) {
         if($enableException && !$openPort) {
            if($submit!="Export to Excel") {
               $data['msg'] .= "<p><FONT COLOR='#0044FF'><b>Exceptions:</b><br>";
               $data['msg'] .= printException($data['host'],$data['scriptid'],$dbconn,FALSE,$data['hostname'],$service_num);
               $data['msg'] .= "</FONT></p>";
            } else {
               $data['msg'] .= "</td><td>";
               $data['msg'] .= printException($data['host'],$data['scriptid'],$dbconn,TRUE,$data['hostname'],$service_num);
               $data['msg'] .= "</td>";
            }
         }

         if (trim($data['scriptid']) <> "" && $submit!="Export to Excel") {
            $data['msg'] .= <<<EOT
<p></p>
<a class="legend" href="lookup.php?id=$data[scriptid]">
<img alt="Info" src="images/info.png" title="More info..." border=0>
</a>&nbsp;
EOT;
            if ($enableNotes) {
               $data['msg'] .= <<<EOT
<a class="legend" href="notes.php?op=add&amp;pid=$data[scriptid]">
<img alt="Note" src="images/note.png" title="Add note" border=0>
</a>&nbsp;
EOT;
            }
         }    
         if($enableFP && $submit!="Export to Excel") {
            if ($data['falsepositive']=="Y") {
               $data['msg'] .= <<<EOT
<B>This result is false positive </B>
<a class="legend" href="search.php?severity=$data[severity]&amp;hostname=$data[ip]&amp;service=$data[service]&amp;description=$data[description]&amp;nfp=$data[resid]">
<img alt="Clear false positive" src="images/false.png" title="Clear false 
positive" border=0></A>
EOT;

            } else {
               $data['msg'] .= <<<EOT
<a href="search.php?severity=$data[severity]&amp;hostname=$data[ip]&amp;
service=$data[service]&amp;description=$data[description]&amp;fp=$data[resid]">
<img alt="Mark as false positive" src="images/true.png" title="Mark as 
false positive" border=0></A>
EOT;

            }
         }
         //echo "<td width=\"70%\">$data['msg']";
         echo "<td>" . $data['msg']."</td></tr>";
         $oldscantime = $data['scantime'];
      }
      echo "</table>";
   }
}
if($submit!="Export to Excel") {
   require_once('footer.php');
}
/* not sure what this is for
global $index;
$index = 1;
*/

?>
