<?php

$pageTitle = "Top 10 Hosts";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

$logh->log("$username : " . $_SERVER['PHP_SELF']  . 
           " : Page accessed", PEAR_LOG_DEBUG);

echo "<h2><i>Top 10 Hosts</i></h2>";
echo "Sorted by Nessus Risk<hr>";

// set up the user restrictions based on rights
$whereclause_user = " and username = '$username'";
if($uroles['admin'] || $uroles['reports']) {
   $whereclause_user = "";
}

// array of possible date ranges
$allRanges = array( "all" => "All Time",
                    "7" => "Last 7 Days",
                    "14" => "Last 14 Days",
                    "30" => "Last 30 Days",
                    "60" => "Last 60 Days",
                    "90" => "Last 90 Days",
                    "180" => "Last 180 Days",
                    "365" => "Last Year"
                  );

$getParams = array( 'daterange' );
foreach ($getParams as $gp) {
   if (isset($_GET[$gp])) { 
      if(get_magic_quotes_gpc()) {
         $$gp = stripslashes(trim($_GET[$gp]));
      } else {
         $$gp = $_GET[$gp];
      }
      $$gp = mysql_real_escape_string($$gp);
      $$gp = htmlspecialchars( $$gp , ENT_QUOTES);
   } else { 
      $$gp=""; 
   }
}

// generate the necessary SQL to limit results based on daterange
if(is_numeric($daterange)) {
   $dsql = "and TO_DAYS(NOW()) - TO_DAYS(scantime) < $daterange";
} else {
   $dsql = "";
}
/*
switch($daterange) {
   case "7d":
      $dsql = "and TO_DAYS(NOW()) - TO_DAYS(scantime) < 7";
      break;
   case "2w":
      $dsql = "and TO_DAYS(NOW()) - TO_DAYS(scantime) < 14";
      break;
   case "1m":
      $dsql = "and TO_DAYS(NOW()) - TO_DAYS(scantime) < 30";
      break;
   case "2m":
      $dsql = "and TO_DAYS(NOW()) - TO_DAYS(scantime) < 60";
      break;
   case "3m":
      $dsql = "and TO_DAYS(NOW()) - TO_DAYS(scantime) < 90";
      break;
   case "6m":
      $dsql = "and TO_DAYS(NOW()) - TO_DAYS(scantime) < 180";
      break;
   case "1y":
      $dsql = "and TO_DAYS(NOW()) - TO_DAYS(scantime) < 365";
      break;
   case "all":
   default:
      $dsql = "";
      break;
}
*/

// draw the pulldown for the date ranges
echo "<form name='drange' action='" . $_SERVER['PHP_SELF'] . "' method='GET'>";
echo "<select name='daterange' onChange='drange.submit();'>";

foreach($allRanges as $key=>$desc) {
   $sel = "";
   if($daterange == $key) { $sel = "selected"; }
   echo "<option value='$key' $sel>$desc</option>\n";
}

echo "</select></form>";

// get the risks
$query = "select distinct risk 
          from nessus_results 
          where scriptid <> '' $whereclause_user 
             and falsepositive<>'Y' and msg<>'' 
             and scriptid <>10180 
             $dsql
          order by risk";
$result=$dbconn->GetArray($query);

$query1="select count(t1.scriptid) as vcount, t1.host as ip, t2.hostname  
         from nessus_results as t1 
         left join hosts as t2 on t1.host = t2.ip
         where t1.scriptid <> '' 
               and t1.risk = ? 
               $whereclause_user 
               and t1.falsepositive<>'Y' 
               and t1.scriptid <>10180  
               $dsql

         group by t1.host 
         order by vcount desc 
         limit 0,10";
$stmt = $dbconn->Prepare($query1);
//echo "<pre>$query1</pre>";

foreach ($result as $data) {
    $risktext = getrisk($data['risk']);

    echo "<br><b><u>$risktext</u></b><br>";

    echo "<table summary=\"$risktext\">
          <tr><td>ID</td><td>Name</td><td>Count</td></tr>";
    $result1=$dbconn->GetArray($stmt, array($data['risk']));
    if($result1 === fales) {
       $errMsg[] = "SQL Error: " . $dbconn->ErrorMsg();
       dispSQLError($errMsg,1);
    }

    foreach($result1 as $host) {
        echo "<tr><td>" . $host['hostname'] . "</td>
              <td>" . $host['ip'] . "</td>
              <td>" . $host['vcount'] . "</td></tr>";

    }
    echo "</table>";

} //End of while

require_once('footer.php');

?>
